"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = exports.generateQueryString = void 0;
const Formatter = __importStar(require("@himenon/openapi-parameter-formatter"));
const generateQueryString = (queryParameters) => {
    if (!queryParameters) {
        return undefined;
    }
    const queries = Object.entries(queryParameters).reduce((queryStringList, [key, item]) => {
        if (!item.value) {
            return queryStringList;
        }
        if (!item.style) {
            return queryStringList.concat(`${key}=${item.value}`);
        }
        const result = Formatter.QueryParameter.generate(key, item);
        if (result) {
            return queryStringList.concat(result);
        }
        return queryStringList;
    }, []);
    return queries.join("&");
};
exports.generateQueryString = generateQueryString;
const create = (accessToken) => {
    const apiClientImpl = {
        request: async (httpMethod, url, headers, requestBody, queryParameters) => {
            const query = (0, exports.generateQueryString)(queryParameters);
            const requestUrl = query ? url + "?" + encodeURI(query) : url;
            const requestHeaders = {
                ...headers,
                Authorization: "token " + accessToken,
            };
            const response = await fetch(requestUrl, {
                body: JSON.stringify(requestBody),
                headers: requestHeaders,
                method: httpMethod,
            });
            return await response.json();
        },
    };
    return apiClientImpl;
};
exports.create = create;
