import { GitHub } from "./GitHub";
import * as ApiClientImpl from "./ApiClientImpl";
import { Client } from "./api";
export * from "./types";
export { GitHub, Client };
export const create = (args) => {
    const baseUrl = args.baseUrl || "https://api.github.com";
    const apiClientImpl = ApiClientImpl.create(args.accessToken);
    const client = new Client(apiClientImpl, baseUrl);
    const github = new GitHub(client, args.owner, args.repo);
    return github;
};
export default create;
