//
// Generated by @himenon/openapi-typescript-code-generator v0.16.0
//
// OpenApi : 3.0.3
//
// License  : MIT
// Url      : https://spdx.org/licenses/MIT
//
export class Client {
    constructor(apiClient, baseUrl) {
        this.apiClient = apiClient;
        this.baseUrl = baseUrl.replace(/\/$/, "");
    }
    /**
     * GitHub API Root
     * Get Hypermedia links to resources accessible in GitHub's REST API
     * operationId: meta/root
     * Request URI: /
     */
    async meta$root(option) {
        const url = this.baseUrl + `/`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List global webhooks
     * operationId: enterprise-admin/list-global-webhooks
     * Request URI: /admin/hooks
     */
    async enterprise$admin$list$global$webhooks(params, option) {
        const url = this.baseUrl + `/admin/hooks`;
        const headers = {
            Accept: "application/json",
            accept: params.parameter.accept,
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a global webhook
     * operationId: enterprise-admin/create-global-webhook
     * Request URI: /admin/hooks
     */
    async enterprise$admin$create$global$webhook(params, option) {
        const url = this.baseUrl + `/admin/hooks`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a global webhook
     * operationId: enterprise-admin/get-global-webhook
     * Request URI: /admin/hooks/{hook_id}
     */
    async enterprise$admin$get$global$webhook(params, option) {
        const url = this.baseUrl + `/admin/hooks/${params.parameter.hook_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a global webhook
     * operationId: enterprise-admin/delete-global-webhook
     * Request URI: /admin/hooks/{hook_id}
     */
    async enterprise$admin$delete$global$webhook(params, option) {
        const url = this.baseUrl + `/admin/hooks/${params.parameter.hook_id}`;
        const headers = {
            accept: params.parameter.accept,
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a global webhook
     * Parameters that are not provided will be overwritten with the default value or removed if no default exists.
     * operationId: enterprise-admin/update-global-webhook
     * Request URI: /admin/hooks/{hook_id}
     */
    async enterprise$admin$update$global$webhook(params, option) {
        const url = this.baseUrl + `/admin/hooks/${params.parameter.hook_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Ping a global webhook
     * This will trigger a [ping event](https://docs.github.com/enterprise-server@3.4/webhooks/#ping-event) to be sent to the webhook.
     * operationId: enterprise-admin/ping-global-webhook
     * Request URI: /admin/hooks/{hook_id}/pings
     */
    async enterprise$admin$ping$global$webhook(params, option) {
        const url = this.baseUrl + `/admin/hooks/${params.parameter.hook_id}/pings`;
        const headers = {
            accept: params.parameter.accept,
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * List public keys
     * operationId: enterprise-admin/list-public-keys
     * Request URI: /admin/keys
     */
    async enterprise$admin$list$public$keys(params, option) {
        const url = this.baseUrl + `/admin/keys`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            since: { value: params.parameter.since, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Delete a public key
     * operationId: enterprise-admin/delete-public-key
     * Request URI: /admin/keys/{key_ids}
     */
    async enterprise$admin$delete$public$key(params, option) {
        const url = this.baseUrl + `/admin/keys/${params.parameter.key_ids}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update LDAP mapping for a team
     * Updates the [distinguished name](https://www.ldap.com/ldap-dns-and-rdns) (DN) of the LDAP entry to map to a team. [LDAP synchronization](https://docs.github.com/enterprise/admin/guides/user-management/using-ldap/#enabling-ldap-sync) must be enabled to map LDAP entries to a team. Use the [Create a team](https://docs.github.com/enterprise-server@3.4/rest/reference/teams/#create-a-team) endpoint to create a team with LDAP mapping.
     * operationId: enterprise-admin/update-ldap-mapping-for-team
     * Request URI: /admin/ldap/teams/{team_id}/mapping
     */
    async enterprise$admin$update$ldap$mapping$for$team(params, option) {
        const url = this.baseUrl + `/admin/ldap/teams/${params.parameter.team_id}/mapping`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Sync LDAP mapping for a team
     * Note that this API call does not automatically initiate an LDAP sync. Rather, if a `201` is returned, the sync job is queued successfully, and is performed when the instance is ready.
     * operationId: enterprise-admin/sync-ldap-mapping-for-team
     * Request URI: /admin/ldap/teams/{team_id}/sync
     */
    async enterprise$admin$sync$ldap$mapping$for$team(params, option) {
        const url = this.baseUrl + `/admin/ldap/teams/${params.parameter.team_id}/sync`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Update LDAP mapping for a user
     * operationId: enterprise-admin/update-ldap-mapping-for-user
     * Request URI: /admin/ldap/users/{username}/mapping
     */
    async enterprise$admin$update$ldap$mapping$for$user(params, option) {
        const url = this.baseUrl + `/admin/ldap/users/${params.parameter.username}/mapping`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Sync LDAP mapping for a user
     * Note that this API call does not automatically initiate an LDAP sync. Rather, if a `201` is returned, the sync job is queued successfully, and is performed when the instance is ready.
     * operationId: enterprise-admin/sync-ldap-mapping-for-user
     * Request URI: /admin/ldap/users/{username}/sync
     */
    async enterprise$admin$sync$ldap$mapping$for$user(params, option) {
        const url = this.baseUrl + `/admin/ldap/users/${params.parameter.username}/sync`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Create an organization
     * operationId: enterprise-admin/create-org
     * Request URI: /admin/organizations
     */
    async enterprise$admin$create$org(params, option) {
        const url = this.baseUrl + `/admin/organizations`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Update an organization name
     * operationId: enterprise-admin/update-org-name
     * Request URI: /admin/organizations/{org}
     */
    async enterprise$admin$update$org$name(params, option) {
        const url = this.baseUrl + `/admin/organizations/${params.parameter.org}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List pre-receive environments
     * operationId: enterprise-admin/list-pre-receive-environments
     * Request URI: /admin/pre-receive-environments
     */
    async enterprise$admin$list$pre$receive$environments(params, option) {
        const url = this.baseUrl + `/admin/pre-receive-environments`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            sort: { value: params.parameter.sort, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a pre-receive environment
     * operationId: enterprise-admin/create-pre-receive-environment
     * Request URI: /admin/pre-receive-environments
     */
    async enterprise$admin$create$pre$receive$environment(params, option) {
        const url = this.baseUrl + `/admin/pre-receive-environments`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a pre-receive environment
     * operationId: enterprise-admin/get-pre-receive-environment
     * Request URI: /admin/pre-receive-environments/{pre_receive_environment_id}
     */
    async enterprise$admin$get$pre$receive$environment(params, option) {
        const url = this.baseUrl + `/admin/pre-receive-environments/${params.parameter.pre_receive_environment_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a pre-receive environment
     * If you attempt to delete an environment that cannot be deleted, you will receive a `422 Unprocessable Entity` response.
     *
     * The possible error messages are:
     *
     * *   _Cannot modify or delete the default environment_
     * *   _Cannot delete environment that has hooks_
     * *   _Cannot delete environment when download is in progress_
     * operationId: enterprise-admin/delete-pre-receive-environment
     * Request URI: /admin/pre-receive-environments/{pre_receive_environment_id}
     */
    async enterprise$admin$delete$pre$receive$environment(params, option) {
        const url = this.baseUrl + `/admin/pre-receive-environments/${params.parameter.pre_receive_environment_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a pre-receive environment
     * You cannot modify the default environment. If you attempt to modify the default environment, you will receive a `422 Unprocessable Entity` response.
     * operationId: enterprise-admin/update-pre-receive-environment
     * Request URI: /admin/pre-receive-environments/{pre_receive_environment_id}
     */
    async enterprise$admin$update$pre$receive$environment(params, option) {
        const url = this.baseUrl + `/admin/pre-receive-environments/${params.parameter.pre_receive_environment_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Start a pre-receive environment download
     * Triggers a new download of the environment tarball from the environment's `image_url`. When the download is finished, the newly downloaded tarball will overwrite the existing environment.
     *
     * If a download cannot be triggered, you will receive a `422 Unprocessable Entity` response.
     *
     * The possible error messages are:
     *
     * * _Cannot modify or delete the default environment_
     * * _Can not start a new download when a download is in progress_
     * operationId: enterprise-admin/start-pre-receive-environment-download
     * Request URI: /admin/pre-receive-environments/{pre_receive_environment_id}/downloads
     */
    async enterprise$admin$start$pre$receive$environment$download(params, option) {
        const url = this.baseUrl + `/admin/pre-receive-environments/${params.parameter.pre_receive_environment_id}/downloads`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Get the download status for a pre-receive environment
     * In addition to seeing the download status at the "[Get a pre-receive environment](#get-a-pre-receive-environment)" endpoint, there is also this separate endpoint for just the download status.
     * operationId: enterprise-admin/get-download-status-for-pre-receive-environment
     * Request URI: /admin/pre-receive-environments/{pre_receive_environment_id}/downloads/latest
     */
    async enterprise$admin$get$download$status$for$pre$receive$environment(params, option) {
        const url = this.baseUrl + `/admin/pre-receive-environments/${params.parameter.pre_receive_environment_id}/downloads/latest`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List pre-receive hooks
     * operationId: enterprise-admin/list-pre-receive-hooks
     * Request URI: /admin/pre-receive-hooks
     */
    async enterprise$admin$list$pre$receive$hooks(params, option) {
        const url = this.baseUrl + `/admin/pre-receive-hooks`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            sort: { value: params.parameter.sort, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a pre-receive hook
     * operationId: enterprise-admin/create-pre-receive-hook
     * Request URI: /admin/pre-receive-hooks
     */
    async enterprise$admin$create$pre$receive$hook(params, option) {
        const url = this.baseUrl + `/admin/pre-receive-hooks`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a pre-receive hook
     * operationId: enterprise-admin/get-pre-receive-hook
     * Request URI: /admin/pre-receive-hooks/{pre_receive_hook_id}
     */
    async enterprise$admin$get$pre$receive$hook(params, option) {
        const url = this.baseUrl + `/admin/pre-receive-hooks/${params.parameter.pre_receive_hook_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a pre-receive hook
     * operationId: enterprise-admin/delete-pre-receive-hook
     * Request URI: /admin/pre-receive-hooks/{pre_receive_hook_id}
     */
    async enterprise$admin$delete$pre$receive$hook(params, option) {
        const url = this.baseUrl + `/admin/pre-receive-hooks/${params.parameter.pre_receive_hook_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a pre-receive hook
     * operationId: enterprise-admin/update-pre-receive-hook
     * Request URI: /admin/pre-receive-hooks/{pre_receive_hook_id}
     */
    async enterprise$admin$update$pre$receive$hook(params, option) {
        const url = this.baseUrl + `/admin/pre-receive-hooks/${params.parameter.pre_receive_hook_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List personal access tokens
     * Lists personal access tokens for all users, including admin users.
     * operationId: enterprise-admin/list-personal-access-tokens
     * Request URI: /admin/tokens
     */
    async enterprise$admin$list$personal$access$tokens(params, option) {
        const url = this.baseUrl + `/admin/tokens`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Delete a personal access token
     * Deletes a personal access token. Returns a `403 - Forbidden` status when a personal access token is in use. For example, if you access this endpoint with the same personal access token that you are trying to delete, you will receive this error.
     * operationId: enterprise-admin/delete-personal-access-token
     * Request URI: /admin/tokens/{token_id}
     */
    async enterprise$admin$delete$personal$access$token(params, option) {
        const url = this.baseUrl + `/admin/tokens/${params.parameter.token_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Create a user
     * If an external authentication mechanism is used, the login name should match the login name in the external system. If you are using LDAP authentication, you should also [update the LDAP mapping](https://docs.github.com/enterprise-server@3.4/rest/reference/enterprise-admin#update-ldap-mapping-for-a-user) for the user.
     *
     * The login name will be normalized to only contain alphanumeric characters or single hyphens. For example, if you send `"octo_cat"` as the login, a user named `"octo-cat"` will be created.
     *
     * If the login name or email address is already associated with an account, the server will return a `422` response.
     * operationId: enterprise-admin/create-user
     * Request URI: /admin/users
     */
    async enterprise$admin$create$user(params, option) {
        const url = this.baseUrl + `/admin/users`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete a user
     * Deleting a user will delete all their repositories, gists, applications, and personal settings. [Suspending a user](https://docs.github.com/enterprise-server@3.4/rest/reference/enterprise-admin#suspend-a-user) is often a better option.
     *
     * You can delete any user account except your own.
     * operationId: enterprise-admin/delete-user
     * Request URI: /admin/users/{username}
     */
    async enterprise$admin$delete$user(params, option) {
        const url = this.baseUrl + `/admin/users/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update the username for a user
     * operationId: enterprise-admin/update-username-for-user
     * Request URI: /admin/users/{username}
     */
    async enterprise$admin$update$username$for$user(params, option) {
        const url = this.baseUrl + `/admin/users/${params.parameter.username}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Create an impersonation OAuth token
     * operationId: enterprise-admin/create-impersonation-o-auth-token
     * Request URI: /admin/users/{username}/authorizations
     */
    async enterprise$admin$create$impersonation$o$auth$token(params, option) {
        const url = this.baseUrl + `/admin/users/${params.parameter.username}/authorizations`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete an impersonation OAuth token
     * operationId: enterprise-admin/delete-impersonation-o-auth-token
     * Request URI: /admin/users/{username}/authorizations
     */
    async enterprise$admin$delete$impersonation$o$auth$token(params, option) {
        const url = this.baseUrl + `/admin/users/${params.parameter.username}/authorizations`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get the authenticated app
     * Returns the GitHub App associated with the authentication credentials used. To see how many app installations are associated with this GitHub App, see the `installations_count` in the response. For more details about your app's installations, see the "[List installations for the authenticated app](https://docs.github.com/enterprise-server@3.4/rest/reference/apps#list-installations-for-the-authenticated-app)" endpoint.
     *
     * You must use a [JWT](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     * operationId: apps/get-authenticated
     * Request URI: /app
     */
    async apps$get$authenticated(option) {
        const url = this.baseUrl + `/app`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create a GitHub App from a manifest
     * Use this endpoint to complete the handshake necessary when implementing the [GitHub App Manifest flow](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/creating-github-apps-from-a-manifest/). When you create a GitHub App with the manifest flow, you receive a temporary `code` used to retrieve the GitHub App's `id`, `pem` (private key), and `webhook_secret`.
     * operationId: apps/create-from-manifest
     * Request URI: /app-manifests/{code}/conversions
     */
    async apps$create$from$manifest(params, option) {
        const url = this.baseUrl + `/app-manifests/${params.parameter.code}/conversions`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a webhook configuration for an app
     * Returns the webhook configuration for a GitHub App. For more information about configuring a webhook for your app, see "[Creating a GitHub App](/developers/apps/creating-a-github-app)."
     *
     * You must use a [JWT](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     * operationId: apps/get-webhook-config-for-app
     * Request URI: /app/hook/config
     */
    async apps$get$webhook$config$for$app(option) {
        const url = this.baseUrl + `/app/hook/config`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update a webhook configuration for an app
     * Updates the webhook configuration for a GitHub App. For more information about configuring a webhook for your app, see "[Creating a GitHub App](/developers/apps/creating-a-github-app)."
     *
     * You must use a [JWT](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     * operationId: apps/update-webhook-config-for-app
     * Request URI: /app/hook/config
     */
    async apps$update$webhook$config$for$app(params, option) {
        const url = this.baseUrl + `/app/hook/config`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List deliveries for an app webhook
     * Returns a list of webhook deliveries for the webhook configured for a GitHub App.
     *
     * You must use a [JWT](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     * operationId: apps/list-webhook-deliveries
     * Request URI: /app/hook/deliveries
     */
    async apps$list$webhook$deliveries(params, option) {
        const url = this.baseUrl + `/app/hook/deliveries`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            cursor: { value: params.parameter.cursor, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a delivery for an app webhook
     * Returns a delivery for the webhook configured for a GitHub App.
     *
     * You must use a [JWT](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     * operationId: apps/get-webhook-delivery
     * Request URI: /app/hook/deliveries/{delivery_id}
     */
    async apps$get$webhook$delivery(params, option) {
        const url = this.baseUrl + `/app/hook/deliveries/${params.parameter.delivery_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Redeliver a delivery for an app webhook
     * Redeliver a delivery for the webhook configured for a GitHub App.
     *
     * You must use a [JWT](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     * operationId: apps/redeliver-webhook-delivery
     * Request URI: /app/hook/deliveries/{delivery_id}/attempts
     */
    async apps$redeliver$webhook$delivery(params, option) {
        const url = this.baseUrl + `/app/hook/deliveries/${params.parameter.delivery_id}/attempts`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * List installations for the authenticated app
     * You must use a [JWT](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     *
     * The permissions the installation has are included under the `permissions` key.
     * operationId: apps/list-installations
     * Request URI: /app/installations
     */
    async apps$list$installations(params, option) {
        const url = this.baseUrl + `/app/installations`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
            since: { value: params.parameter.since, explode: false },
            outdated: { value: params.parameter.outdated, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get an installation for the authenticated app
     * Enables an authenticated GitHub App to find an installation's information using the installation id.
     *
     * You must use a [JWT](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     * operationId: apps/get-installation
     * Request URI: /app/installations/{installation_id}
     */
    async apps$get$installation(params, option) {
        const url = this.baseUrl + `/app/installations/${params.parameter.installation_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete an installation for the authenticated app
     * Uninstalls a GitHub App on a user, organization, or business account. If you prefer to temporarily suspend an app's access to your account's resources, then we recommend the "[Suspend an app installation](https://docs.github.com/enterprise-server@3.4/rest/reference/apps/#suspend-an-app-installation)" endpoint.
     *
     * You must use a [JWT](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     * operationId: apps/delete-installation
     * Request URI: /app/installations/{installation_id}
     */
    async apps$delete$installation(params, option) {
        const url = this.baseUrl + `/app/installations/${params.parameter.installation_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Create an installation access token for an app
     * Creates an installation access token that enables a GitHub App to make authenticated API requests for the app's installation on an organization or individual account. Installation tokens expire one hour from the time you create them. Using an expired token produces a status code of `401 - Unauthorized`, and requires creating a new installation token. By default the installation token has access to all repositories that the installation can access. To restrict the access to specific repositories, you can provide the `repository_ids` when creating the token. When you omit `repository_ids`, the response does not contain the `repositories` key.
     *
     * You must use a [JWT](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     * operationId: apps/create-installation-access-token
     * Request URI: /app/installations/{installation_id}/access_tokens
     */
    async apps$create$installation$access$token(params, option) {
        const url = this.baseUrl + `/app/installations/${params.parameter.installation_id}/access_tokens`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Suspend an app installation
     * Suspends a GitHub App on a user, organization, or business account, which blocks the app from accessing the account's resources. When a GitHub App is suspended, the app's access to the GitHub Enterprise Server API or webhook events is blocked for that account.
     *
     * You must use a [JWT](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     * operationId: apps/suspend-installation
     * Request URI: /app/installations/{installation_id}/suspended
     */
    async apps$suspend$installation(params, option) {
        const url = this.baseUrl + `/app/installations/${params.parameter.installation_id}/suspended`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Unsuspend an app installation
     * Removes a GitHub App installation suspension.
     *
     * You must use a [JWT](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     * operationId: apps/unsuspend-installation
     * Request URI: /app/installations/{installation_id}/suspended
     */
    async apps$unsuspend$installation(params, option) {
        const url = this.baseUrl + `/app/installations/${params.parameter.installation_id}/suspended`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * List your grants
     * **Deprecation Notice:** GitHub Enterprise Server will discontinue the [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations/), which is used by integrations to create personal access tokens and OAuth tokens, and you must now create these tokens using our [web application flow](https://docs.github.com/enterprise-server@3.4/developers/apps/authorizing-oauth-apps#web-application-flow). The [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations) will be removed on November, 13, 2020. For more information, including scheduled brownouts, see the [blog post](https://developer.github.com/changes/2020-02-14-deprecating-oauth-auth-endpoint/).
     *
     * You can use this API to list the set of OAuth applications that have been granted access to your account. Unlike the [list your authorizations](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations#list-your-authorizations) API, this API does not manage individual tokens. This API will return one entry for each OAuth application that has been granted access to your account, regardless of the number of tokens an application has generated for your user. The list of OAuth applications returned matches what is shown on [the application authorizations settings screen within GitHub](https://github.com/settings/applications#authorized). The `scopes` returned are the union of scopes authorized for the application. For example, if an application has one token with `repo` scope and another token with `user` scope, the grant will return `["repo", "user"]`.
     * operationId: oauth-authorizations/list-grants
     * Request URI: /applications/grants
     */
    async oauth$authorizations$list$grants(params, option) {
        const url = this.baseUrl + `/applications/grants`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
            client_id: { value: params.parameter.client_id, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * @deprecated
     * Get a single grant
     * **Deprecation Notice:** GitHub Enterprise Server will discontinue the [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations), which is used by integrations to create personal access tokens and OAuth tokens, and you must now create these tokens using our [web application flow](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/authorizing-oauth-apps/#web-application-flow). The [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations) will be removed on November, 13, 2020. For more information, including scheduled brownouts, see the [blog post](https://developer.github.com/changes/2020-02-14-deprecating-oauth-auth-endpoint/).
     * operationId: oauth-authorizations/get-grant
     * Request URI: /applications/grants/{grant_id}
     */
    async oauth$authorizations$get$grant(params, option) {
        const url = this.baseUrl + `/applications/grants/${params.parameter.grant_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Delete a grant
     * **Deprecation Notice:** GitHub Enterprise Server will discontinue the [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations/), which is used by integrations to create personal access tokens and OAuth tokens, and you must now create these tokens using our [web application flow](https://docs.github.com/enterprise-server@3.4/developers/apps/authorizing-oauth-apps#web-application-flow). The [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations/) will be removed on November, 13, 2020. For more information, including scheduled brownouts, see the [blog post](https://developer.github.com/changes/2020-02-14-deprecating-oauth-auth-endpoint/).
     *
     * Deleting an OAuth application's grant will also delete all OAuth tokens associated with the application for your user. Once deleted, the application has no access to your account and is no longer listed on [the application authorizations settings screen within GitHub](https://github.com/settings/applications#authorized).
     * operationId: oauth-authorizations/delete-grant
     * Request URI: /applications/grants/{grant_id}
     */
    async oauth$authorizations$delete$grant(params, option) {
        const url = this.baseUrl + `/applications/grants/${params.parameter.grant_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Delete an app authorization
     * OAuth application owners can revoke a grant for their OAuth application and a specific user. You must use [Basic Authentication](https://docs.github.com/enterprise-server@3.4/rest/overview/other-authentication-methods#basic-authentication) when accessing this endpoint, using the OAuth application's `client_id` and `client_secret` as the username and password. You must also provide a valid OAuth `access_token` as an input parameter and the grant for the token's owner will be deleted.
     * Deleting an OAuth application's grant will also delete all OAuth tokens associated with the application for the user. Once deleted, the application will have no access to the user's account and will no longer be listed on [the application authorizations settings screen within GitHub](https://github.com/settings/applications#authorized).
     * operationId: apps/delete-authorization
     * Request URI: /applications/{client_id}/grant
     */
    async apps$delete$authorization(params, option) {
        const url = this.baseUrl + `/applications/${params.parameter.client_id}/grant`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Check a token
     * OAuth applications can use a special API method for checking OAuth token validity without exceeding the normal rate limits for failed login attempts. Authentication works differently with this particular endpoint. You must use [Basic Authentication](https://docs.github.com/enterprise-server@3.4/rest/overview/other-authentication-methods#basic-authentication) to use this endpoint, where the username is the OAuth application `client_id` and the password is its `client_secret`. Invalid tokens will return `404 NOT FOUND`.
     * operationId: apps/check-token
     * Request URI: /applications/{client_id}/token
     */
    async apps$check$token(params, option) {
        const url = this.baseUrl + `/applications/${params.parameter.client_id}/token`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete an app token
     * OAuth application owners can revoke a single token for an OAuth application. You must use [Basic Authentication](https://docs.github.com/enterprise-server@3.4/rest/overview/other-authentication-methods#basic-authentication) when accessing this endpoint, using the OAuth application's `client_id` and `client_secret` as the username and password.
     * operationId: apps/delete-token
     * Request URI: /applications/{client_id}/token
     */
    async apps$delete$token(params, option) {
        const url = this.baseUrl + `/applications/${params.parameter.client_id}/token`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Reset a token
     * OAuth applications can use this API method to reset a valid OAuth token without end-user involvement. Applications must save the "token" property in the response because changes take effect immediately. You must use [Basic Authentication](https://docs.github.com/enterprise-server@3.4/rest/overview/other-authentication-methods#basic-authentication) when accessing this endpoint, using the OAuth application's `client_id` and `client_secret` as the username and password. Invalid tokens will return `404 NOT FOUND`.
     * operationId: apps/reset-token
     * Request URI: /applications/{client_id}/token
     */
    async apps$reset$token(params, option) {
        const url = this.baseUrl + `/applications/${params.parameter.client_id}/token`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Create a scoped access token
     * Use a non-scoped user-to-server OAuth access token to create a repository scoped and/or permission scoped user-to-server OAuth access token. You can specify which repositories the token can access and which permissions are granted to the token. You must use [Basic Authentication](https://docs.github.com/enterprise-server@3.4/rest/overview/other-authentication-methods#basic-authentication) when accessing this endpoint, using the OAuth application's `client_id` and `client_secret` as the username and password. Invalid tokens will return `404 NOT FOUND`.
     * operationId: apps/scope-token
     * Request URI: /applications/{client_id}/token/scoped
     */
    async apps$scope$token(params, option) {
        const url = this.baseUrl + `/applications/${params.parameter.client_id}/token/scoped`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get an app
     * **Note**: The `:app_slug` is just the URL-friendly name of your GitHub App. You can find this on the settings page for your GitHub App (e.g., `https://github.com/settings/apps/:app_slug`).
     *
     * If the GitHub App you specify is public, you can access this endpoint without authenticating. If the GitHub App you specify is private, you must authenticate with a [personal access token](https://docs.github.com/articles/creating-a-personal-access-token-for-the-command-line/) or an [installation access token](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-an-installation) to access this endpoint.
     * operationId: apps/get-by-slug
     * Request URI: /apps/{app_slug}
     */
    async apps$get$by$slug(params, option) {
        const url = this.baseUrl + `/apps/${params.parameter.app_slug}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * List your authorizations
     * **Deprecation Notice:** GitHub Enterprise Server will discontinue the [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations), which is used by integrations to create personal access tokens and OAuth tokens, and you must now create these tokens using our [web application flow](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/authorizing-oauth-apps/#web-application-flow). The [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations) will be removed on November, 13, 2020. For more information, including scheduled brownouts, see the [blog post](https://developer.github.com/changes/2020-02-14-deprecating-oauth-auth-endpoint/).
     * operationId: oauth-authorizations/list-authorizations
     * Request URI: /authorizations
     */
    async oauth$authorizations$list$authorizations(params, option) {
        const url = this.baseUrl + `/authorizations`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
            client_id: { value: params.parameter.client_id, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * @deprecated
     * Create a new authorization
     * **Deprecation Notice:** GitHub Enterprise Server will discontinue the [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations), which is used by integrations to create personal access tokens and OAuth tokens, and you must now create these tokens using our [web application flow](https://docs.github.com/enterprise-server@3.4/developers/apps/authorizing-oauth-apps#web-application-flow). The [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations) will be removed on November, 13, 2020. For more information, including scheduled brownouts, see the [blog post](https://developer.github.com/changes/2020-02-14-deprecating-oauth-auth-endpoint/).
     *
     * **Warning:** Apps must use the [web application flow](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/authorizing-oauth-apps/#web-application-flow) to obtain OAuth tokens that work with GitHub Enterprise Server SAML organizations. OAuth tokens created using the Authorizations API will be unable to access GitHub Enterprise Server SAML organizations. For more information, see the [blog post](https://developer.github.com/changes/2019-11-05-deprecated-passwords-and-authorizations-api).
     *
     * Creates OAuth tokens using [Basic Authentication](https://docs.github.com/enterprise-server@3.4/rest/overview/other-authentication-methods#basic-authentication). If you have two-factor authentication setup, Basic Authentication for this endpoint requires that you use a one-time password (OTP) and your username and password instead of tokens. For more information, see "[Working with two-factor authentication](https://docs.github.com/enterprise-server@3.4/rest/overview/other-authentication-methods#working-with-two-factor-authentication)."
     *
     * To create tokens for a particular OAuth application using this endpoint, you must authenticate as the user you want to create an authorization for and provide the app's client ID and secret, found on your OAuth application's settings page. If your OAuth application intends to create multiple tokens for one user, use `fingerprint` to differentiate between them.
     *
     * You can also create tokens on GitHub Enterprise Server from the [personal access tokens settings](https://github.com/settings/tokens) page. Read more about these tokens in [the GitHub Help documentation](https://docs.github.com/articles/creating-an-access-token-for-command-line-use).
     *
     * Organizations that enforce SAML SSO require personal access tokens to be allowed. Read more about allowing tokens in [the GitHub Help documentation](https://docs.github.com/articles/about-identity-and-access-management-with-saml-single-sign-on).
     * operationId: oauth-authorizations/create-authorization
     * Request URI: /authorizations
     */
    async oauth$authorizations$create$authorization(params, option) {
        const url = this.baseUrl + `/authorizations`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * @deprecated
     * Get-or-create an authorization for a specific app
     * **Deprecation Notice:** GitHub Enterprise Server will discontinue the [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations/), which is used by integrations to create personal access tokens and OAuth tokens, and you must now create these tokens using our [web application flow](https://docs.github.com/enterprise-server@3.4/developers/apps/authorizing-oauth-apps#web-application-flow). The [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations) will be removed on November, 13, 2020. For more information, including scheduled brownouts, see the [blog post](https://developer.github.com/changes/2020-02-14-deprecating-oauth-auth-endpoint/).
     *
     * **Warning:** Apps must use the [web application flow](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/authorizing-oauth-apps/#web-application-flow) to obtain OAuth tokens that work with GitHub Enterprise Server SAML organizations. OAuth tokens created using the Authorizations API will be unable to access GitHub Enterprise Server SAML organizations. For more information, see the [blog post](https://developer.github.com/changes/2019-11-05-deprecated-passwords-and-authorizations-api).
     *
     * Creates a new authorization for the specified OAuth application, only if an authorization for that application doesn't already exist for the user. The URL includes the 20 character client ID for the OAuth app that is requesting the token. It returns the user's existing authorization for the application if one is present. Otherwise, it creates and returns a new one.
     *
     * If you have two-factor authentication setup, Basic Authentication for this endpoint requires that you use a one-time password (OTP) and your username and password instead of tokens. For more information, see "[Working with two-factor authentication](https://docs.github.com/enterprise-server@3.4/rest/overview/other-authentication-methods#working-with-two-factor-authentication)."
     *
     * **Deprecation Notice:** GitHub Enterprise Server will discontinue the [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations/), which is used by integrations to create personal access tokens and OAuth tokens, and you must now create these tokens using our [web application flow](https://docs.github.com/enterprise-server@3.4/developers/apps/authorizing-oauth-apps#web-application-flow). The [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations) will be removed on November, 13, 2020. For more information, including scheduled brownouts, see the [blog post](https://developer.github.com/changes/2020-02-14-deprecating-oauth-auth-endpoint/).
     * operationId: oauth-authorizations/get-or-create-authorization-for-app
     * Request URI: /authorizations/clients/{client_id}
     */
    async oauth$authorizations$get$or$create$authorization$for$app(params, option) {
        const url = this.baseUrl + `/authorizations/clients/${params.parameter.client_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * @deprecated
     * Get-or-create an authorization for a specific app and fingerprint
     * **Deprecation Notice:** GitHub Enterprise Server will discontinue the [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations/), which is used by integrations to create personal access tokens and OAuth tokens, and you must now create these tokens using our [web application flow](https://docs.github.com/enterprise-server@3.4/developers/apps/authorizing-oauth-apps#web-application-flow). The [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations) will be removed on November, 13, 2020. For more information, including scheduled brownouts, see the [blog post](https://developer.github.com/changes/2020-02-14-deprecating-oauth-auth-endpoint/).
     *
     * **Warning:** Apps must use the [web application flow](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/authorizing-oauth-apps/#web-application-flow) to obtain OAuth tokens that work with GitHub Enterprise Server SAML organizations. OAuth tokens created using the Authorizations API will be unable to access GitHub Enterprise Server SAML organizations. For more information, see the [blog post](https://developer.github.com/changes/2019-11-05-deprecated-passwords-and-authorizations-api).
     *
     * This method will create a new authorization for the specified OAuth application, only if an authorization for that application and fingerprint do not already exist for the user. The URL includes the 20 character client ID for the OAuth app that is requesting the token. `fingerprint` is a unique string to distinguish an authorization from others created for the same client ID and user. It returns the user's existing authorization for the application if one is present. Otherwise, it creates and returns a new one.
     *
     * If you have two-factor authentication setup, Basic Authentication for this endpoint requires that you use a one-time password (OTP) and your username and password instead of tokens. For more information, see "[Working with two-factor authentication](https://docs.github.com/enterprise-server@3.4/rest/overview/other-authentication-methods#working-with-two-factor-authentication)."
     * operationId: oauth-authorizations/get-or-create-authorization-for-app-and-fingerprint
     * Request URI: /authorizations/clients/{client_id}/{fingerprint}
     */
    async oauth$authorizations$get$or$create$authorization$for$app$and$fingerprint(params, option) {
        const url = this.baseUrl + `/authorizations/clients/${params.parameter.client_id}/${params.parameter.fingerprint}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * @deprecated
     * Get a single authorization
     * **Deprecation Notice:** GitHub Enterprise Server will discontinue the [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations), which is used by integrations to create personal access tokens and OAuth tokens, and you must now create these tokens using our [web application flow](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/authorizing-oauth-apps/#web-application-flow). The [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations) will be removed on November, 13, 2020. For more information, including scheduled brownouts, see the [blog post](https://developer.github.com/changes/2020-02-14-deprecating-oauth-auth-endpoint/).
     * operationId: oauth-authorizations/get-authorization
     * Request URI: /authorizations/{authorization_id}
     */
    async oauth$authorizations$get$authorization(params, option) {
        const url = this.baseUrl + `/authorizations/${params.parameter.authorization_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Delete an authorization
     * **Deprecation Notice:** GitHub Enterprise Server will discontinue the [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations), which is used by integrations to create personal access tokens and OAuth tokens, and you must now create these tokens using our [web application flow](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/authorizing-oauth-apps/#web-application-flow). The [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations) will be removed on November, 13, 2020. For more information, including scheduled brownouts, see the [blog post](https://developer.github.com/changes/2020-02-14-deprecating-oauth-auth-endpoint/).
     * operationId: oauth-authorizations/delete-authorization
     * Request URI: /authorizations/{authorization_id}
     */
    async oauth$authorizations$delete$authorization(params, option) {
        const url = this.baseUrl + `/authorizations/${params.parameter.authorization_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Update an existing authorization
     * **Deprecation Notice:** GitHub Enterprise Server will discontinue the [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations/), which is used by integrations to create personal access tokens and OAuth tokens, and you must now create these tokens using our [web application flow](https://docs.github.com/enterprise-server@3.4/developers/apps/authorizing-oauth-apps#web-application-flow). The [OAuth Authorizations API](https://docs.github.com/enterprise-server@3.4/rest/reference/oauth-authorizations) will be removed on November, 13, 2020. For more information, including scheduled brownouts, see the [blog post](https://developer.github.com/changes/2020-02-14-deprecating-oauth-auth-endpoint/).
     *
     * If you have two-factor authentication setup, Basic Authentication for this endpoint requires that you use a one-time password (OTP) and your username and password instead of tokens. For more information, see "[Working with two-factor authentication](https://docs.github.com/enterprise-server@3.4/rest/overview/other-authentication-methods#working-with-two-factor-authentication)."
     *
     * You can only send one of these scope keys at a time.
     * operationId: oauth-authorizations/update-authorization
     * Request URI: /authorizations/{authorization_id}
     */
    async oauth$authorizations$update$authorization(params, option) {
        const url = this.baseUrl + `/authorizations/${params.parameter.authorization_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get all codes of conduct
     * operationId: codes-of-conduct/get-all-codes-of-conduct
     * Request URI: /codes_of_conduct
     */
    async codes$of$conduct$get$all$codes$of$conduct(option) {
        const url = this.baseUrl + `/codes_of_conduct`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get a code of conduct
     * operationId: codes-of-conduct/get-conduct-code
     * Request URI: /codes_of_conduct/{key}
     */
    async codes$of$conduct$get$conduct$code(params, option) {
        const url = this.baseUrl + `/codes_of_conduct/${params.parameter.key}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get emojis
     * Lists all the emojis available to use on GitHub Enterprise Server.
     * operationId: emojis/get
     * Request URI: /emojis
     */
    async emojis$get(option) {
        const url = this.baseUrl + `/emojis`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get the global announcement banner
     * Gets the current message and expiration date of the global announcement banner in your enterprise.
     * operationId: enterprise-admin/get-announcement
     * Request URI: /enterprise/announcement
     */
    async enterprise$admin$get$announcement(option) {
        const url = this.baseUrl + `/enterprise/announcement`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Remove the global announcement banner
     * Removes the global announcement banner in your enterprise.
     * operationId: enterprise-admin/remove-announcement
     * Request URI: /enterprise/announcement
     */
    async enterprise$admin$remove$announcement(option) {
        const url = this.baseUrl + `/enterprise/announcement`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Set the global announcement banner
     * Sets the message and expiration time for the global announcement banner in your enterprise.
     * operationId: enterprise-admin/set-announcement
     * Request URI: /enterprise/announcement
     */
    async enterprise$admin$set$announcement(params, option) {
        const url = this.baseUrl + `/enterprise/announcement`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get license information
     * operationId: enterprise-admin/get-license-information
     * Request URI: /enterprise/settings/license
     */
    async enterprise$admin$get$license$information(option) {
        const url = this.baseUrl + `/enterprise/settings/license`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get all statistics
     * operationId: enterprise-admin/get-all-stats
     * Request URI: /enterprise/stats/all
     */
    async enterprise$admin$get$all$stats(option) {
        const url = this.baseUrl + `/enterprise/stats/all`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get comment statistics
     * operationId: enterprise-admin/get-comment-stats
     * Request URI: /enterprise/stats/comments
     */
    async enterprise$admin$get$comment$stats(option) {
        const url = this.baseUrl + `/enterprise/stats/comments`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get gist statistics
     * operationId: enterprise-admin/get-gist-stats
     * Request URI: /enterprise/stats/gists
     */
    async enterprise$admin$get$gist$stats(option) {
        const url = this.baseUrl + `/enterprise/stats/gists`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get hooks statistics
     * operationId: enterprise-admin/get-hooks-stats
     * Request URI: /enterprise/stats/hooks
     */
    async enterprise$admin$get$hooks$stats(option) {
        const url = this.baseUrl + `/enterprise/stats/hooks`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get issue statistics
     * operationId: enterprise-admin/get-issue-stats
     * Request URI: /enterprise/stats/issues
     */
    async enterprise$admin$get$issue$stats(option) {
        const url = this.baseUrl + `/enterprise/stats/issues`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get milestone statistics
     * operationId: enterprise-admin/get-milestone-stats
     * Request URI: /enterprise/stats/milestones
     */
    async enterprise$admin$get$milestone$stats(option) {
        const url = this.baseUrl + `/enterprise/stats/milestones`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get organization statistics
     * operationId: enterprise-admin/get-org-stats
     * Request URI: /enterprise/stats/orgs
     */
    async enterprise$admin$get$org$stats(option) {
        const url = this.baseUrl + `/enterprise/stats/orgs`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get pages statistics
     * operationId: enterprise-admin/get-pages-stats
     * Request URI: /enterprise/stats/pages
     */
    async enterprise$admin$get$pages$stats(option) {
        const url = this.baseUrl + `/enterprise/stats/pages`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get pull request statistics
     * operationId: enterprise-admin/get-pull-request-stats
     * Request URI: /enterprise/stats/pulls
     */
    async enterprise$admin$get$pull$request$stats(option) {
        const url = this.baseUrl + `/enterprise/stats/pulls`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get repository statistics
     * operationId: enterprise-admin/get-repo-stats
     * Request URI: /enterprise/stats/repos
     */
    async enterprise$admin$get$repo$stats(option) {
        const url = this.baseUrl + `/enterprise/stats/repos`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get users statistics
     * operationId: enterprise-admin/get-user-stats
     * Request URI: /enterprise/stats/users
     */
    async enterprise$admin$get$user$stats(option) {
        const url = this.baseUrl + `/enterprise/stats/users`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get GitHub Actions permissions for an enterprise
     * Gets the GitHub Actions permissions policy for organizations and allowed actions in an enterprise.
     *
     * You must authenticate using an access token with the `admin:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/get-github-actions-permissions-enterprise
     * Request URI: /enterprises/{enterprise}/actions/permissions
     */
    async enterprise$admin$get$github$actions$permissions$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/permissions`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set GitHub Actions permissions for an enterprise
     * Sets the GitHub Actions permissions policy for organizations and allowed actions in an enterprise.
     *
     * You must authenticate using an access token with the `admin:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/set-github-actions-permissions-enterprise
     * Request URI: /enterprises/{enterprise}/actions/permissions
     */
    async enterprise$admin$set$github$actions$permissions$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/permissions`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List selected organizations enabled for GitHub Actions in an enterprise
     * Lists the organizations that are selected to have GitHub Actions enabled in an enterprise. To use this endpoint, the enterprise permission policy for `enabled_organizations` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an enterprise](#set-github-actions-permissions-for-an-enterprise)."
     *
     * You must authenticate using an access token with the `admin:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/list-selected-organizations-enabled-github-actions-enterprise
     * Request URI: /enterprises/{enterprise}/actions/permissions/organizations
     */
    async enterprise$admin$list$selected$organizations$enabled$github$actions$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/permissions/organizations`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Set selected organizations enabled for GitHub Actions in an enterprise
     * Replaces the list of selected organizations that are enabled for GitHub Actions in an enterprise. To use this endpoint, the enterprise permission policy for `enabled_organizations` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an enterprise](#set-github-actions-permissions-for-an-enterprise)."
     *
     * You must authenticate using an access token with the `admin:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/set-selected-organizations-enabled-github-actions-enterprise
     * Request URI: /enterprises/{enterprise}/actions/permissions/organizations
     */
    async enterprise$admin$set$selected$organizations$enabled$github$actions$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/permissions/organizations`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Enable a selected organization for GitHub Actions in an enterprise
     * Adds an organization to the list of selected organizations that are enabled for GitHub Actions in an enterprise. To use this endpoint, the enterprise permission policy for `enabled_organizations` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an enterprise](#set-github-actions-permissions-for-an-enterprise)."
     *
     * You must authenticate using an access token with the `admin:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/enable-selected-organization-github-actions-enterprise
     * Request URI: /enterprises/{enterprise}/actions/permissions/organizations/{org_id}
     */
    async enterprise$admin$enable$selected$organization$github$actions$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/permissions/organizations/${params.parameter.org_id}`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Disable a selected organization for GitHub Actions in an enterprise
     * Removes an organization from the list of selected organizations that are enabled for GitHub Actions in an enterprise. To use this endpoint, the enterprise permission policy for `enabled_organizations` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an enterprise](#set-github-actions-permissions-for-an-enterprise)."
     *
     * You must authenticate using an access token with the `admin:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/disable-selected-organization-github-actions-enterprise
     * Request URI: /enterprises/{enterprise}/actions/permissions/organizations/{org_id}
     */
    async enterprise$admin$disable$selected$organization$github$actions$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/permissions/organizations/${params.parameter.org_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get allowed actions for an enterprise
     * Gets the selected actions that are allowed in an enterprise. To use this endpoint, the enterprise permission policy for `allowed_actions` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an enterprise](#set-github-actions-permissions-for-an-enterprise)."
     *
     * You must authenticate using an access token with the `admin:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/get-allowed-actions-enterprise
     * Request URI: /enterprises/{enterprise}/actions/permissions/selected-actions
     */
    async enterprise$admin$get$allowed$actions$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/permissions/selected-actions`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set allowed actions for an enterprise
     * Sets the actions that are allowed in an enterprise. To use this endpoint, the enterprise permission policy for `allowed_actions` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an enterprise](#set-github-actions-permissions-for-an-enterprise)."
     *
     * You must authenticate using an access token with the `admin:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/set-allowed-actions-enterprise
     * Request URI: /enterprises/{enterprise}/actions/permissions/selected-actions
     */
    async enterprise$admin$set$allowed$actions$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/permissions/selected-actions`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List self-hosted runner groups for an enterprise
     * Lists all self-hosted runner groups for an enterprise.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/list-self-hosted-runner-groups-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runner-groups
     */
    async enterprise$admin$list$self$hosted$runner$groups$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runner-groups`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a self-hosted runner group for an enterprise
     * Creates a new self-hosted runner group for an enterprise.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/create-self-hosted-runner-group-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runner-groups
     */
    async enterprise$admin$create$self$hosted$runner$group$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runner-groups`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a self-hosted runner group for an enterprise
     * Gets a specific self-hosted runner group for an enterprise.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/get-self-hosted-runner-group-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runner-groups/{runner_group_id}
     */
    async enterprise$admin$get$self$hosted$runner$group$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runner-groups/${params.parameter.runner_group_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a self-hosted runner group from an enterprise
     * Deletes a self-hosted runner group for an enterprise.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/delete-self-hosted-runner-group-from-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runner-groups/{runner_group_id}
     */
    async enterprise$admin$delete$self$hosted$runner$group$from$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runner-groups/${params.parameter.runner_group_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a self-hosted runner group for an enterprise
     * Updates the `name` and `visibility` of a self-hosted runner group in an enterprise.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/update-self-hosted-runner-group-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runner-groups/{runner_group_id}
     */
    async enterprise$admin$update$self$hosted$runner$group$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runner-groups/${params.parameter.runner_group_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List organization access to a self-hosted runner group in an enterprise
     * Lists the organizations with access to a self-hosted runner group.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/list-org-access-to-self-hosted-runner-group-in-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runner-groups/{runner_group_id}/organizations
     */
    async enterprise$admin$list$org$access$to$self$hosted$runner$group$in$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runner-groups/${params.parameter.runner_group_id}/organizations`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Set organization access for a self-hosted runner group in an enterprise
     * Replaces the list of organizations that have access to a self-hosted runner configured in an enterprise.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/set-org-access-to-self-hosted-runner-group-in-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runner-groups/{runner_group_id}/organizations
     */
    async enterprise$admin$set$org$access$to$self$hosted$runner$group$in$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runner-groups/${params.parameter.runner_group_id}/organizations`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Add organization access to a self-hosted runner group in an enterprise
     * Adds an organization to the list of selected organizations that can access a self-hosted runner group. The runner group must have `visibility` set to `selected`. For more information, see "[Create a self-hosted runner group for an enterprise](#create-a-self-hosted-runner-group-for-an-enterprise)."
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/add-org-access-to-self-hosted-runner-group-in-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runner-groups/{runner_group_id}/organizations/{org_id}
     */
    async enterprise$admin$add$org$access$to$self$hosted$runner$group$in$enterprise(params, option) {
        const url = this.baseUrl +
            `/enterprises/${params.parameter.enterprise}/actions/runner-groups/${params.parameter.runner_group_id}/organizations/${params.parameter.org_id}`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Remove organization access to a self-hosted runner group in an enterprise
     * Removes an organization from the list of selected organizations that can access a self-hosted runner group. The runner group must have `visibility` set to `selected`. For more information, see "[Create a self-hosted runner group for an enterprise](#create-a-self-hosted-runner-group-for-an-enterprise)."
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/remove-org-access-to-self-hosted-runner-group-in-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runner-groups/{runner_group_id}/organizations/{org_id}
     */
    async enterprise$admin$remove$org$access$to$self$hosted$runner$group$in$enterprise(params, option) {
        const url = this.baseUrl +
            `/enterprises/${params.parameter.enterprise}/actions/runner-groups/${params.parameter.runner_group_id}/organizations/${params.parameter.org_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List self-hosted runners in a group for an enterprise
     * Lists the self-hosted runners that are in a specific enterprise group.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/list-self-hosted-runners-in-group-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runner-groups/{runner_group_id}/runners
     */
    async enterprise$admin$list$self$hosted$runners$in$group$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runner-groups/${params.parameter.runner_group_id}/runners`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Set self-hosted runners in a group for an enterprise
     * Replaces the list of self-hosted runners that are part of an enterprise runner group.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/set-self-hosted-runners-in-group-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runner-groups/{runner_group_id}/runners
     */
    async enterprise$admin$set$self$hosted$runners$in$group$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runner-groups/${params.parameter.runner_group_id}/runners`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Add a self-hosted runner to a group for an enterprise
     * Adds a self-hosted runner to a runner group configured in an enterprise.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise`
     * scope to use this endpoint.
     * operationId: enterprise-admin/add-self-hosted-runner-to-group-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runner-groups/{runner_group_id}/runners/{runner_id}
     */
    async enterprise$admin$add$self$hosted$runner$to$group$for$enterprise(params, option) {
        const url = this.baseUrl +
            `/enterprises/${params.parameter.enterprise}/actions/runner-groups/${params.parameter.runner_group_id}/runners/${params.parameter.runner_id}`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Remove a self-hosted runner from a group for an enterprise
     * Removes a self-hosted runner from a group configured in an enterprise. The runner is then returned to the default group.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/remove-self-hosted-runner-from-group-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runner-groups/{runner_group_id}/runners/{runner_id}
     */
    async enterprise$admin$remove$self$hosted$runner$from$group$for$enterprise(params, option) {
        const url = this.baseUrl +
            `/enterprises/${params.parameter.enterprise}/actions/runner-groups/${params.parameter.runner_group_id}/runners/${params.parameter.runner_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List self-hosted runners for an enterprise
     * Lists all self-hosted runners configured for an enterprise.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/list-self-hosted-runners-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runners
     */
    async enterprise$admin$list$self$hosted$runners$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runners`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List runner applications for an enterprise
     * Lists binaries for the runner application that you can download and run.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/list-runner-applications-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runners/downloads
     */
    async enterprise$admin$list$runner$applications$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runners/downloads`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create a registration token for an enterprise
     * Returns a token that you can pass to the `config` script. The token expires after one hour.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     *
     * #### Example using registration token
     *
     * Configure your self-hosted runner, replacing `TOKEN` with the registration token provided by this endpoint.
     *
     * ```
     * ./config.sh --url https://github.com/enterprises/octo-enterprise --token TOKEN
     * ```
     * operationId: enterprise-admin/create-registration-token-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runners/registration-token
     */
    async enterprise$admin$create$registration$token$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runners/registration-token`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Create a remove token for an enterprise
     * Returns a token that you can pass to the `config` script to remove a self-hosted runner from an enterprise. The token expires after one hour.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     *
     * #### Example using remove token
     *
     * To remove your self-hosted runner from an enterprise, replace `TOKEN` with the remove token provided by this
     * endpoint.
     *
     * ```
     * ./config.sh remove --token TOKEN
     * ```
     * operationId: enterprise-admin/create-remove-token-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runners/remove-token
     */
    async enterprise$admin$create$remove$token$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runners/remove-token`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Get a self-hosted runner for an enterprise
     * Gets a specific self-hosted runner configured in an enterprise.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/get-self-hosted-runner-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runners/{runner_id}
     */
    async enterprise$admin$get$self$hosted$runner$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runners/${params.parameter.runner_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a self-hosted runner from an enterprise
     * Forces the removal of a self-hosted runner from an enterprise. You can use this endpoint to completely remove the runner when the machine you were using no longer exists.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/delete-self-hosted-runner-from-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runners/{runner_id}
     */
    async enterprise$admin$delete$self$hosted$runner$from$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runners/${params.parameter.runner_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List labels for a self-hosted runner for an enterprise
     * Lists all labels for a self-hosted runner configured in an enterprise.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/list-labels-for-self-hosted-runner-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runners/{runner_id}/labels
     */
    async enterprise$admin$list$labels$for$self$hosted$runner$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runners/${params.parameter.runner_id}/labels`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set custom labels for a self-hosted runner for an enterprise
     * Remove all previous custom labels and set the new custom labels for a specific
     * self-hosted runner configured in an enterprise.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/set-custom-labels-for-self-hosted-runner-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runners/{runner_id}/labels
     */
    async enterprise$admin$set$custom$labels$for$self$hosted$runner$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runners/${params.parameter.runner_id}/labels`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Add custom labels to a self-hosted runner for an enterprise
     * Add custom labels to a self-hosted runner configured in an enterprise.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/add-custom-labels-to-self-hosted-runner-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runners/{runner_id}/labels
     */
    async enterprise$admin$add$custom$labels$to$self$hosted$runner$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runners/${params.parameter.runner_id}/labels`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove all custom labels from a self-hosted runner for an enterprise
     * Remove all custom labels from a self-hosted runner configured in an
     * enterprise. Returns the remaining read-only labels from the runner.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/remove-all-custom-labels-from-self-hosted-runner-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runners/{runner_id}/labels
     */
    async enterprise$admin$remove$all$custom$labels$from$self$hosted$runner$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/actions/runners/${params.parameter.runner_id}/labels`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Remove a custom label from a self-hosted runner for an enterprise
     * Remove a custom label from a self-hosted runner configured
     * in an enterprise. Returns the remaining labels from the runner.
     *
     * This endpoint returns a `404 Not Found` status if the custom label is not
     * present on the runner.
     *
     * You must authenticate using an access token with the `manage_runners:enterprise` scope to use this endpoint.
     * operationId: enterprise-admin/remove-custom-label-from-self-hosted-runner-for-enterprise
     * Request URI: /enterprises/{enterprise}/actions/runners/{runner_id}/labels/{name}
     */
    async enterprise$admin$remove$custom$label$from$self$hosted$runner$for$enterprise(params, option) {
        const url = this.baseUrl +
            `/enterprises/${params.parameter.enterprise}/actions/runners/${params.parameter.runner_id}/labels/${params.parameter.name}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get the audit log for an enterprise
     * Gets the audit log for an enterprise. To use this endpoint, you must be an enterprise admin, and you must use an access token with the `admin:enterprise` scope.
     * operationId: enterprise-admin/get-audit-log
     * Request URI: /enterprises/{enterprise}/audit-log
     */
    async enterprise$admin$get$audit$log(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/audit-log`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            phrase: { value: params.parameter.phrase, explode: false },
            include: { value: params.parameter.include, explode: false },
            after: { value: params.parameter.after, explode: false },
            before: { value: params.parameter.before, explode: false },
            order: { value: params.parameter.order, explode: false },
            page: { value: params.parameter.page, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List secret scanning alerts for an enterprise
     * Lists secret scanning alerts for eligible repositories in an enterprise, from newest to oldest.
     * To use this endpoint, you must be a member of the enterprise, and you must use an access token with the `repo` scope or `security_events` scope. Alerts are only returned for organizations in the enterprise for which you are an organization owner or a [security manager](https://docs.github.com/enterprise-server@3.4/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization).
     * operationId: secret-scanning/list-alerts-for-enterprise
     * Request URI: /enterprises/{enterprise}/secret-scanning/alerts
     */
    async secret$scanning$list$alerts$for$enterprise(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/secret-scanning/alerts`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            state: { value: params.parameter.state, explode: false },
            secret_type: { value: params.parameter.secret_type, explode: false },
            resolution: { value: params.parameter.resolution, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            before: { value: params.parameter.before, explode: false },
            after: { value: params.parameter.after, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get GitHub Advanced Security active committers for an enterprise
     * Gets the GitHub Advanced Security active committers for an enterprise per repository.
     * Each distinct user login across all repositories is counted as a single Advanced Security seat, so the total_advanced_security_committers is not the sum of active_users for each repository.
     * operationId: billing/get-github-advanced-security-billing-ghe
     * Request URI: /enterprises/{enterprise}/settings/billing/advanced-security
     */
    async billing$get$github$advanced$security$billing$ghe(params, option) {
        const url = this.baseUrl + `/enterprises/${params.parameter.enterprise}/settings/billing/advanced-security`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List public events
     * We delay the public events feed by five minutes, which means the most recent event returned by the public events API actually occurred at least five minutes ago.
     * operationId: activity/list-public-events
     * Request URI: /events
     */
    async activity$list$public$events(params, option) {
        const url = this.baseUrl + `/events`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get feeds
     * GitHub Enterprise Server provides several timeline resources in [Atom](http://en.wikipedia.org/wiki/Atom_(standard)) format. The Feeds API lists all the feeds available to the authenticated user:
     *
     * *   **Timeline**: The GitHub Enterprise Server global public timeline
     * *   **User**: The public timeline for any user, using [URI template](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#hypermedia)
     * *   **Current user public**: The public timeline for the authenticated user
     * *   **Current user**: The private timeline for the authenticated user
     * *   **Current user actor**: The private timeline for activity created by the authenticated user
     * *   **Current user organizations**: The private timeline for the organizations the authenticated user is a member of.
     * *   **Security advisories**: A collection of public announcements that provide information about security-related vulnerabilities in software on GitHub Enterprise Server.
     *
     * **Note**: Private feeds are only returned when [authenticating via Basic Auth](https://docs.github.com/enterprise-server@3.4/rest/overview/other-authentication-methods#basic-authentication) since current feed URIs use the older, non revocable auth tokens.
     * operationId: activity/get-feeds
     * Request URI: /feeds
     */
    async activity$get$feeds(option) {
        const url = this.baseUrl + `/feeds`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List gists for the authenticated user
     * Lists the authenticated user's gists or if called anonymously, this endpoint returns all public gists:
     * operationId: gists/list
     * Request URI: /gists
     */
    async gists$list(params, option) {
        const url = this.baseUrl + `/gists`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            since: { value: params.parameter.since, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a gist
     * Allows you to add a new gist with one or more files.
     *
     * **Note:** Don't name your files "gistfile" with a numerical suffix. This is the format of the automatic naming scheme that Gist uses internally.
     * operationId: gists/create
     * Request URI: /gists
     */
    async gists$create(params, option) {
        const url = this.baseUrl + `/gists`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List public gists
     * List public gists sorted by most recently updated to least recently updated.
     *
     * Note: With [pagination](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#pagination), you can fetch up to 3000 gists. For example, you can fetch 100 pages with 30 gists per page or 30 pages with 100 gists per page.
     * operationId: gists/list-public
     * Request URI: /gists/public
     */
    async gists$list$public(params, option) {
        const url = this.baseUrl + `/gists/public`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            since: { value: params.parameter.since, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List starred gists
     * List the authenticated user's starred gists:
     * operationId: gists/list-starred
     * Request URI: /gists/starred
     */
    async gists$list$starred(params, option) {
        const url = this.baseUrl + `/gists/starred`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            since: { value: params.parameter.since, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a gist
     * operationId: gists/get
     * Request URI: /gists/{gist_id}
     */
    async gists$get(params, option) {
        const url = this.baseUrl + `/gists/${params.parameter.gist_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a gist
     * operationId: gists/delete
     * Request URI: /gists/{gist_id}
     */
    async gists$delete(params, option) {
        const url = this.baseUrl + `/gists/${params.parameter.gist_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a gist
     * Allows you to update or delete a gist file and rename gist files. Files from the previous version of the gist that aren't explicitly changed during an edit are unchanged.
     * operationId: gists/update
     * Request URI: /gists/{gist_id}
     */
    async gists$update(params, option) {
        const url = this.baseUrl + `/gists/${params.parameter.gist_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List gist comments
     * operationId: gists/list-comments
     * Request URI: /gists/{gist_id}/comments
     */
    async gists$list$comments(params, option) {
        const url = this.baseUrl + `/gists/${params.parameter.gist_id}/comments`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a gist comment
     * operationId: gists/create-comment
     * Request URI: /gists/{gist_id}/comments
     */
    async gists$create$comment(params, option) {
        const url = this.baseUrl + `/gists/${params.parameter.gist_id}/comments`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a gist comment
     * operationId: gists/get-comment
     * Request URI: /gists/{gist_id}/comments/{comment_id}
     */
    async gists$get$comment(params, option) {
        const url = this.baseUrl + `/gists/${params.parameter.gist_id}/comments/${params.parameter.comment_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a gist comment
     * operationId: gists/delete-comment
     * Request URI: /gists/{gist_id}/comments/{comment_id}
     */
    async gists$delete$comment(params, option) {
        const url = this.baseUrl + `/gists/${params.parameter.gist_id}/comments/${params.parameter.comment_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a gist comment
     * operationId: gists/update-comment
     * Request URI: /gists/{gist_id}/comments/{comment_id}
     */
    async gists$update$comment(params, option) {
        const url = this.baseUrl + `/gists/${params.parameter.gist_id}/comments/${params.parameter.comment_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List gist commits
     * operationId: gists/list-commits
     * Request URI: /gists/{gist_id}/commits
     */
    async gists$list$commits(params, option) {
        const url = this.baseUrl + `/gists/${params.parameter.gist_id}/commits`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List gist forks
     * operationId: gists/list-forks
     * Request URI: /gists/{gist_id}/forks
     */
    async gists$list$forks(params, option) {
        const url = this.baseUrl + `/gists/${params.parameter.gist_id}/forks`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Fork a gist
     * **Note**: This was previously `/gists/:gist_id/fork`.
     * operationId: gists/fork
     * Request URI: /gists/{gist_id}/forks
     */
    async gists$fork(params, option) {
        const url = this.baseUrl + `/gists/${params.parameter.gist_id}/forks`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Check if a gist is starred
     * operationId: gists/check-is-starred
     * Request URI: /gists/{gist_id}/star
     */
    async gists$check$is$starred(params, option) {
        const url = this.baseUrl + `/gists/${params.parameter.gist_id}/star`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Star a gist
     * Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#http-verbs)."
     * operationId: gists/star
     * Request URI: /gists/{gist_id}/star
     */
    async gists$star(params, option) {
        const url = this.baseUrl + `/gists/${params.parameter.gist_id}/star`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Unstar a gist
     * operationId: gists/unstar
     * Request URI: /gists/{gist_id}/star
     */
    async gists$unstar(params, option) {
        const url = this.baseUrl + `/gists/${params.parameter.gist_id}/star`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get a gist revision
     * operationId: gists/get-revision
     * Request URI: /gists/{gist_id}/{sha}
     */
    async gists$get$revision(params, option) {
        const url = this.baseUrl + `/gists/${params.parameter.gist_id}/${params.parameter.sha}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get all gitignore templates
     * List all templates available to pass as an option when [creating a repository](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#create-a-repository-for-the-authenticated-user).
     * operationId: gitignore/get-all-templates
     * Request URI: /gitignore/templates
     */
    async gitignore$get$all$templates(option) {
        const url = this.baseUrl + `/gitignore/templates`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get a gitignore template
     * The API also allows fetching the source of a single template.
     * Use the raw [media type](https://docs.github.com/enterprise-server@3.4/rest/overview/media-types/) to get the raw contents.
     * operationId: gitignore/get-template
     * Request URI: /gitignore/templates/{name}
     */
    async gitignore$get$template(params, option) {
        const url = this.baseUrl + `/gitignore/templates/${params.parameter.name}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List repositories accessible to the app installation
     * List repositories that an app installation can access.
     *
     * You must use an [installation access token](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-an-installation) to access this endpoint.
     * operationId: apps/list-repos-accessible-to-installation
     * Request URI: /installation/repositories
     */
    async apps$list$repos$accessible$to$installation(params, option) {
        const url = this.baseUrl + `/installation/repositories`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Revoke an installation access token
     * Revokes the installation token you're using to authenticate as an installation and access this endpoint.
     *
     * Once an installation token is revoked, the token is invalidated and cannot be used. Other endpoints that require the revoked installation token must have a new installation token to work. You can create a new token using the "[Create an installation access token for an app](https://docs.github.com/enterprise-server@3.4/rest/reference/apps#create-an-installation-access-token-for-an-app)" endpoint.
     *
     * You must use an [installation access token](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-an-installation) to access this endpoint.
     * operationId: apps/revoke-installation-access-token
     * Request URI: /installation/token
     */
    async apps$revoke$installation$access$token(option) {
        const url = this.baseUrl + `/installation/token`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List issues assigned to the authenticated user
     * List issues assigned to the authenticated user across all visible repositories including owned repositories, member
     * repositories, and organization repositories. You can use the `filter` query parameter to fetch issues that are not
     * necessarily assigned to you.
     *
     *
     * **Note**: GitHub's REST API v3 considers every pull request an issue, but not every issue is a pull request. For this
     * reason, "Issues" endpoints may return both issues and pull requests in the response. You can identify pull requests by
     * the `pull_request` key. Be aware that the `id` of a pull request returned from "Issues" endpoints will be an _issue id_. To find out the pull
     * request id, use the "[List pull requests](https://docs.github.com/enterprise-server@3.4/rest/reference/pulls#list-pull-requests)" endpoint.
     * operationId: issues/list
     * Request URI: /issues
     */
    async issues$list(params, option) {
        const url = this.baseUrl + `/issues`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filter: { value: params.parameter.filter, explode: false },
            state: { value: params.parameter.state, explode: false },
            labels: { value: params.parameter.labels, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            since: { value: params.parameter.since, explode: false },
            collab: { value: params.parameter.collab, explode: false },
            orgs: { value: params.parameter.orgs, explode: false },
            owned: { value: params.parameter.owned, explode: false },
            pulls: { value: params.parameter.pulls, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get all commonly used licenses
     * operationId: licenses/get-all-commonly-used
     * Request URI: /licenses
     */
    async licenses$get$all$commonly$used(params, option) {
        const url = this.baseUrl + `/licenses`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            featured: { value: params.parameter.featured, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a license
     * operationId: licenses/get
     * Request URI: /licenses/{license}
     */
    async licenses$get(params, option) {
        const url = this.baseUrl + `/licenses/${params.parameter.license}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Render a Markdown document
     * operationId: markdown/render
     * Request URI: /markdown
     */
    async markdown$render(params, option) {
        const url = this.baseUrl + `/markdown`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "text/html",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Render a Markdown document in raw mode
     * You must send Markdown as plain text (using a `Content-Type` header of `text/plain` or `text/x-markdown`) to this endpoint, rather than using JSON format. In raw mode, [GitHub Flavored Markdown](https://github.github.com/gfm/) is not supported and Markdown will be rendered in plain format like a README.md file. Markdown content must be 400 KB or less.
     * operationId: markdown/render-raw
     * Request URI: /markdown/raw
     */
    async markdown$render$raw(params, option) {
        const url = this.baseUrl + `/markdown/raw`;
        const headers = {
            "Content-Type": params.headers["Content-Type"],
            Accept: "text/html",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get GitHub Enterprise Server meta information
     * operationId: meta/get
     * Request URI: /meta
     */
    async meta$get(option) {
        const url = this.baseUrl + `/meta`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List public events for a network of repositories
     * operationId: activity/list-public-events-for-repo-network
     * Request URI: /networks/{owner}/{repo}/events
     */
    async activity$list$public$events$for$repo$network(params, option) {
        const url = this.baseUrl + `/networks/${params.parameter.owner}/${params.parameter.repo}/events`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List notifications for the authenticated user
     * List all notifications for the current user, sorted by most recently updated.
     * operationId: activity/list-notifications-for-authenticated-user
     * Request URI: /notifications
     */
    async activity$list$notifications$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/notifications`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            all: { value: params.parameter.all, explode: false },
            participating: { value: params.parameter.participating, explode: false },
            since: { value: params.parameter.since, explode: false },
            before: { value: params.parameter.before, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Mark notifications as read
     * Marks all notifications as "read" removes it from the [default view on GitHub Enterprise Server](https://github.com/notifications). If the number of notifications is too large to complete in one request, you will receive a `202 Accepted` status and GitHub Enterprise Server will run an asynchronous process to mark notifications as "read." To check whether any "unread" notifications remain, you can use the [List notifications for the authenticated user](https://docs.github.com/enterprise-server@3.4/rest/reference/activity#list-notifications-for-the-authenticated-user) endpoint and pass the query parameter `all=false`.
     * operationId: activity/mark-notifications-as-read
     * Request URI: /notifications
     */
    async activity$mark$notifications$as$read(params, option) {
        const url = this.baseUrl + `/notifications`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a thread
     * operationId: activity/get-thread
     * Request URI: /notifications/threads/{thread_id}
     */
    async activity$get$thread(params, option) {
        const url = this.baseUrl + `/notifications/threads/${params.parameter.thread_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Mark a thread as read
     * operationId: activity/mark-thread-as-read
     * Request URI: /notifications/threads/{thread_id}
     */
    async activity$mark$thread$as$read(params, option) {
        const url = this.baseUrl + `/notifications/threads/${params.parameter.thread_id}`;
        const headers = {};
        return this.apiClient.request("PATCH", url, headers, undefined, undefined, option);
    }
    /**
     * Get a thread subscription for the authenticated user
     * This checks to see if the current user is subscribed to a thread. You can also [get a repository subscription](https://docs.github.com/enterprise-server@3.4/rest/reference/activity#get-a-repository-subscription).
     *
     * Note that subscriptions are only generated if a user is participating in a conversation--for example, they've replied to the thread, were **@mentioned**, or manually subscribe to a thread.
     * operationId: activity/get-thread-subscription-for-authenticated-user
     * Request URI: /notifications/threads/{thread_id}/subscription
     */
    async activity$get$thread$subscription$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/notifications/threads/${params.parameter.thread_id}/subscription`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set a thread subscription
     * If you are watching a repository, you receive notifications for all threads by default. Use this endpoint to ignore future notifications for threads until you comment on the thread or get an **@mention**.
     *
     * You can also use this endpoint to subscribe to threads that you are currently not receiving notifications for or to subscribed to threads that you have previously ignored.
     *
     * Unsubscribing from a conversation in a repository that you are not watching is functionally equivalent to the [Delete a thread subscription](https://docs.github.com/enterprise-server@3.4/rest/reference/activity#delete-a-thread-subscription) endpoint.
     * operationId: activity/set-thread-subscription
     * Request URI: /notifications/threads/{thread_id}/subscription
     */
    async activity$set$thread$subscription(params, option) {
        const url = this.baseUrl + `/notifications/threads/${params.parameter.thread_id}/subscription`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete a thread subscription
     * Mutes all future notifications for a conversation until you comment on the thread or get an **@mention**. If you are watching the repository of the thread, you will still receive notifications. To ignore future notifications for a repository you are watching, use the [Set a thread subscription](https://docs.github.com/enterprise-server@3.4/rest/reference/activity#set-a-thread-subscription) endpoint and set `ignore` to `true`.
     * operationId: activity/delete-thread-subscription
     * Request URI: /notifications/threads/{thread_id}/subscription
     */
    async activity$delete$thread$subscription(params, option) {
        const url = this.baseUrl + `/notifications/threads/${params.parameter.thread_id}/subscription`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get Octocat
     * Get the octocat as ASCII art
     * operationId: meta/get-octocat
     * Request URI: /octocat
     */
    async meta$get$octocat(params, option) {
        const url = this.baseUrl + `/octocat`;
        const headers = {
            Accept: "application/octocat-stream",
        };
        const queryParameters = {
            s: { value: params.parameter.s, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List organizations
     * Lists all organizations, in the order that they were created on GitHub Enterprise Server.
     *
     * **Note:** Pagination is powered exclusively by the `since` parameter. Use the [Link header](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#link-header) to get the URL for the next page of organizations.
     * operationId: orgs/list
     * Request URI: /organizations
     */
    async orgs$list(params, option) {
        const url = this.baseUrl + `/organizations`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            since: { value: params.parameter.since, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List custom repository roles in an organization
     * List the custom repository roles available in this organization. In order to see custom
     * repository roles in an organization, the authenticated user must be an organization owner.
     *
     * For more information on custom repository roles, see "[Managing custom repository roles for an organization](https://docs.github.com/enterprise-server@3.4/organizations/managing-peoples-access-to-your-organization-with-roles/managing-custom-repository-roles-for-an-organization)".
     * operationId: orgs/list-custom-roles
     * Request URI: /organizations/{organization_id}/custom_roles
     */
    async orgs$list$custom$roles(params, option) {
        const url = this.baseUrl + `/organizations/${params.parameter.organization_id}/custom_roles`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get an organization
     * To see many of the organization response values, you need to be an authenticated organization owner with the `admin:org` scope. When the value of `two_factor_requirement_enabled` is `true`, the organization requires all members, billing managers, and outside collaborators to enable [two-factor authentication](https://docs.github.com/articles/securing-your-account-with-two-factor-authentication-2fa/).
     *
     * GitHub Apps with the `Organization plan` permission can use this endpoint to retrieve information about an organization's GitHub Enterprise Server plan. See "[Authenticating with GitHub Apps](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/)" for details. For an example response, see 'Response with GitHub Enterprise Server plan information' below."
     * operationId: orgs/get
     * Request URI: /orgs/{org}
     */
    async orgs$get(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update an organization
     * **Parameter Deprecation Notice:** GitHub Enterprise Server will replace and discontinue `members_allowed_repository_creation_type` in favor of more granular permissions. The new input parameters are `members_can_create_public_repositories`, `members_can_create_private_repositories` for all organizations and `members_can_create_internal_repositories` for organizations associated with an enterprise account using GitHub Enterprise Cloud or GitHub Enterprise Server 2.20+. For more information, see the [blog post](https://developer.github.com/changes/2019-12-03-internal-visibility-changes).
     *
     * Enables an authenticated organization owner with the `admin:org` scope to update the organization's profile and member privileges.
     * operationId: orgs/update
     * Request URI: /orgs/{org}
     */
    async orgs$update(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get GitHub Actions permissions for an organization
     * Gets the GitHub Actions permissions policy for repositories and allowed actions in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     * operationId: actions/get-github-actions-permissions-organization
     * Request URI: /orgs/{org}/actions/permissions
     */
    async actions$get$github$actions$permissions$organization(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/permissions`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set GitHub Actions permissions for an organization
     * Sets the GitHub Actions permissions policy for repositories and allowed actions in an organization.
     *
     * If the organization belongs to an enterprise that has set restrictive permissions at the enterprise level, such as `allowed_actions` to `selected` actions, then you cannot override them for the organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     * operationId: actions/set-github-actions-permissions-organization
     * Request URI: /orgs/{org}/actions/permissions
     */
    async actions$set$github$actions$permissions$organization(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/permissions`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List selected repositories enabled for GitHub Actions in an organization
     * Lists the selected repositories that are enabled for GitHub Actions in an organization. To use this endpoint, the organization permission policy for `enabled_repositories` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization)."
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     * operationId: actions/list-selected-repositories-enabled-github-actions-organization
     * Request URI: /orgs/{org}/actions/permissions/repositories
     */
    async actions$list$selected$repositories$enabled$github$actions$organization(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/permissions/repositories`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Set selected repositories enabled for GitHub Actions in an organization
     * Replaces the list of selected repositories that are enabled for GitHub Actions in an organization. To use this endpoint, the organization permission policy for `enabled_repositories` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization)."
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     * operationId: actions/set-selected-repositories-enabled-github-actions-organization
     * Request URI: /orgs/{org}/actions/permissions/repositories
     */
    async actions$set$selected$repositories$enabled$github$actions$organization(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/permissions/repositories`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Enable a selected repository for GitHub Actions in an organization
     * Adds a repository to the list of selected repositories that are enabled for GitHub Actions in an organization. To use this endpoint, the organization permission policy for `enabled_repositories` must be must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization)."
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     * operationId: actions/enable-selected-repository-github-actions-organization
     * Request URI: /orgs/{org}/actions/permissions/repositories/{repository_id}
     */
    async actions$enable$selected$repository$github$actions$organization(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/permissions/repositories/${params.parameter.repository_id}`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Disable a selected repository for GitHub Actions in an organization
     * Removes a repository from the list of selected repositories that are enabled for GitHub Actions in an organization. To use this endpoint, the organization permission policy for `enabled_repositories` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization)."
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     * operationId: actions/disable-selected-repository-github-actions-organization
     * Request URI: /orgs/{org}/actions/permissions/repositories/{repository_id}
     */
    async actions$disable$selected$repository$github$actions$organization(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/permissions/repositories/${params.parameter.repository_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get allowed actions for an organization
     * Gets the selected actions that are allowed in an organization. To use this endpoint, the organization permission policy for `allowed_actions` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization).""
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     * operationId: actions/get-allowed-actions-organization
     * Request URI: /orgs/{org}/actions/permissions/selected-actions
     */
    async actions$get$allowed$actions$organization(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/permissions/selected-actions`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set allowed actions for an organization
     * Sets the actions that are allowed in an organization. To use this endpoint, the organization permission policy for `allowed_actions` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization)."
     *
     * If the organization belongs to an enterprise that has `selected` actions set at the enterprise level, then you cannot override any of the enterprise's allowed actions settings.
     *
     * To use the `patterns_allowed` setting for private repositories, the organization must belong to an enterprise. If the organization does not belong to an enterprise, then the `patterns_allowed` setting only applies to public repositories in the organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     * operationId: actions/set-allowed-actions-organization
     * Request URI: /orgs/{org}/actions/permissions/selected-actions
     */
    async actions$set$allowed$actions$organization(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/permissions/selected-actions`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List self-hosted runner groups for an organization
     * Lists all self-hosted runner groups configured in an organization and inherited from an enterprise.
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/list-self-hosted-runner-groups-for-org
     * Request URI: /orgs/{org}/actions/runner-groups
     */
    async actions$list$self$hosted$runner$groups$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runner-groups`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a self-hosted runner group for an organization
     * The self-hosted runner groups REST API is available with GitHub Enterprise Cloud and GitHub Enterprise Server. For more information, see "[GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products)."
     *
     * Creates a new self-hosted runner group for an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/create-self-hosted-runner-group-for-org
     * Request URI: /orgs/{org}/actions/runner-groups
     */
    async actions$create$self$hosted$runner$group$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runner-groups`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a self-hosted runner group for an organization
     * Gets a specific self-hosted runner group for an organization.
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/get-self-hosted-runner-group-for-org
     * Request URI: /orgs/{org}/actions/runner-groups/{runner_group_id}
     */
    async actions$get$self$hosted$runner$group$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runner-groups/${params.parameter.runner_group_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a self-hosted runner group from an organization
     * Deletes a self-hosted runner group for an organization.
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/delete-self-hosted-runner-group-from-org
     * Request URI: /orgs/{org}/actions/runner-groups/{runner_group_id}
     */
    async actions$delete$self$hosted$runner$group$from$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runner-groups/${params.parameter.runner_group_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a self-hosted runner group for an organization
     * Updates the `name` and `visibility` of a self-hosted runner group in an organization.
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/update-self-hosted-runner-group-for-org
     * Request URI: /orgs/{org}/actions/runner-groups/{runner_group_id}
     */
    async actions$update$self$hosted$runner$group$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runner-groups/${params.parameter.runner_group_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List repository access to a self-hosted runner group in an organization
     * The self-hosted runner groups REST API is available with GitHub Enterprise Cloud and GitHub Enterprise Server. For more information, see "[GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products)."
     *
     * Lists the repositories with access to a self-hosted runner group configured in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/list-repo-access-to-self-hosted-runner-group-in-org
     * Request URI: /orgs/{org}/actions/runner-groups/{runner_group_id}/repositories
     */
    async actions$list$repo$access$to$self$hosted$runner$group$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runner-groups/${params.parameter.runner_group_id}/repositories`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            page: { value: params.parameter.page, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Set repository access for a self-hosted runner group in an organization
     * Replaces the list of repositories that have access to a self-hosted runner group configured in an organization.
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/set-repo-access-to-self-hosted-runner-group-in-org
     * Request URI: /orgs/{org}/actions/runner-groups/{runner_group_id}/repositories
     */
    async actions$set$repo$access$to$self$hosted$runner$group$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runner-groups/${params.parameter.runner_group_id}/repositories`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Add repository access to a self-hosted runner group in an organization
     * Adds a repository to the list of selected repositories that can access a self-hosted runner group. The runner group must have `visibility` set to `selected`. For more information, see "[Create a self-hosted runner group for an organization](#create-a-self-hosted-runner-group-for-an-organization)."
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/add-repo-access-to-self-hosted-runner-group-in-org
     * Request URI: /orgs/{org}/actions/runner-groups/{runner_group_id}/repositories/{repository_id}
     */
    async actions$add$repo$access$to$self$hosted$runner$group$in$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/actions/runner-groups/${params.parameter.runner_group_id}/repositories/${params.parameter.repository_id}`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Remove repository access to a self-hosted runner group in an organization
     * Removes a repository from the list of selected repositories that can access a self-hosted runner group. The runner group must have `visibility` set to `selected`. For more information, see "[Create a self-hosted runner group for an organization](#create-a-self-hosted-runner-group-for-an-organization)."
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/remove-repo-access-to-self-hosted-runner-group-in-org
     * Request URI: /orgs/{org}/actions/runner-groups/{runner_group_id}/repositories/{repository_id}
     */
    async actions$remove$repo$access$to$self$hosted$runner$group$in$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/actions/runner-groups/${params.parameter.runner_group_id}/repositories/${params.parameter.repository_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List self-hosted runners in a group for an organization
     * Lists self-hosted runners that are in a specific organization group.
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/list-self-hosted-runners-in-group-for-org
     * Request URI: /orgs/{org}/actions/runner-groups/{runner_group_id}/runners
     */
    async actions$list$self$hosted$runners$in$group$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runner-groups/${params.parameter.runner_group_id}/runners`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Set self-hosted runners in a group for an organization
     * Replaces the list of self-hosted runners that are part of an organization runner group.
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/set-self-hosted-runners-in-group-for-org
     * Request URI: /orgs/{org}/actions/runner-groups/{runner_group_id}/runners
     */
    async actions$set$self$hosted$runners$in$group$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runner-groups/${params.parameter.runner_group_id}/runners`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Add a self-hosted runner to a group for an organization
     * Adds a self-hosted runner to a runner group configured in an organization.
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/add-self-hosted-runner-to-group-for-org
     * Request URI: /orgs/{org}/actions/runner-groups/{runner_group_id}/runners/{runner_id}
     */
    async actions$add$self$hosted$runner$to$group$for$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/actions/runner-groups/${params.parameter.runner_group_id}/runners/${params.parameter.runner_id}`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Remove a self-hosted runner from a group for an organization
     * Removes a self-hosted runner from a group configured in an organization. The runner is then returned to the default group.
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/remove-self-hosted-runner-from-group-for-org
     * Request URI: /orgs/{org}/actions/runner-groups/{runner_group_id}/runners/{runner_id}
     */
    async actions$remove$self$hosted$runner$from$group$for$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/actions/runner-groups/${params.parameter.runner_group_id}/runners/${params.parameter.runner_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List self-hosted runners for an organization
     * Lists all self-hosted runners configured in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/list-self-hosted-runners-for-org
     * Request URI: /orgs/{org}/actions/runners
     */
    async actions$list$self$hosted$runners$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runners`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List runner applications for an organization
     * Lists binaries for the runner application that you can download and run.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/list-runner-applications-for-org
     * Request URI: /orgs/{org}/actions/runners/downloads
     */
    async actions$list$runner$applications$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runners/downloads`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create a registration token for an organization
     * Returns a token that you can pass to the `config` script. The token expires after one hour.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     *
     * #### Example using registration token
     *
     * Configure your self-hosted runner, replacing `TOKEN` with the registration token provided by this endpoint.
     *
     * ```
     * ./config.sh --url https://github.com/octo-org --token TOKEN
     * ```
     * operationId: actions/create-registration-token-for-org
     * Request URI: /orgs/{org}/actions/runners/registration-token
     */
    async actions$create$registration$token$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runners/registration-token`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Create a remove token for an organization
     * Returns a token that you can pass to the `config` script to remove a self-hosted runner from an organization. The token expires after one hour.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     *
     * #### Example using remove token
     *
     * To remove your self-hosted runner from an organization, replace `TOKEN` with the remove token provided by this
     * endpoint.
     *
     * ```
     * ./config.sh remove --token TOKEN
     * ```
     * operationId: actions/create-remove-token-for-org
     * Request URI: /orgs/{org}/actions/runners/remove-token
     */
    async actions$create$remove$token$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runners/remove-token`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Get a self-hosted runner for an organization
     * Gets a specific self-hosted runner configured in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/get-self-hosted-runner-for-org
     * Request URI: /orgs/{org}/actions/runners/{runner_id}
     */
    async actions$get$self$hosted$runner$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runners/${params.parameter.runner_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a self-hosted runner from an organization
     * Forces the removal of a self-hosted runner from an organization. You can use this endpoint to completely remove the runner when the machine you were using no longer exists.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/delete-self-hosted-runner-from-org
     * Request URI: /orgs/{org}/actions/runners/{runner_id}
     */
    async actions$delete$self$hosted$runner$from$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runners/${params.parameter.runner_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List labels for a self-hosted runner for an organization
     * Lists all labels for a self-hosted runner configured in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/list-labels-for-self-hosted-runner-for-org
     * Request URI: /orgs/{org}/actions/runners/{runner_id}/labels
     */
    async actions$list$labels$for$self$hosted$runner$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runners/${params.parameter.runner_id}/labels`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set custom labels for a self-hosted runner for an organization
     * Remove all previous custom labels and set the new custom labels for a specific
     * self-hosted runner configured in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/set-custom-labels-for-self-hosted-runner-for-org
     * Request URI: /orgs/{org}/actions/runners/{runner_id}/labels
     */
    async actions$set$custom$labels$for$self$hosted$runner$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runners/${params.parameter.runner_id}/labels`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Add custom labels to a self-hosted runner for an organization
     * Add custom labels to a self-hosted runner configured in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/add-custom-labels-to-self-hosted-runner-for-org
     * Request URI: /orgs/{org}/actions/runners/{runner_id}/labels
     */
    async actions$add$custom$labels$to$self$hosted$runner$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runners/${params.parameter.runner_id}/labels`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove all custom labels from a self-hosted runner for an organization
     * Remove all custom labels from a self-hosted runner configured in an
     * organization. Returns the remaining read-only labels from the runner.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/remove-all-custom-labels-from-self-hosted-runner-for-org
     * Request URI: /orgs/{org}/actions/runners/{runner_id}/labels
     */
    async actions$remove$all$custom$labels$from$self$hosted$runner$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runners/${params.parameter.runner_id}/labels`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Remove a custom label from a self-hosted runner for an organization
     * Remove a custom label from a self-hosted runner configured
     * in an organization. Returns the remaining labels from the runner.
     *
     * This endpoint returns a `404 Not Found` status if the custom label is not
     * present on the runner.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * operationId: actions/remove-custom-label-from-self-hosted-runner-for-org
     * Request URI: /orgs/{org}/actions/runners/{runner_id}/labels/{name}
     */
    async actions$remove$custom$label$from$self$hosted$runner$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/runners/${params.parameter.runner_id}/labels/${params.parameter.name}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List organization secrets
     * Lists all secrets available in an organization without revealing their encrypted values. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     * operationId: actions/list-org-secrets
     * Request URI: /orgs/{org}/actions/secrets
     */
    async actions$list$org$secrets(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/secrets`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get an organization public key
     * Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     * operationId: actions/get-org-public-key
     * Request URI: /orgs/{org}/actions/secrets/public-key
     */
    async actions$get$org$public$key(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/secrets/public-key`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get an organization secret
     * Gets a single organization secret without revealing its encrypted value. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     * operationId: actions/get-org-secret
     * Request URI: /orgs/{org}/actions/secrets/{secret_name}
     */
    async actions$get$org$secret(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/secrets/${params.parameter.secret_name}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create or update an organization secret
     * Creates or updates an organization secret with an encrypted value. Encrypt your secret using
     * [LibSodium](https://libsodium.gitbook.io/doc/bindings_for_other_languages). You must authenticate using an access
     * token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to
     * use this endpoint.
     *
     * #### Example encrypting a secret using Node.js
     *
     * Encrypt your secret using the [tweetsodium](https://github.com/github/tweetsodium) library.
     *
     * ```
     * const sodium = require('tweetsodium');
     *
     * const key = "base64-encoded-public-key";
     * const value = "plain-text-secret";
     *
     * // Convert the message and key to Uint8Array's (Buffer implements that interface)
     * const messageBytes = Buffer.from(value);
     * const keyBytes = Buffer.from(key, 'base64');
     *
     * // Encrypt using LibSodium.
     * const encryptedBytes = sodium.seal(messageBytes, keyBytes);
     *
     * // Base64 the encrypted secret
     * const encrypted = Buffer.from(encryptedBytes).toString('base64');
     *
     * console.log(encrypted);
     * ```
     *
     *
     * #### Example encrypting a secret using Python
     *
     * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
     *
     * ```
     * from base64 import b64encode
     * from nacl import encoding, public
     *
     * def encrypt(public_key: str, secret_value: str) -> str:
     *   """Encrypt a Unicode string using the public key."""
     *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
     *   sealed_box = public.SealedBox(public_key)
     *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
     *   return b64encode(encrypted).decode("utf-8")
     * ```
     *
     * #### Example encrypting a secret using C#
     *
     * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
     *
     * ```
     * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
     * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
     *
     * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
     *
     * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
     * ```
     *
     * #### Example encrypting a secret using Ruby
     *
     * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
     *
     * ```ruby
     * require "rbnacl"
     * require "base64"
     *
     * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
     * public_key = RbNaCl::PublicKey.new(key)
     *
     * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
     * encrypted_secret = box.encrypt("my_secret")
     *
     * # Print the base64 encoded secret
     * puts Base64.strict_encode64(encrypted_secret)
     * ```
     * operationId: actions/create-or-update-org-secret
     * Request URI: /orgs/{org}/actions/secrets/{secret_name}
     */
    async actions$create$or$update$org$secret(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/secrets/${params.parameter.secret_name}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete an organization secret
     * Deletes a secret in an organization using the secret name. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     * operationId: actions/delete-org-secret
     * Request URI: /orgs/{org}/actions/secrets/{secret_name}
     */
    async actions$delete$org$secret(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/secrets/${params.parameter.secret_name}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List selected repositories for an organization secret
     * Lists all repositories that have been selected when the `visibility` for repository access to a secret is set to `selected`. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     * operationId: actions/list-selected-repos-for-org-secret
     * Request URI: /orgs/{org}/actions/secrets/{secret_name}/repositories
     */
    async actions$list$selected$repos$for$org$secret(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/secrets/${params.parameter.secret_name}/repositories`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            page: { value: params.parameter.page, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Set selected repositories for an organization secret
     * Replaces all repositories for an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/enterprise-server@3.4/rest/reference/actions#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     * operationId: actions/set-selected-repos-for-org-secret
     * Request URI: /orgs/{org}/actions/secrets/{secret_name}/repositories
     */
    async actions$set$selected$repos$for$org$secret(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/actions/secrets/${params.parameter.secret_name}/repositories`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Add selected repository to an organization secret
     * Adds a repository to an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/enterprise-server@3.4/rest/reference/actions#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     * operationId: actions/add-selected-repo-to-org-secret
     * Request URI: /orgs/{org}/actions/secrets/{secret_name}/repositories/{repository_id}
     */
    async actions$add$selected$repo$to$org$secret(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/actions/secrets/${params.parameter.secret_name}/repositories/${params.parameter.repository_id}`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Remove selected repository from an organization secret
     * Removes a repository from an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/enterprise-server@3.4/rest/reference/actions#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     * operationId: actions/remove-selected-repo-from-org-secret
     * Request URI: /orgs/{org}/actions/secrets/{secret_name}/repositories/{repository_id}
     */
    async actions$remove$selected$repo$from$org$secret(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/actions/secrets/${params.parameter.secret_name}/repositories/${params.parameter.repository_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get the audit log for an organization
     * Gets the audit log for an organization. For more information, see "[Reviewing the audit log for your organization](https://docs.github.com/enterprise-server@3.4/github/setting-up-and-managing-organizations-and-teams/reviewing-the-audit-log-for-your-organization)."
     *
     * To use this endpoint, you must be an organization owner, and you must use an access token with the `admin:org` scope. GitHub Apps must have the `organization_administration` read permission to use this endpoint.
     * operationId: orgs/get-audit-log
     * Request URI: /orgs/{org}/audit-log
     */
    async orgs$get$audit$log(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/audit-log`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            phrase: { value: params.parameter.phrase, explode: false },
            include: { value: params.parameter.include, explode: false },
            after: { value: params.parameter.after, explode: false },
            before: { value: params.parameter.before, explode: false },
            order: { value: params.parameter.order, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List organization secrets
     * Lists all secrets available in an organization without revealing their encrypted values. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     * operationId: dependabot/list-org-secrets
     * Request URI: /orgs/{org}/dependabot/secrets
     */
    async dependabot$list$org$secrets(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/dependabot/secrets`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get an organization public key
     * Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     * operationId: dependabot/get-org-public-key
     * Request URI: /orgs/{org}/dependabot/secrets/public-key
     */
    async dependabot$get$org$public$key(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/dependabot/secrets/public-key`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get an organization secret
     * Gets a single organization secret without revealing its encrypted value. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     * operationId: dependabot/get-org-secret
     * Request URI: /orgs/{org}/dependabot/secrets/{secret_name}
     */
    async dependabot$get$org$secret(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/dependabot/secrets/${params.parameter.secret_name}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create or update an organization secret
     * Creates or updates an organization secret with an encrypted value. Encrypt your secret using
     * [LibSodium](https://libsodium.gitbook.io/doc/bindings_for_other_languages). You must authenticate using an access
     * token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization
     * permission to use this endpoint.
     *
     * #### Example encrypting a secret using Node.js
     *
     * Encrypt your secret using the [tweetsodium](https://github.com/github/tweetsodium) library.
     *
     * ```
     * const sodium = require('tweetsodium');
     *
     * const key = "base64-encoded-public-key";
     * const value = "plain-text-secret";
     *
     * // Convert the message and key to Uint8Array's (Buffer implements that interface)
     * const messageBytes = Buffer.from(value);
     * const keyBytes = Buffer.from(key, 'base64');
     *
     * // Encrypt using LibSodium.
     * const encryptedBytes = sodium.seal(messageBytes, keyBytes);
     *
     * // Base64 the encrypted secret
     * const encrypted = Buffer.from(encryptedBytes).toString('base64');
     *
     * console.log(encrypted);
     * ```
     *
     *
     * #### Example encrypting a secret using Python
     *
     * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
     *
     * ```
     * from base64 import b64encode
     * from nacl import encoding, public
     *
     * def encrypt(public_key: str, secret_value: str) -> str:
     *   """Encrypt a Unicode string using the public key."""
     *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
     *   sealed_box = public.SealedBox(public_key)
     *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
     *   return b64encode(encrypted).decode("utf-8")
     * ```
     *
     * #### Example encrypting a secret using C#
     *
     * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
     *
     * ```
     * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
     * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
     *
     * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
     *
     * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
     * ```
     *
     * #### Example encrypting a secret using Ruby
     *
     * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
     *
     * ```ruby
     * require "rbnacl"
     * require "base64"
     *
     * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
     * public_key = RbNaCl::PublicKey.new(key)
     *
     * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
     * encrypted_secret = box.encrypt("my_secret")
     *
     * # Print the base64 encoded secret
     * puts Base64.strict_encode64(encrypted_secret)
     * ```
     * operationId: dependabot/create-or-update-org-secret
     * Request URI: /orgs/{org}/dependabot/secrets/{secret_name}
     */
    async dependabot$create$or$update$org$secret(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/dependabot/secrets/${params.parameter.secret_name}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete an organization secret
     * Deletes a secret in an organization using the secret name. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     * operationId: dependabot/delete-org-secret
     * Request URI: /orgs/{org}/dependabot/secrets/{secret_name}
     */
    async dependabot$delete$org$secret(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/dependabot/secrets/${params.parameter.secret_name}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List selected repositories for an organization secret
     * Lists all repositories that have been selected when the `visibility` for repository access to a secret is set to `selected`. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     * operationId: dependabot/list-selected-repos-for-org-secret
     * Request URI: /orgs/{org}/dependabot/secrets/{secret_name}/repositories
     */
    async dependabot$list$selected$repos$for$org$secret(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/dependabot/secrets/${params.parameter.secret_name}/repositories`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            page: { value: params.parameter.page, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Set selected repositories for an organization secret
     * Replaces all repositories for an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/enterprise-server@3.4/rest/reference/dependabot#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     * operationId: dependabot/set-selected-repos-for-org-secret
     * Request URI: /orgs/{org}/dependabot/secrets/{secret_name}/repositories
     */
    async dependabot$set$selected$repos$for$org$secret(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/dependabot/secrets/${params.parameter.secret_name}/repositories`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Add selected repository to an organization secret
     * Adds a repository to an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/enterprise-server@3.4/rest/reference/dependabot#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     * operationId: dependabot/add-selected-repo-to-org-secret
     * Request URI: /orgs/{org}/dependabot/secrets/{secret_name}/repositories/{repository_id}
     */
    async dependabot$add$selected$repo$to$org$secret(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/dependabot/secrets/${params.parameter.secret_name}/repositories/${params.parameter.repository_id}`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Remove selected repository from an organization secret
     * Removes a repository from an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/enterprise-server@3.4/rest/reference/dependabot#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     * operationId: dependabot/remove-selected-repo-from-org-secret
     * Request URI: /orgs/{org}/dependabot/secrets/{secret_name}/repositories/{repository_id}
     */
    async dependabot$remove$selected$repo$from$org$secret(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/dependabot/secrets/${params.parameter.secret_name}/repositories/${params.parameter.repository_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List public organization events
     * operationId: activity/list-public-org-events
     * Request URI: /orgs/{org}/events
     */
    async activity$list$public$org$events(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/events`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List organization webhooks
     * operationId: orgs/list-webhooks
     * Request URI: /orgs/{org}/hooks
     */
    async orgs$list$webhooks(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/hooks`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create an organization webhook
     * Here's how you can create a hook that posts payloads in JSON format:
     * operationId: orgs/create-webhook
     * Request URI: /orgs/{org}/hooks
     */
    async orgs$create$webhook(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/hooks`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get an organization webhook
     * Returns a webhook configured in an organization. To get only the webhook `config` properties, see "[Get a webhook configuration for an organization](/rest/reference/orgs#get-a-webhook-configuration-for-an-organization)."
     * operationId: orgs/get-webhook
     * Request URI: /orgs/{org}/hooks/{hook_id}
     */
    async orgs$get$webhook(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/hooks/${params.parameter.hook_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete an organization webhook
     * operationId: orgs/delete-webhook
     * Request URI: /orgs/{org}/hooks/{hook_id}
     */
    async orgs$delete$webhook(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/hooks/${params.parameter.hook_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update an organization webhook
     * Updates a webhook configured in an organization. When you update a webhook, the `secret` will be overwritten. If you previously had a `secret` set, you must provide the same `secret` or set a new `secret` or the secret will be removed. If you are only updating individual webhook `config` properties, use "[Update a webhook configuration for an organization](/rest/reference/orgs#update-a-webhook-configuration-for-an-organization)."
     * operationId: orgs/update-webhook
     * Request URI: /orgs/{org}/hooks/{hook_id}
     */
    async orgs$update$webhook(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/hooks/${params.parameter.hook_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a webhook configuration for an organization
     * Returns the webhook configuration for an organization. To get more information about the webhook, including the `active` state and `events`, use "[Get an organization webhook ](/rest/reference/orgs#get-an-organization-webhook)."
     *
     * Access tokens must have the `admin:org_hook` scope, and GitHub Apps must have the `organization_hooks:read` permission.
     * operationId: orgs/get-webhook-config-for-org
     * Request URI: /orgs/{org}/hooks/{hook_id}/config
     */
    async orgs$get$webhook$config$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/hooks/${params.parameter.hook_id}/config`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update a webhook configuration for an organization
     * Updates the webhook configuration for an organization. To update more information about the webhook, including the `active` state and `events`, use "[Update an organization webhook ](/rest/reference/orgs#update-an-organization-webhook)."
     *
     * Access tokens must have the `admin:org_hook` scope, and GitHub Apps must have the `organization_hooks:write` permission.
     * operationId: orgs/update-webhook-config-for-org
     * Request URI: /orgs/{org}/hooks/{hook_id}/config
     */
    async orgs$update$webhook$config$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/hooks/${params.parameter.hook_id}/config`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List deliveries for an organization webhook
     * Returns a list of webhook deliveries for a webhook configured in an organization.
     * operationId: orgs/list-webhook-deliveries
     * Request URI: /orgs/{org}/hooks/{hook_id}/deliveries
     */
    async orgs$list$webhook$deliveries(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/hooks/${params.parameter.hook_id}/deliveries`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            cursor: { value: params.parameter.cursor, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a webhook delivery for an organization webhook
     * Returns a delivery for a webhook configured in an organization.
     * operationId: orgs/get-webhook-delivery
     * Request URI: /orgs/{org}/hooks/{hook_id}/deliveries/{delivery_id}
     */
    async orgs$get$webhook$delivery(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/hooks/${params.parameter.hook_id}/deliveries/${params.parameter.delivery_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Redeliver a delivery for an organization webhook
     * Redeliver a delivery for a webhook configured in an organization.
     * operationId: orgs/redeliver-webhook-delivery
     * Request URI: /orgs/{org}/hooks/{hook_id}/deliveries/{delivery_id}/attempts
     */
    async orgs$redeliver$webhook$delivery(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/hooks/${params.parameter.hook_id}/deliveries/${params.parameter.delivery_id}/attempts`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Ping an organization webhook
     * This will trigger a [ping event](https://docs.github.com/enterprise-server@3.4/webhooks/#ping-event) to be sent to the hook.
     * operationId: orgs/ping-webhook
     * Request URI: /orgs/{org}/hooks/{hook_id}/pings
     */
    async orgs$ping$webhook(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/hooks/${params.parameter.hook_id}/pings`;
        const headers = {};
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Get an organization installation for the authenticated app
     * Enables an authenticated GitHub App to find the organization's installation information.
     *
     * You must use a [JWT](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     * operationId: apps/get-org-installation
     * Request URI: /orgs/{org}/installation
     */
    async apps$get$org$installation(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/installation`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List app installations for an organization
     * Lists all GitHub Apps in an organization. The installation count includes all GitHub Apps installed on repositories in the organization. You must be an organization owner with `admin:read` scope to use this endpoint.
     * operationId: orgs/list-app-installations
     * Request URI: /orgs/{org}/installations
     */
    async orgs$list$app$installations(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/installations`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List organization issues assigned to the authenticated user
     * List issues in an organization assigned to the authenticated user.
     *
     * **Note**: GitHub's REST API v3 considers every pull request an issue, but not every issue is a pull request. For this
     * reason, "Issues" endpoints may return both issues and pull requests in the response. You can identify pull requests by
     * the `pull_request` key. Be aware that the `id` of a pull request returned from "Issues" endpoints will be an _issue id_. To find out the pull
     * request id, use the "[List pull requests](https://docs.github.com/enterprise-server@3.4/rest/reference/pulls#list-pull-requests)" endpoint.
     * operationId: issues/list-for-org
     * Request URI: /orgs/{org}/issues
     */
    async issues$list$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/issues`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filter: { value: params.parameter.filter, explode: false },
            state: { value: params.parameter.state, explode: false },
            labels: { value: params.parameter.labels, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            since: { value: params.parameter.since, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List organization members
     * List all users who are members of an organization. If the authenticated user is also a member of this organization then both concealed and public members will be returned.
     * operationId: orgs/list-members
     * Request URI: /orgs/{org}/members
     */
    async orgs$list$members(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/members`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filter: { value: params.parameter.filter, explode: false },
            role: { value: params.parameter.role, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Check organization membership for a user
     * Check if a user is, publicly or privately, a member of the organization.
     * operationId: orgs/check-membership-for-user
     * Request URI: /orgs/{org}/members/{username}
     */
    async orgs$check$membership$for$user(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/members/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Remove an organization member
     * Removing a user from this list will remove them from all teams and they will no longer have any access to the organization's repositories.
     * operationId: orgs/remove-member
     * Request URI: /orgs/{org}/members/{username}
     */
    async orgs$remove$member(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/members/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get organization membership for a user
     * In order to get a user's membership with an organization, the authenticated user must be an organization member. The `state` parameter in the response can be used to identify the user's membership status.
     * operationId: orgs/get-membership-for-user
     * Request URI: /orgs/{org}/memberships/{username}
     */
    async orgs$get$membership$for$user(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/memberships/${params.parameter.username}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set organization membership for a user
     * Only authenticated organization owners can add a member to the organization or update the member's role.
     *
     * *   If the authenticated user is _adding_ a member to the organization, the invited user will receive an email inviting them to the organization. The user's [membership status](https://docs.github.com/enterprise-server@3.4/rest/reference/orgs#get-organization-membership-for-a-user) will be `pending` until they accept the invitation.
     *
     * *   Authenticated users can _update_ a user's membership by passing the `role` parameter. If the authenticated user changes a member's role to `admin`, the affected user will receive an email notifying them that they've been made an organization owner. If the authenticated user changes an owner's role to `member`, no email will be sent.
     *
     * **Rate limits**
     *
     * To prevent abuse, the authenticated user is limited to 50 organization invitations per 24 hour period. If the organization is more than one month old or on a paid plan, the limit is 500 invitations per 24 hour period.
     * operationId: orgs/set-membership-for-user
     * Request URI: /orgs/{org}/memberships/{username}
     */
    async orgs$set$membership$for$user(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/memberships/${params.parameter.username}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove organization membership for a user
     * In order to remove a user's membership with an organization, the authenticated user must be an organization owner.
     *
     * If the specified user is an active member of the organization, this will remove them from the organization. If the specified user has been invited to the organization, this will cancel their invitation. The specified user will receive an email notification in both cases.
     * operationId: orgs/remove-membership-for-user
     * Request URI: /orgs/{org}/memberships/{username}
     */
    async orgs$remove$membership$for$user(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/memberships/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List organization migrations
     * Lists the most recent migrations.
     * operationId: migrations/list-for-org
     * Request URI: /orgs/{org}/migrations
     */
    async migrations$list$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/migrations`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
            exclude: { value: params.parameter.exclude, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Start an organization migration
     * Initiates the generation of a migration archive.
     * operationId: migrations/start-for-org
     * Request URI: /orgs/{org}/migrations
     */
    async migrations$start$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/migrations`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get an organization migration status
     * Fetches the status of a migration.
     *
     * The `state` of a migration can be one of the following values:
     *
     * *   `pending`, which means the migration hasn't started yet.
     * *   `exporting`, which means the migration is in progress.
     * *   `exported`, which means the migration finished successfully.
     * *   `failed`, which means the migration failed.
     * operationId: migrations/get-status-for-org
     * Request URI: /orgs/{org}/migrations/{migration_id}
     */
    async migrations$get$status$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/migrations/${params.parameter.migration_id}`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            exclude: { value: params.parameter.exclude, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List outside collaborators for an organization
     * List all users who are outside collaborators of an organization.
     * operationId: orgs/list-outside-collaborators
     * Request URI: /orgs/{org}/outside_collaborators
     */
    async orgs$list$outside$collaborators(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/outside_collaborators`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filter: { value: params.parameter.filter, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Convert an organization member to outside collaborator
     * When an organization member is converted to an outside collaborator, they'll only have access to the repositories that their current team membership allows. The user will no longer be a member of the organization. For more information, see "[Converting an organization member to an outside collaborator](https://docs.github.com/articles/converting-an-organization-member-to-an-outside-collaborator/)".
     * operationId: orgs/convert-member-to-outside-collaborator
     * Request URI: /orgs/{org}/outside_collaborators/{username}
     */
    async orgs$convert$member$to$outside$collaborator(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/outside_collaborators/${params.parameter.username}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Remove outside collaborator from an organization
     * Removing a user from this list will remove them from all the organization's repositories.
     * operationId: orgs/remove-outside-collaborator
     * Request URI: /orgs/{org}/outside_collaborators/{username}
     */
    async orgs$remove$outside$collaborator(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/outside_collaborators/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List pre-receive hooks for an organization
     * List all pre-receive hooks that are enabled or testing for this organization as well as any disabled hooks that can be configured at the organization level. Globally disabled pre-receive hooks that do not allow downstream configuration are not listed.
     * operationId: enterprise-admin/list-pre-receive-hooks-for-org
     * Request URI: /orgs/{org}/pre-receive-hooks
     */
    async enterprise$admin$list$pre$receive$hooks$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/pre-receive-hooks`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            sort: { value: params.parameter.sort, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a pre-receive hook for an organization
     * operationId: enterprise-admin/get-pre-receive-hook-for-org
     * Request URI: /orgs/{org}/pre-receive-hooks/{pre_receive_hook_id}
     */
    async enterprise$admin$get$pre$receive$hook$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/pre-receive-hooks/${params.parameter.pre_receive_hook_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Remove pre-receive hook enforcement for an organization
     * Removes any overrides for this hook at the org level for this org.
     * operationId: enterprise-admin/remove-pre-receive-hook-enforcement-for-org
     * Request URI: /orgs/{org}/pre-receive-hooks/{pre_receive_hook_id}
     */
    async enterprise$admin$remove$pre$receive$hook$enforcement$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/pre-receive-hooks/${params.parameter.pre_receive_hook_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update pre-receive hook enforcement for an organization
     * For pre-receive hooks which are allowed to be configured at the org level, you can set `enforcement` and `allow_downstream_configuration`
     * operationId: enterprise-admin/update-pre-receive-hook-enforcement-for-org
     * Request URI: /orgs/{org}/pre-receive-hooks/{pre_receive_hook_id}
     */
    async enterprise$admin$update$pre$receive$hook$enforcement$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/pre-receive-hooks/${params.parameter.pre_receive_hook_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List organization projects
     * Lists the projects in an organization. Returns a `404 Not Found` status if projects are disabled in the organization. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
     * operationId: projects/list-for-org
     * Request URI: /orgs/{org}/projects
     */
    async projects$list$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/projects`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            state: { value: params.parameter.state, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create an organization project
     * Creates an organization project board. Returns a `404 Not Found` status if projects are disabled in the organization. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
     * operationId: projects/create-for-org
     * Request URI: /orgs/{org}/projects
     */
    async projects$create$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/projects`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List public organization members
     * Members of an organization can choose to have their membership publicized or not.
     * operationId: orgs/list-public-members
     * Request URI: /orgs/{org}/public_members
     */
    async orgs$list$public$members(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/public_members`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Check public organization membership for a user
     * operationId: orgs/check-public-membership-for-user
     * Request URI: /orgs/{org}/public_members/{username}
     */
    async orgs$check$public$membership$for$user(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/public_members/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set public organization membership for the authenticated user
     * The user can publicize their own membership. (A user cannot publicize the membership for another user.)
     *
     * Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#http-verbs)."
     * operationId: orgs/set-public-membership-for-authenticated-user
     * Request URI: /orgs/{org}/public_members/{username}
     */
    async orgs$set$public$membership$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/public_members/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Remove public organization membership for the authenticated user
     * operationId: orgs/remove-public-membership-for-authenticated-user
     * Request URI: /orgs/{org}/public_members/{username}
     */
    async orgs$remove$public$membership$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/public_members/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List organization repositories
     * Lists repositories for the specified organization.
     * operationId: repos/list-for-org
     * Request URI: /orgs/{org}/repos
     */
    async repos$list$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/repos`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            type: { value: params.parameter.type, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create an organization repository
     * Creates a new repository in the specified organization. The authenticated user must be a member of the organization.
     *
     * **OAuth scope requirements**
     *
     * When using [OAuth](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/), authorizations must include:
     *
     * *   `public_repo` scope or `repo` scope to create a public repository. Note: For GitHub AE, use `repo` scope to create an internal repository.
     * *   `repo` scope to create a private repository
     * operationId: repos/create-in-org
     * Request URI: /orgs/{org}/repos
     */
    async repos$create$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/repos`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List secret scanning alerts for an organization
     * Lists secret scanning alerts for eligible repositories in an organization, from newest to oldest.
     * To use this endpoint, you must be an administrator or security manager for the organization, and you must use an access token with the `repo` scope or `security_events` scope.
     *
     * GitHub Apps must have the `secret_scanning_alerts` read permission to use this endpoint.
     * operationId: secret-scanning/list-alerts-for-org
     * Request URI: /orgs/{org}/secret-scanning/alerts
     */
    async secret$scanning$list$alerts$for$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/secret-scanning/alerts`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            state: { value: params.parameter.state, explode: false },
            secret_type: { value: params.parameter.secret_type, explode: false },
            resolution: { value: params.parameter.resolution, explode: false },
            page: { value: params.parameter.page, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get GitHub Advanced Security active committers for an organization
     * Gets the GitHub Advanced Security active committers for an organization per repository.
     * Each distinct user login across all repositories is counted as a single Advanced Security seat, so the total_advanced_security_committers is not the sum of advanced_security_committers for each repository.
     * If this organization defers to an enterprise for billing, the total_advanced_security_committers returned from the organization API may include some users that are in more than one organization, so they will only consume a single Advanced Security seat at the enterprise level.
     * operationId: billing/get-github-advanced-security-billing-org
     * Request URI: /orgs/{org}/settings/billing/advanced-security
     */
    async billing$get$github$advanced$security$billing$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/settings/billing/advanced-security`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List teams
     * Lists all teams in an organization that are visible to the authenticated user.
     * operationId: teams/list
     * Request URI: /orgs/{org}/teams
     */
    async teams$list(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a team
     * To create a team, the authenticated user must be a member or owner of `{org}`. By default, organization members can create teams. Organization owners can limit team creation to organization owners. For more information, see "[Setting team creation permissions](https://docs.github.com/en/articles/setting-team-creation-permissions-in-your-organization)."
     *
     * When you create a new team, you automatically become a team maintainer without explicitly adding yourself to the optional array of `maintainers`. For more information, see "[About teams](https://docs.github.com/en/github/setting-up-and-managing-organizations-and-teams/about-teams)".
     * operationId: teams/create
     * Request URI: /orgs/{org}/teams
     */
    async teams$create(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a team by name
     * Gets a team using the team's `slug`. GitHub Enterprise Server generates the `slug` from the team `name`.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}`.
     * operationId: teams/get-by-name
     * Request URI: /orgs/{org}/teams/{team_slug}
     */
    async teams$get$by$name(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a team
     * To delete a team, the authenticated user must be an organization owner or team maintainer.
     *
     * If you are an organization owner, deleting a parent team will delete all of its child teams as well.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}`.
     * operationId: teams/delete-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}
     */
    async teams$delete$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a team
     * To edit a team, the authenticated user must either be an organization owner or a team maintainer.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PATCH /organizations/{org_id}/team/{team_id}`.
     * operationId: teams/update-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}
     */
    async teams$update$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List discussions
     * List all discussions on a team's page. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/discussions`.
     * operationId: teams/list-discussions-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions
     */
    async teams$list$discussions$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            direction: { value: params.parameter.direction, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
            pinned: { value: params.parameter.pinned, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a discussion
     * Creates a new discussion post on a team's page. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * This endpoint triggers [notifications](https://docs.github.com/en/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `POST /organizations/{org_id}/team/{team_id}/discussions`.
     * operationId: teams/create-discussion-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions
     */
    async teams$create$discussion$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a discussion
     * Get a specific discussion on a team's page. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}`.
     * operationId: teams/get-discussion-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}
     */
    async teams$get$discussion$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions/${params.parameter.discussion_number}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a discussion
     * Delete a discussion from a team's page. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}`.
     * operationId: teams/delete-discussion-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}
     */
    async teams$delete$discussion$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions/${params.parameter.discussion_number}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a discussion
     * Edits the title and body text of a discussion post. Only the parameters you provide are updated. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PATCH /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}`.
     * operationId: teams/update-discussion-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}
     */
    async teams$update$discussion$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions/${params.parameter.discussion_number}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List discussion comments
     * List all comments on a team discussion. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}/comments`.
     * operationId: teams/list-discussion-comments-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments
     */
    async teams$list$discussion$comments$in$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions/${params.parameter.discussion_number}/comments`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            direction: { value: params.parameter.direction, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a discussion comment
     * Creates a new comment on a team discussion. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * This endpoint triggers [notifications](https://docs.github.com/en/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `POST /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}/comments`.
     * operationId: teams/create-discussion-comment-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments
     */
    async teams$create$discussion$comment$in$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions/${params.parameter.discussion_number}/comments`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a discussion comment
     * Get a specific comment on a team discussion. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}/comments/{comment_number}`.
     * operationId: teams/get-discussion-comment-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}
     */
    async teams$get$discussion$comment$in$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions/${params.parameter.discussion_number}/comments/${params.parameter.comment_number}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a discussion comment
     * Deletes a comment on a team discussion. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}/comments/{comment_number}`.
     * operationId: teams/delete-discussion-comment-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}
     */
    async teams$delete$discussion$comment$in$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions/${params.parameter.discussion_number}/comments/${params.parameter.comment_number}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a discussion comment
     * Edits the body text of a discussion comment. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PATCH /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}/comments/{comment_number}`.
     * operationId: teams/update-discussion-comment-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}
     */
    async teams$update$discussion$comment$in$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions/${params.parameter.discussion_number}/comments/${params.parameter.comment_number}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List reactions for a team discussion comment
     * List the reactions to a [team discussion comment](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#discussion-comments/). OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/:org_id/team/:team_id/discussions/:discussion_number/comments/:comment_number/reactions`.
     * operationId: reactions/list-for-team-discussion-comment-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}/reactions
     */
    async reactions$list$for$team$discussion$comment$in$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions/${params.parameter.discussion_number}/comments/${params.parameter.comment_number}/reactions`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            content: { value: params.parameter.content, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create reaction for a team discussion comment
     * Create a reaction to a [team discussion comment](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#discussion-comments). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/). A response with an HTTP `200` status means that you already added the reaction type to this team discussion comment.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `POST /organizations/:org_id/team/:team_id/discussions/:discussion_number/comments/:comment_number/reactions`.
     * operationId: reactions/create-for-team-discussion-comment-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}/reactions
     */
    async reactions$create$for$team$discussion$comment$in$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions/${params.parameter.discussion_number}/comments/${params.parameter.comment_number}/reactions`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete team discussion comment reaction
     * **Note:** You can also specify a team or organization with `team_id` and `org_id` using the route `DELETE /organizations/:org_id/team/:team_id/discussions/:discussion_number/comments/:comment_number/reactions/:reaction_id`.
     *
     * Delete a reaction to a [team discussion comment](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#discussion-comments). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: reactions/delete-for-team-discussion-comment
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}/reactions/{reaction_id}
     */
    async reactions$delete$for$team$discussion$comment(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions/${params.parameter.discussion_number}/comments/${params.parameter.comment_number}/reactions/${params.parameter.reaction_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List reactions for a team discussion
     * List the reactions to a [team discussion](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#discussions). OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/:org_id/team/:team_id/discussions/:discussion_number/reactions`.
     * operationId: reactions/list-for-team-discussion-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/reactions
     */
    async reactions$list$for$team$discussion$in$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions/${params.parameter.discussion_number}/reactions`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            content: { value: params.parameter.content, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create reaction for a team discussion
     * Create a reaction to a [team discussion](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#discussions). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/). A response with an HTTP `200` status means that you already added the reaction type to this team discussion.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `POST /organizations/:org_id/team/:team_id/discussions/:discussion_number/reactions`.
     * operationId: reactions/create-for-team-discussion-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/reactions
     */
    async reactions$create$for$team$discussion$in$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions/${params.parameter.discussion_number}/reactions`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete team discussion reaction
     * **Note:** You can also specify a team or organization with `team_id` and `org_id` using the route `DELETE /organizations/:org_id/team/:team_id/discussions/:discussion_number/reactions/:reaction_id`.
     *
     * Delete a reaction to a [team discussion](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#discussions). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: reactions/delete-for-team-discussion
     * Request URI: /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/reactions/{reaction_id}
     */
    async reactions$delete$for$team$discussion(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/discussions/${params.parameter.discussion_number}/reactions/${params.parameter.reaction_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List team members
     * Team members will include the members of child teams.
     *
     * To list members in a team, the team must be visible to the authenticated user.
     * operationId: teams/list-members-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/members
     */
    async teams$list$members$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/members`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            role: { value: params.parameter.role, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get team membership for a user
     * Team members will include the members of child teams.
     *
     * To get a user's membership with a team, the team must be visible to the authenticated user.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/memberships/{username}`.
     *
     * **Note:**
     * The response contains the `state` of the membership and the member's `role`.
     *
     * The `role` for organization owners is set to `maintainer`. For more information about `maintainer` roles, see see [Create a team](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#create-a-team).
     * operationId: teams/get-membership-for-user-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/memberships/{username}
     */
    async teams$get$membership$for$user$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/memberships/${params.parameter.username}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Add or update team membership for a user
     * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Adds an organization member to a team. An authenticated organization owner or team maintainer can add organization members to a team.
     *
     * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub Enterprise Server team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub Enterprise Server](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
     *
     * An organization owner can add someone who is not part of the team's organization to a team. When an organization owner adds someone to a team who is not an organization member, this endpoint will send an invitation to the person via email. This newly-created membership will be in the "pending" state until the person accepts the invitation, at which point the membership will transition to the "active" state and the user will be added as a member of the team.
     *
     * If the user is already a member of the team, this endpoint will update the role of the team member's role. To update the membership of a team member, the authenticated user must be an organization owner or a team maintainer.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PUT /organizations/{org_id}/team/{team_id}/memberships/{username}`.
     * operationId: teams/add-or-update-membership-for-user-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/memberships/{username}
     */
    async teams$add$or$update$membership$for$user$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/memberships/${params.parameter.username}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove team membership for a user
     * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * To remove a membership between a user and a team, the authenticated user must have 'admin' permissions to the team or be an owner of the organization that the team is associated with. Removing team membership does not delete the user, it just removes their membership from the team.
     *
     * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub Enterprise Server team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub Enterprise Server](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}/memberships/{username}`.
     * operationId: teams/remove-membership-for-user-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/memberships/{username}
     */
    async teams$remove$membership$for$user$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/memberships/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List team projects
     * Lists the organization projects for a team.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/projects`.
     * operationId: teams/list-projects-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/projects
     */
    async teams$list$projects$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/projects`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Check team permissions for a project
     * Checks whether a team has `read`, `write`, or `admin` permissions for an organization project. The response includes projects inherited from a parent team.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/projects/{project_id}`.
     * operationId: teams/check-permissions-for-project-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/projects/{project_id}
     */
    async teams$check$permissions$for$project$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/projects/${params.parameter.project_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Add or update team project permissions
     * Adds an organization project to a team. To add a project to a team or update the team's permission on a project, the authenticated user must have `admin` permissions for the project. The project and team must be part of the same organization.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PUT /organizations/{org_id}/team/{team_id}/projects/{project_id}`.
     * operationId: teams/add-or-update-project-permissions-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/projects/{project_id}
     */
    async teams$add$or$update$project$permissions$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/projects/${params.parameter.project_id}`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove a project from a team
     * Removes an organization project from a team. An organization owner or a team maintainer can remove any project from the team. To remove a project from a team as an organization member, the authenticated user must have `read` access to both the team and project, or `admin` access to the team or project. This endpoint removes the project from the team, but does not delete the project.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}/projects/{project_id}`.
     * operationId: teams/remove-project-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/projects/{project_id}
     */
    async teams$remove$project$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/projects/${params.parameter.project_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List team repositories
     * Lists a team's repositories visible to the authenticated user.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/repos`.
     * operationId: teams/list-repos-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/repos
     */
    async teams$list$repos$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/repos`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Check team permissions for a repository
     * Checks whether a team has `admin`, `push`, `maintain`, `triage`, or `pull` permission for a repository. Repositories inherited through a parent team will also be checked.
     *
     * You can also get information about the specified repository, including what permissions the team grants on it, by passing the following custom [media type](https://docs.github.com/enterprise-server@3.4/rest/overview/media-types/) via the `application/vnd.github.v3.repository+json` accept header.
     *
     * If a team doesn't have permission for the repository, you will receive a `404 Not Found` response status.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/repos/{owner}/{repo}`.
     * operationId: teams/check-permissions-for-repo-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/repos/{owner}/{repo}
     */
    async teams$check$permissions$for$repo$in$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/repos/${params.parameter.owner}/${params.parameter.repo}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Add or update team repository permissions
     * To add a repository to a team or update the team's permission on a repository, the authenticated user must have admin access to the repository, and must be able to see the team. The repository must be owned by the organization, or a direct fork of a repository owned by the organization. You will get a `422 Unprocessable Entity` status if you attempt to add a repository to a team that is not owned by the organization. Note that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#http-verbs)."
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PUT /organizations/{org_id}/team/{team_id}/repos/{owner}/{repo}`.
     *
     * For more information about the permission levels, see "[Repository permission levels for an organization](https://docs.github.com/en/github/setting-up-and-managing-organizations-and-teams/repository-permission-levels-for-an-organization#permission-levels-for-repositories-owned-by-an-organization)".
     * operationId: teams/add-or-update-repo-permissions-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/repos/{owner}/{repo}
     */
    async teams$add$or$update$repo$permissions$in$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/repos/${params.parameter.owner}/${params.parameter.repo}`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove a repository from a team
     * If the authenticated user is an organization owner or a team maintainer, they can remove any repositories from the team. To remove a repository from a team as an organization member, the authenticated user must have admin access to the repository and must be able to see the team. This does not delete the repository, it just removes it from the team.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}/repos/{owner}/{repo}`.
     * operationId: teams/remove-repo-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/repos/{owner}/{repo}
     */
    async teams$remove$repo$in$org(params, option) {
        const url = this.baseUrl +
            `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/repos/${params.parameter.owner}/${params.parameter.repo}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List child teams
     * Lists the child teams of the team specified by `{team_slug}`.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/teams`.
     * operationId: teams/list-child-in-org
     * Request URI: /orgs/{org}/teams/{team_slug}/teams
     */
    async teams$list$child$in$org(params, option) {
        const url = this.baseUrl + `/orgs/${params.parameter.org}/teams/${params.parameter.team_slug}/teams`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a project card
     * operationId: projects/get-card
     * Request URI: /projects/columns/cards/{card_id}
     */
    async projects$get$card(params, option) {
        const url = this.baseUrl + `/projects/columns/cards/${params.parameter.card_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a project card
     * operationId: projects/delete-card
     * Request URI: /projects/columns/cards/{card_id}
     */
    async projects$delete$card(params, option) {
        const url = this.baseUrl + `/projects/columns/cards/${params.parameter.card_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update an existing project card
     * operationId: projects/update-card
     * Request URI: /projects/columns/cards/{card_id}
     */
    async projects$update$card(params, option) {
        const url = this.baseUrl + `/projects/columns/cards/${params.parameter.card_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Move a project card
     * operationId: projects/move-card
     * Request URI: /projects/columns/cards/{card_id}/moves
     */
    async projects$move$card(params, option) {
        const url = this.baseUrl + `/projects/columns/cards/${params.parameter.card_id}/moves`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a project column
     * operationId: projects/get-column
     * Request URI: /projects/columns/{column_id}
     */
    async projects$get$column(params, option) {
        const url = this.baseUrl + `/projects/columns/${params.parameter.column_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a project column
     * operationId: projects/delete-column
     * Request URI: /projects/columns/{column_id}
     */
    async projects$delete$column(params, option) {
        const url = this.baseUrl + `/projects/columns/${params.parameter.column_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update an existing project column
     * operationId: projects/update-column
     * Request URI: /projects/columns/{column_id}
     */
    async projects$update$column(params, option) {
        const url = this.baseUrl + `/projects/columns/${params.parameter.column_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List project cards
     * operationId: projects/list-cards
     * Request URI: /projects/columns/{column_id}/cards
     */
    async projects$list$cards(params, option) {
        const url = this.baseUrl + `/projects/columns/${params.parameter.column_id}/cards`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            archived_state: { value: params.parameter.archived_state, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a project card
     * operationId: projects/create-card
     * Request URI: /projects/columns/{column_id}/cards
     */
    async projects$create$card(params, option) {
        const url = this.baseUrl + `/projects/columns/${params.parameter.column_id}/cards`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Move a project column
     * operationId: projects/move-column
     * Request URI: /projects/columns/{column_id}/moves
     */
    async projects$move$column(params, option) {
        const url = this.baseUrl + `/projects/columns/${params.parameter.column_id}/moves`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a project
     * Gets a project by its `id`. Returns a `404 Not Found` status if projects are disabled. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
     * operationId: projects/get
     * Request URI: /projects/{project_id}
     */
    async projects$get(params, option) {
        const url = this.baseUrl + `/projects/${params.parameter.project_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a project
     * Deletes a project board. Returns a `404 Not Found` status if projects are disabled.
     * operationId: projects/delete
     * Request URI: /projects/{project_id}
     */
    async projects$delete(params, option) {
        const url = this.baseUrl + `/projects/${params.parameter.project_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a project
     * Updates a project board's information. Returns a `404 Not Found` status if projects are disabled. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
     * operationId: projects/update
     * Request URI: /projects/{project_id}
     */
    async projects$update(params, option) {
        const url = this.baseUrl + `/projects/${params.parameter.project_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List project collaborators
     * Lists the collaborators for an organization project. For a project, the list of collaborators includes outside collaborators, organization members that are direct collaborators, organization members with access through team memberships, organization members with access through default organization permissions, and organization owners. You must be an organization owner or a project `admin` to list collaborators.
     * operationId: projects/list-collaborators
     * Request URI: /projects/{project_id}/collaborators
     */
    async projects$list$collaborators(params, option) {
        const url = this.baseUrl + `/projects/${params.parameter.project_id}/collaborators`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            affiliation: { value: params.parameter.affiliation, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Add project collaborator
     * Adds a collaborator to an organization project and sets their permission level. You must be an organization owner or a project `admin` to add a collaborator.
     * operationId: projects/add-collaborator
     * Request URI: /projects/{project_id}/collaborators/{username}
     */
    async projects$add$collaborator(params, option) {
        const url = this.baseUrl + `/projects/${params.parameter.project_id}/collaborators/${params.parameter.username}`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove user as a collaborator
     * Removes a collaborator from an organization project. You must be an organization owner or a project `admin` to remove a collaborator.
     * operationId: projects/remove-collaborator
     * Request URI: /projects/{project_id}/collaborators/{username}
     */
    async projects$remove$collaborator(params, option) {
        const url = this.baseUrl + `/projects/${params.parameter.project_id}/collaborators/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get project permission for a user
     * Returns the collaborator's permission level for an organization project. Possible values for the `permission` key: `admin`, `write`, `read`, `none`. You must be an organization owner or a project `admin` to review a user's permission level.
     * operationId: projects/get-permission-for-user
     * Request URI: /projects/{project_id}/collaborators/{username}/permission
     */
    async projects$get$permission$for$user(params, option) {
        const url = this.baseUrl + `/projects/${params.parameter.project_id}/collaborators/${params.parameter.username}/permission`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List project columns
     * operationId: projects/list-columns
     * Request URI: /projects/{project_id}/columns
     */
    async projects$list$columns(params, option) {
        const url = this.baseUrl + `/projects/${params.parameter.project_id}/columns`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a project column
     * operationId: projects/create-column
     * Request URI: /projects/{project_id}/columns
     */
    async projects$create$column(params, option) {
        const url = this.baseUrl + `/projects/${params.parameter.project_id}/columns`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get rate limit status for the authenticated user
     * **Note:** Accessing this endpoint does not count against your REST API rate limit.
     *
     * **Note:** The `rate` object is deprecated. If you're writing new API client code or updating existing code, you should use the `core` object instead of the `rate` object. The `core` object contains the same information that is present in the `rate` object.
     * operationId: rate-limit/get
     * Request URI: /rate_limit
     */
    async rate$limit$get(option) {
        const url = this.baseUrl + `/rate_limit`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Delete a reaction (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Reactions API. We recommend migrating your existing code to use the new delete reactions endpoints. For more information, see this [blog post](https://developer.github.com/changes/2020-02-26-new-delete-reactions-endpoints/).
     *
     * OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/), when deleting a [team discussion](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#discussions) or [team discussion comment](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#discussion-comments).
     * operationId: reactions/delete-legacy
     * Request URI: /reactions/{reaction_id}
     */
    async reactions$delete$legacy(params, option) {
        const url = this.baseUrl + `/reactions/${params.parameter.reaction_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get a repository
     * The `parent` and `source` objects are present when the repository is a fork. `parent` is the repository this repository was forked from, `source` is the ultimate source for the network.
     * operationId: repos/get
     * Request URI: /repos/{owner}/{repo}
     */
    async repos$get(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a repository
     * Deleting a repository requires admin access. If OAuth is used, the `delete_repo` scope is required.
     *
     * If an organization owner has configured the organization to prevent members from deleting organization-owned
     * repositories, you will get a `403 Forbidden` response.
     * operationId: repos/delete
     * Request URI: /repos/{owner}/{repo}
     */
    async repos$delete(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a repository
     * **Note**: To edit a repository's topics, use the [Replace all repository topics](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#replace-all-repository-topics) endpoint.
     * operationId: repos/update
     * Request URI: /repos/{owner}/{repo}
     */
    async repos$update(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List artifacts for a repository
     * Lists all artifacts for a repository. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     * operationId: actions/list-artifacts-for-repo
     * Request URI: /repos/{owner}/{repo}/actions/artifacts
     */
    async actions$list$artifacts$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/artifacts`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get an artifact
     * Gets a specific artifact for a workflow run. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     * operationId: actions/get-artifact
     * Request URI: /repos/{owner}/{repo}/actions/artifacts/{artifact_id}
     */
    async actions$get$artifact(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/artifacts/${params.parameter.artifact_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete an artifact
     * Deletes an artifact for a workflow run. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
     * operationId: actions/delete-artifact
     * Request URI: /repos/{owner}/{repo}/actions/artifacts/{artifact_id}
     */
    async actions$delete$artifact(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/artifacts/${params.parameter.artifact_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Download an artifact
     * Gets a redirect URL to download an archive for a repository. This URL expires after 1 minute. Look for `Location:` in
     * the response header to find the URL for the download. The `:archive_format` must be `zip`. Anyone with read access to
     * the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope.
     * GitHub Apps must have the `actions:read` permission to use this endpoint.
     * operationId: actions/download-artifact
     * Request URI: /repos/{owner}/{repo}/actions/artifacts/{artifact_id}/{archive_format}
     */
    async actions$download$artifact(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/artifacts/${params.parameter.artifact_id}/${params.parameter.archive_format}`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get a job for a workflow run
     * Gets a specific job in a workflow run. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     * operationId: actions/get-job-for-workflow-run
     * Request URI: /repos/{owner}/{repo}/actions/jobs/{job_id}
     */
    async actions$get$job$for$workflow$run(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/jobs/${params.parameter.job_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Download job logs for a workflow run
     * Gets a redirect URL to download a plain text file of logs for a workflow job. This link expires after 1 minute. Look
     * for `Location:` in the response header to find the URL for the download. Anyone with read access to the repository can
     * use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must
     * have the `actions:read` permission to use this endpoint.
     * operationId: actions/download-job-logs-for-workflow-run
     * Request URI: /repos/{owner}/{repo}/actions/jobs/{job_id}/logs
     */
    async actions$download$job$logs$for$workflow$run(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/jobs/${params.parameter.job_id}/logs`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get GitHub Actions permissions for a repository
     * Gets the GitHub Actions permissions policy for a repository, including whether GitHub Actions is enabled and the actions allowed to run in the repository.
     *
     * You must authenticate using an access token with the `repo` scope to use this
     * endpoint. GitHub Apps must have the `administration` repository permission to use this API.
     * operationId: actions/get-github-actions-permissions-repository
     * Request URI: /repos/{owner}/{repo}/actions/permissions
     */
    async actions$get$github$actions$permissions$repository(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/permissions`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set GitHub Actions permissions for a repository
     * Sets the GitHub Actions permissions policy for enabling GitHub Actions and allowed actions in the repository.
     *
     * If the repository belongs to an organization or enterprise that has set restrictive permissions at the organization or enterprise levels, such as `allowed_actions` to `selected` actions, then you cannot override them for the repository.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration` repository permission to use this API.
     * operationId: actions/set-github-actions-permissions-repository
     * Request URI: /repos/{owner}/{repo}/actions/permissions
     */
    async actions$set$github$actions$permissions$repository(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/permissions`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get allowed actions for a repository
     * Gets the settings for selected actions that are allowed in a repository. To use this endpoint, the repository policy for `allowed_actions` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for a repository](#set-github-actions-permissions-for-a-repository)."
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration` repository permission to use this API.
     * operationId: actions/get-allowed-actions-repository
     * Request URI: /repos/{owner}/{repo}/actions/permissions/selected-actions
     */
    async actions$get$allowed$actions$repository(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/permissions/selected-actions`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set allowed actions for a repository
     * Sets the actions that are allowed in a repository. To use this endpoint, the repository permission policy for `allowed_actions` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for a repository](#set-github-actions-permissions-for-a-repository)."
     *
     * If the repository belongs to an organization or enterprise that has `selected` actions set at the organization or enterprise levels, then you cannot override any of the allowed actions settings.
     *
     * To use the `patterns_allowed` setting for private repositories, the repository must belong to an enterprise. If the repository does not belong to an enterprise, then the `patterns_allowed` setting only applies to public repositories.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration` repository permission to use this API.
     * operationId: actions/set-allowed-actions-repository
     * Request URI: /repos/{owner}/{repo}/actions/permissions/selected-actions
     */
    async actions$set$allowed$actions$repository(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/permissions/selected-actions`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List self-hosted runners for a repository
     * Lists all self-hosted runners configured in a repository. You must authenticate using an access token with the `repo` scope to use this endpoint.
     * operationId: actions/list-self-hosted-runners-for-repo
     * Request URI: /repos/{owner}/{repo}/actions/runners
     */
    async actions$list$self$hosted$runners$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runners`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List runner applications for a repository
     * Lists binaries for the runner application that you can download and run.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint.
     * operationId: actions/list-runner-applications-for-repo
     * Request URI: /repos/{owner}/{repo}/actions/runners/downloads
     */
    async actions$list$runner$applications$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runners/downloads`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create a registration token for a repository
     * Returns a token that you can pass to the `config` script. The token expires after one hour. You must authenticate
     * using an access token with the `repo` scope to use this endpoint.
     *
     * #### Example using registration token
     *
     * Configure your self-hosted runner, replacing `TOKEN` with the registration token provided by this endpoint.
     *
     * ```
     * ./config.sh --url https://github.com/octo-org/octo-repo-artifacts --token TOKEN
     * ```
     * operationId: actions/create-registration-token-for-repo
     * Request URI: /repos/{owner}/{repo}/actions/runners/registration-token
     */
    async actions$create$registration$token$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runners/registration-token`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Create a remove token for a repository
     * Returns a token that you can pass to remove a self-hosted runner from a repository. The token expires after one hour.
     * You must authenticate using an access token with the `repo` scope to use this endpoint.
     *
     * #### Example using remove token
     *
     * To remove your self-hosted runner from a repository, replace TOKEN with the remove token provided by this endpoint.
     *
     * ```
     * ./config.sh remove --token TOKEN
     * ```
     * operationId: actions/create-remove-token-for-repo
     * Request URI: /repos/{owner}/{repo}/actions/runners/remove-token
     */
    async actions$create$remove$token$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runners/remove-token`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Get a self-hosted runner for a repository
     * Gets a specific self-hosted runner configured in a repository.
     *
     * You must authenticate using an access token with the `repo` scope to use this
     * endpoint.
     * operationId: actions/get-self-hosted-runner-for-repo
     * Request URI: /repos/{owner}/{repo}/actions/runners/{runner_id}
     */
    async actions$get$self$hosted$runner$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runners/${params.parameter.runner_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a self-hosted runner from a repository
     * Forces the removal of a self-hosted runner from a repository. You can use this endpoint to completely remove the runner when the machine you were using no longer exists.
     *
     * You must authenticate using an access token with the `repo`
     * scope to use this endpoint.
     * operationId: actions/delete-self-hosted-runner-from-repo
     * Request URI: /repos/{owner}/{repo}/actions/runners/{runner_id}
     */
    async actions$delete$self$hosted$runner$from$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runners/${params.parameter.runner_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List labels for a self-hosted runner for a repository
     * Lists all labels for a self-hosted runner configured in a repository.
     *
     * You must authenticate using an access token with the `repo` scope to use this
     * endpoint.
     * operationId: actions/list-labels-for-self-hosted-runner-for-repo
     * Request URI: /repos/{owner}/{repo}/actions/runners/{runner_id}/labels
     */
    async actions$list$labels$for$self$hosted$runner$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runners/${params.parameter.runner_id}/labels`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set custom labels for a self-hosted runner for a repository
     * Remove all previous custom labels and set the new custom labels for a specific
     * self-hosted runner configured in a repository.
     *
     * You must authenticate using an access token with the `repo` scope to use this
     * endpoint.
     * operationId: actions/set-custom-labels-for-self-hosted-runner-for-repo
     * Request URI: /repos/{owner}/{repo}/actions/runners/{runner_id}/labels
     */
    async actions$set$custom$labels$for$self$hosted$runner$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runners/${params.parameter.runner_id}/labels`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Add custom labels to a self-hosted runner for a repository
     * Add custom labels to a self-hosted runner configured in a repository.
     *
     * You must authenticate using an access token with the `repo` scope to use this
     * endpoint.
     * operationId: actions/add-custom-labels-to-self-hosted-runner-for-repo
     * Request URI: /repos/{owner}/{repo}/actions/runners/{runner_id}/labels
     */
    async actions$add$custom$labels$to$self$hosted$runner$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runners/${params.parameter.runner_id}/labels`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove all custom labels from a self-hosted runner for a repository
     * Remove all custom labels from a self-hosted runner configured in a
     * repository. Returns the remaining read-only labels from the runner.
     *
     * You must authenticate using an access token with the `repo` scope to use this
     * endpoint.
     * operationId: actions/remove-all-custom-labels-from-self-hosted-runner-for-repo
     * Request URI: /repos/{owner}/{repo}/actions/runners/{runner_id}/labels
     */
    async actions$remove$all$custom$labels$from$self$hosted$runner$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runners/${params.parameter.runner_id}/labels`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Remove a custom label from a self-hosted runner for a repository
     * Remove a custom label from a self-hosted runner configured
     * in a repository. Returns the remaining labels from the runner.
     *
     * This endpoint returns a `404 Not Found` status if the custom label is not
     * present on the runner.
     *
     * You must authenticate using an access token with the `repo` scope to use this
     * endpoint.
     * operationId: actions/remove-custom-label-from-self-hosted-runner-for-repo
     * Request URI: /repos/{owner}/{repo}/actions/runners/{runner_id}/labels/{name}
     */
    async actions$remove$custom$label$from$self$hosted$runner$for$repo(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runners/${params.parameter.runner_id}/labels/${params.parameter.name}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List workflow runs for a repository
     * Lists all workflow runs for a repository. You can use parameters to narrow the list of results. For more information about using parameters, see [Parameters](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#parameters).
     *
     * Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     * operationId: actions/list-workflow-runs-for-repo
     * Request URI: /repos/{owner}/{repo}/actions/runs
     */
    async actions$list$workflow$runs$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runs`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            actor: { value: params.parameter.actor, explode: false },
            branch: { value: params.parameter.branch, explode: false },
            event: { value: params.parameter.event, explode: false },
            status: { value: params.parameter.status, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
            created: { value: params.parameter.created, explode: false },
            exclude_pull_requests: { value: params.parameter.exclude_pull_requests, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a workflow run
     * Gets a specific workflow run. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     * operationId: actions/get-workflow-run
     * Request URI: /repos/{owner}/{repo}/actions/runs/{run_id}
     */
    async actions$get$workflow$run(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runs/${params.parameter.run_id}`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            exclude_pull_requests: { value: params.parameter.exclude_pull_requests, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Delete a workflow run
     * Delete a specific workflow run. Anyone with write access to the repository can use this endpoint. If the repository is
     * private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:write` permission to use
     * this endpoint.
     * operationId: actions/delete-workflow-run
     * Request URI: /repos/{owner}/{repo}/actions/runs/{run_id}
     */
    async actions$delete$workflow$run(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runs/${params.parameter.run_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get the review history for a workflow run
     * Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     * operationId: actions/get-reviews-for-run
     * Request URI: /repos/{owner}/{repo}/actions/runs/{run_id}/approvals
     */
    async actions$get$reviews$for$run(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runs/${params.parameter.run_id}/approvals`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List workflow run artifacts
     * Lists artifacts for a workflow run. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     * operationId: actions/list-workflow-run-artifacts
     * Request URI: /repos/{owner}/{repo}/actions/runs/{run_id}/artifacts
     */
    async actions$list$workflow$run$artifacts(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runs/${params.parameter.run_id}/artifacts`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Cancel a workflow run
     * Cancels a workflow run using its `id`. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
     * operationId: actions/cancel-workflow-run
     * Request URI: /repos/{owner}/{repo}/actions/runs/{run_id}/cancel
     */
    async actions$cancel$workflow$run(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runs/${params.parameter.run_id}/cancel`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * List jobs for a workflow run
     * Lists jobs for a workflow run. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint. You can use parameters to narrow the list of results. For more information about using parameters, see [Parameters](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#parameters).
     * operationId: actions/list-jobs-for-workflow-run
     * Request URI: /repos/{owner}/{repo}/actions/runs/{run_id}/jobs
     */
    async actions$list$jobs$for$workflow$run(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runs/${params.parameter.run_id}/jobs`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filter: { value: params.parameter.filter, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Download workflow run logs
     * Gets a redirect URL to download an archive of log files for a workflow run. This link expires after 1 minute. Look for
     * `Location:` in the response header to find the URL for the download. Anyone with read access to the repository can use
     * this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have
     * the `actions:read` permission to use this endpoint.
     * operationId: actions/download-workflow-run-logs
     * Request URI: /repos/{owner}/{repo}/actions/runs/{run_id}/logs
     */
    async actions$download$workflow$run$logs(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runs/${params.parameter.run_id}/logs`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete workflow run logs
     * Deletes all logs for a workflow run. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
     * operationId: actions/delete-workflow-run-logs
     * Request URI: /repos/{owner}/{repo}/actions/runs/{run_id}/logs
     */
    async actions$delete$workflow$run$logs(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runs/${params.parameter.run_id}/logs`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get pending deployments for a workflow run
     * Get all deployment environments for a workflow run that are waiting for protection rules to pass.
     *
     * Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     * operationId: actions/get-pending-deployments-for-run
     * Request URI: /repos/{owner}/{repo}/actions/runs/{run_id}/pending_deployments
     */
    async actions$get$pending$deployments$for$run(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runs/${params.parameter.run_id}/pending_deployments`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Review pending deployments for a workflow run
     * Approve or reject pending deployments that are waiting on approval by a required reviewer.
     *
     * Anyone with read access to the repository contents and deployments can use this endpoint.
     * operationId: actions/review-pending-deployments-for-run
     * Request URI: /repos/{owner}/{repo}/actions/runs/{run_id}/pending_deployments
     */
    async actions$review$pending$deployments$for$run(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runs/${params.parameter.run_id}/pending_deployments`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * @deprecated
     * Re-run a workflow
     * Re-runs your workflow run using its `id`. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
     * operationId: actions/re-run-workflow
     * Request URI: /repos/{owner}/{repo}/actions/runs/{run_id}/rerun
     */
    async actions$re$run$workflow(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/runs/${params.parameter.run_id}/rerun`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * List repository secrets
     * Lists all secrets available in a repository without revealing their encrypted values. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     * operationId: actions/list-repo-secrets
     * Request URI: /repos/{owner}/{repo}/actions/secrets
     */
    async actions$list$repo$secrets(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/secrets`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a repository public key
     * Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     * operationId: actions/get-repo-public-key
     * Request URI: /repos/{owner}/{repo}/actions/secrets/public-key
     */
    async actions$get$repo$public$key(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/secrets/public-key`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get a repository secret
     * Gets a single repository secret without revealing its encrypted value. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     * operationId: actions/get-repo-secret
     * Request URI: /repos/{owner}/{repo}/actions/secrets/{secret_name}
     */
    async actions$get$repo$secret(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/secrets/${params.parameter.secret_name}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create or update a repository secret
     * Creates or updates a repository secret with an encrypted value. Encrypt your secret using
     * [LibSodium](https://libsodium.gitbook.io/doc/bindings_for_other_languages). You must authenticate using an access
     * token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use
     * this endpoint.
     *
     * #### Example encrypting a secret using Node.js
     *
     * Encrypt your secret using the [tweetsodium](https://github.com/github/tweetsodium) library.
     *
     * ```
     * const sodium = require('tweetsodium');
     *
     * const key = "base64-encoded-public-key";
     * const value = "plain-text-secret";
     *
     * // Convert the message and key to Uint8Array's (Buffer implements that interface)
     * const messageBytes = Buffer.from(value);
     * const keyBytes = Buffer.from(key, 'base64');
     *
     * // Encrypt using LibSodium.
     * const encryptedBytes = sodium.seal(messageBytes, keyBytes);
     *
     * // Base64 the encrypted secret
     * const encrypted = Buffer.from(encryptedBytes).toString('base64');
     *
     * console.log(encrypted);
     * ```
     *
     *
     * #### Example encrypting a secret using Python
     *
     * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
     *
     * ```
     * from base64 import b64encode
     * from nacl import encoding, public
     *
     * def encrypt(public_key: str, secret_value: str) -> str:
     *   """Encrypt a Unicode string using the public key."""
     *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
     *   sealed_box = public.SealedBox(public_key)
     *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
     *   return b64encode(encrypted).decode("utf-8")
     * ```
     *
     * #### Example encrypting a secret using C#
     *
     * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
     *
     * ```
     * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
     * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
     *
     * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
     *
     * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
     * ```
     *
     * #### Example encrypting a secret using Ruby
     *
     * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
     *
     * ```ruby
     * require "rbnacl"
     * require "base64"
     *
     * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
     * public_key = RbNaCl::PublicKey.new(key)
     *
     * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
     * encrypted_secret = box.encrypt("my_secret")
     *
     * # Print the base64 encoded secret
     * puts Base64.strict_encode64(encrypted_secret)
     * ```
     * operationId: actions/create-or-update-repo-secret
     * Request URI: /repos/{owner}/{repo}/actions/secrets/{secret_name}
     */
    async actions$create$or$update$repo$secret(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/secrets/${params.parameter.secret_name}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete a repository secret
     * Deletes a secret in a repository using the secret name. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     * operationId: actions/delete-repo-secret
     * Request URI: /repos/{owner}/{repo}/actions/secrets/{secret_name}
     */
    async actions$delete$repo$secret(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/secrets/${params.parameter.secret_name}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List repository workflows
     * Lists the workflows in a repository. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     * operationId: actions/list-repo-workflows
     * Request URI: /repos/{owner}/{repo}/actions/workflows
     */
    async actions$list$repo$workflows(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/workflows`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a workflow
     * Gets a specific workflow. You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     * operationId: actions/get-workflow
     * Request URI: /repos/{owner}/{repo}/actions/workflows/{workflow_id}
     */
    async actions$get$workflow(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/workflows/${params.parameter.workflow_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Disable a workflow
     * Disables a workflow and sets the `state` of the workflow to `disabled_manually`. You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
     * operationId: actions/disable-workflow
     * Request URI: /repos/{owner}/{repo}/actions/workflows/{workflow_id}/disable
     */
    async actions$disable$workflow(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/workflows/${params.parameter.workflow_id}/disable`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Create a workflow dispatch event
     * You can use this endpoint to manually trigger a GitHub Actions workflow run. You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`.
     *
     * You must configure your GitHub Actions workflow to run when the [`workflow_dispatch` webhook](/developers/webhooks-and-events/webhook-events-and-payloads#workflow_dispatch) event occurs. The `inputs` are configured in the workflow file. For more information about how to configure the `workflow_dispatch` event in the workflow file, see "[Events that trigger workflows](/actions/reference/events-that-trigger-workflows#workflow_dispatch)."
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint. For more information, see "[Creating a personal access token for the command line](https://docs.github.com/articles/creating-a-personal-access-token-for-the-command-line)."
     * operationId: actions/create-workflow-dispatch
     * Request URI: /repos/{owner}/{repo}/actions/workflows/{workflow_id}/dispatches
     */
    async actions$create$workflow$dispatch(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/workflows/${params.parameter.workflow_id}/dispatches`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Enable a workflow
     * Enables a workflow and sets the `state` of the workflow to `active`. You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
     * operationId: actions/enable-workflow
     * Request URI: /repos/{owner}/{repo}/actions/workflows/{workflow_id}/enable
     */
    async actions$enable$workflow(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/workflows/${params.parameter.workflow_id}/enable`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * List workflow runs
     * List all workflow runs for a workflow. You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`. You can use parameters to narrow the list of results. For more information about using parameters, see [Parameters](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#parameters).
     *
     * Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope.
     * operationId: actions/list-workflow-runs
     * Request URI: /repos/{owner}/{repo}/actions/workflows/{workflow_id}/runs
     */
    async actions$list$workflow$runs(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/actions/workflows/${params.parameter.workflow_id}/runs`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            actor: { value: params.parameter.actor, explode: false },
            branch: { value: params.parameter.branch, explode: false },
            event: { value: params.parameter.event, explode: false },
            status: { value: params.parameter.status, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
            created: { value: params.parameter.created, explode: false },
            exclude_pull_requests: { value: params.parameter.exclude_pull_requests, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List assignees
     * Lists the [available assignees](https://docs.github.com/articles/assigning-issues-and-pull-requests-to-other-github-users/) for issues in a repository.
     * operationId: issues/list-assignees
     * Request URI: /repos/{owner}/{repo}/assignees
     */
    async issues$list$assignees(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/assignees`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Check if a user can be assigned
     * Checks if a user has permission to be assigned to an issue in this repository.
     *
     * If the `assignee` can be assigned to issues in the repository, a `204` header with no content is returned.
     *
     * Otherwise a `404` status code is returned.
     * operationId: issues/check-user-can-be-assigned
     * Request URI: /repos/{owner}/{repo}/assignees/{assignee}
     */
    async issues$check$user$can$be$assigned(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/assignees/${params.parameter.assignee}`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List all autolinks of a repository
     * This returns a list of autolinks configured for the given repository.
     *
     * Information about autolinks are only available to repository administrators.
     * operationId: repos/list-autolinks
     * Request URI: /repos/{owner}/{repo}/autolinks
     */
    async repos$list$autolinks(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/autolinks`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create an autolink reference for a repository
     * Users with admin access to the repository can create an autolink.
     * operationId: repos/create-autolink
     * Request URI: /repos/{owner}/{repo}/autolinks
     */
    async repos$create$autolink(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/autolinks`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get an autolink reference of a repository
     * This returns a single autolink reference by ID that was configured for the given repository.
     *
     * Information about autolinks are only available to repository administrators.
     * operationId: repos/get-autolink
     * Request URI: /repos/{owner}/{repo}/autolinks/{autolink_id}
     */
    async repos$get$autolink(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/autolinks/${params.parameter.autolink_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete an autolink reference from a repository
     * This deletes a single autolink reference by ID that was configured for the given repository.
     *
     * Information about autolinks are only available to repository administrators.
     * operationId: repos/delete-autolink
     * Request URI: /repos/{owner}/{repo}/autolinks/{autolink_id}
     */
    async repos$delete$autolink(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/autolinks/${params.parameter.autolink_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List branches
     * operationId: repos/list-branches
     * Request URI: /repos/{owner}/{repo}/branches
     */
    async repos$list$branches(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/branches`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            protected: { value: params.parameter.protected, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a branch
     * operationId: repos/get-branch
     * Request URI: /repos/{owner}/{repo}/branches/{branch}
     */
    async repos$get$branch(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get branch protection
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     * operationId: repos/get-branch-protection
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection
     */
    async repos$get$branch$protection(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update branch protection
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Protecting a branch requires admin or owner permissions to the repository.
     *
     * **Note**: Passing new arrays of `users` and `teams` replaces their previous values.
     *
     * **Note**: The list of users, apps, and teams in total is limited to 100 items.
     * operationId: repos/update-branch-protection
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection
     */
    async repos$update$branch$protection(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete branch protection
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     * operationId: repos/delete-branch-protection
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection
     */
    async repos$delete$branch$protection(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get admin branch protection
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     * operationId: repos/get-admin-branch-protection
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/enforce_admins
     */
    async repos$get$admin$branch$protection(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/enforce_admins`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set admin branch protection
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Adding admin enforcement requires admin or owner permissions to the repository and branch protection to be enabled.
     * operationId: repos/set-admin-branch-protection
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/enforce_admins
     */
    async repos$set$admin$branch$protection(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/enforce_admins`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Delete admin branch protection
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Removing admin enforcement requires admin or owner permissions to the repository and branch protection to be enabled.
     * operationId: repos/delete-admin-branch-protection
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/enforce_admins
     */
    async repos$delete$admin$branch$protection(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/enforce_admins`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get pull request review protection
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     * operationId: repos/get-pull-request-review-protection
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/required_pull_request_reviews
     */
    async repos$get$pull$request$review$protection(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/required_pull_request_reviews`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete pull request review protection
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     * operationId: repos/delete-pull-request-review-protection
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/required_pull_request_reviews
     */
    async repos$delete$pull$request$review$protection(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/required_pull_request_reviews`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update pull request review protection
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Updating pull request review enforcement requires admin or owner permissions to the repository and branch protection to be enabled.
     *
     * **Note**: Passing new arrays of `users` and `teams` replaces their previous values.
     * operationId: repos/update-pull-request-review-protection
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/required_pull_request_reviews
     */
    async repos$update$pull$request$review$protection(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/required_pull_request_reviews`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get commit signature protection
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * When authenticated with admin or owner permissions to the repository, you can use this endpoint to check whether a branch requires signed commits. An enabled status of `true` indicates you must sign commits on this branch. For more information, see [Signing commits with GPG](https://docs.github.com/articles/signing-commits-with-gpg) in GitHub Help.
     *
     * **Note**: You must enable branch protection to require signed commits.
     * operationId: repos/get-commit-signature-protection
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/required_signatures
     */
    async repos$get$commit$signature$protection(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/required_signatures`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create commit signature protection
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * When authenticated with admin or owner permissions to the repository, you can use this endpoint to require signed commits on a branch. You must enable branch protection to require signed commits.
     * operationId: repos/create-commit-signature-protection
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/required_signatures
     */
    async repos$create$commit$signature$protection(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/required_signatures`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Delete commit signature protection
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * When authenticated with admin or owner permissions to the repository, you can use this endpoint to disable required signed commits on a branch. You must enable branch protection to require signed commits.
     * operationId: repos/delete-commit-signature-protection
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/required_signatures
     */
    async repos$delete$commit$signature$protection(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/required_signatures`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get status checks protection
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     * operationId: repos/get-status-checks-protection
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks
     */
    async repos$get$status$checks$protection(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/required_status_checks`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Remove status check protection
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     * operationId: repos/remove-status-check-protection
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks
     */
    async repos$remove$status$check$protection(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/required_status_checks`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update status check protection
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Updating required status checks requires admin or owner permissions to the repository and branch protection to be enabled.
     * operationId: repos/update-status-check-protection
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks
     */
    async repos$update$status$check$protection(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/required_status_checks`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get all status check contexts
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     * operationId: repos/get-all-status-check-contexts
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks/contexts
     */
    async repos$get$all$status$check$contexts(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/required_status_checks/contexts`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set status check contexts
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     * operationId: repos/set-status-check-contexts
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks/contexts
     */
    async repos$set$status$check$contexts(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/required_status_checks/contexts`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Add status check contexts
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     * operationId: repos/add-status-check-contexts
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks/contexts
     */
    async repos$add$status$check$contexts(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/required_status_checks/contexts`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove status check contexts
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     * operationId: repos/remove-status-check-contexts
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks/contexts
     */
    async repos$remove$status$check$contexts(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/required_status_checks/contexts`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get access restrictions
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Lists who has access to this protected branch.
     *
     * **Note**: Users, apps, and teams `restrictions` are only available for organization-owned repositories.
     * operationId: repos/get-access-restrictions
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/restrictions
     */
    async repos$get$access$restrictions(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/restrictions`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete access restrictions
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Disables the ability to restrict who can push to this branch.
     * operationId: repos/delete-access-restrictions
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/restrictions
     */
    async repos$delete$access$restrictions(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/restrictions`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get apps with access to the protected branch
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Lists the GitHub Apps that have push access to this branch. Only installed GitHub Apps with `write` access to the `contents` permission can be added as authorized actors on a protected branch.
     * operationId: repos/get-apps-with-access-to-protected-branch
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/apps
     */
    async repos$get$apps$with$access$to$protected$branch(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/restrictions/apps`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set app access restrictions
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Replaces the list of apps that have push access to this branch. This removes all apps that previously had push access and grants push access to the new list of apps. Only installed GitHub Apps with `write` access to the `contents` permission can be added as authorized actors on a protected branch.
     *
     * | Type    | Description                                                                                                                                                |
     * | ------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------- |
     * | `array` | The GitHub Apps that have push access to this branch. Use the app's `slug`. **Note**: The list of users, apps, and teams in total is limited to 100 items. |
     * operationId: repos/set-app-access-restrictions
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/apps
     */
    async repos$set$app$access$restrictions(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/restrictions/apps`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Add app access restrictions
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Grants the specified apps push access for this branch. Only installed GitHub Apps with `write` access to the `contents` permission can be added as authorized actors on a protected branch.
     *
     * | Type    | Description                                                                                                                                                |
     * | ------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------- |
     * | `array` | The GitHub Apps that have push access to this branch. Use the app's `slug`. **Note**: The list of users, apps, and teams in total is limited to 100 items. |
     * operationId: repos/add-app-access-restrictions
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/apps
     */
    async repos$add$app$access$restrictions(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/restrictions/apps`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove app access restrictions
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Removes the ability of an app to push to this branch. Only installed GitHub Apps with `write` access to the `contents` permission can be added as authorized actors on a protected branch.
     *
     * | Type    | Description                                                                                                                                                |
     * | ------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------- |
     * | `array` | The GitHub Apps that have push access to this branch. Use the app's `slug`. **Note**: The list of users, apps, and teams in total is limited to 100 items. |
     * operationId: repos/remove-app-access-restrictions
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/apps
     */
    async repos$remove$app$access$restrictions(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/restrictions/apps`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get teams with access to the protected branch
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Lists the teams who have push access to this branch. The list includes child teams.
     * operationId: repos/get-teams-with-access-to-protected-branch
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/teams
     */
    async repos$get$teams$with$access$to$protected$branch(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/restrictions/teams`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set team access restrictions
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Replaces the list of teams that have push access to this branch. This removes all teams that previously had push access and grants push access to the new list of teams. Team restrictions include child teams.
     *
     * | Type    | Description                                                                                                                                |
     * | ------- | ------------------------------------------------------------------------------------------------------------------------------------------ |
     * | `array` | The teams that can have push access. Use the team's `slug`. **Note**: The list of users, apps, and teams in total is limited to 100 items. |
     * operationId: repos/set-team-access-restrictions
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/teams
     */
    async repos$set$team$access$restrictions(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/restrictions/teams`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Add team access restrictions
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Grants the specified teams push access for this branch. You can also give push access to child teams.
     *
     * | Type    | Description                                                                                                                                |
     * | ------- | ------------------------------------------------------------------------------------------------------------------------------------------ |
     * | `array` | The teams that can have push access. Use the team's `slug`. **Note**: The list of users, apps, and teams in total is limited to 100 items. |
     * operationId: repos/add-team-access-restrictions
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/teams
     */
    async repos$add$team$access$restrictions(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/restrictions/teams`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove team access restrictions
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Removes the ability of a team to push to this branch. You can also remove push access for child teams.
     *
     * | Type    | Description                                                                                                                                         |
     * | ------- | --------------------------------------------------------------------------------------------------------------------------------------------------- |
     * | `array` | Teams that should no longer have push access. Use the team's `slug`. **Note**: The list of users, apps, and teams in total is limited to 100 items. |
     * operationId: repos/remove-team-access-restrictions
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/teams
     */
    async repos$remove$team$access$restrictions(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/restrictions/teams`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get users with access to the protected branch
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Lists the people who have push access to this branch.
     * operationId: repos/get-users-with-access-to-protected-branch
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/users
     */
    async repos$get$users$with$access$to$protected$branch(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/restrictions/users`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set user access restrictions
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Replaces the list of people that have push access to this branch. This removes all people that previously had push access and grants push access to the new list of people.
     *
     * | Type    | Description                                                                                                                   |
     * | ------- | ----------------------------------------------------------------------------------------------------------------------------- |
     * | `array` | Usernames for people who can have push access. **Note**: The list of users, apps, and teams in total is limited to 100 items. |
     * operationId: repos/set-user-access-restrictions
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/users
     */
    async repos$set$user$access$restrictions(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/restrictions/users`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Add user access restrictions
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Grants the specified people push access for this branch.
     *
     * | Type    | Description                                                                                                                   |
     * | ------- | ----------------------------------------------------------------------------------------------------------------------------- |
     * | `array` | Usernames for people who can have push access. **Note**: The list of users, apps, and teams in total is limited to 100 items. |
     * operationId: repos/add-user-access-restrictions
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/users
     */
    async repos$add$user$access$restrictions(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/restrictions/users`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove user access restrictions
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Removes the ability of a user to push to this branch.
     *
     * | Type    | Description                                                                                                                                   |
     * | ------- | --------------------------------------------------------------------------------------------------------------------------------------------- |
     * | `array` | Usernames of the people who should no longer have push access. **Note**: The list of users, apps, and teams in total is limited to 100 items. |
     * operationId: repos/remove-user-access-restrictions
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/users
     */
    async repos$remove$user$access$restrictions(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/protection/restrictions/users`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Rename a branch
     * Renames a branch in a repository.
     *
     * **Note:** Although the API responds immediately, the branch rename process might take some extra time to complete in the background. You won't be able to push to the old branch name while the rename process is in progress. For more information, see "[Renaming a branch](https://docs.github.com/enterprise-server@3.4/github/administering-a-repository/renaming-a-branch)".
     *
     * The permissions required to use this endpoint depends on whether you are renaming the default branch.
     *
     * To rename a non-default branch:
     *
     * * Users must have push access.
     * * GitHub Apps must have the `contents:write` repository permission.
     *
     * To rename the default branch:
     *
     * * Users must have admin or owner permissions.
     * * GitHub Apps must have the `administration:write` repository permission.
     * operationId: repos/rename-branch
     * Request URI: /repos/{owner}/{repo}/branches/{branch}/rename
     */
    async repos$rename$branch(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/branches/${params.parameter.branch}/rename`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Create a check run
     * **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
     *
     * Creates a new check run for a specific commit in a repository. Your GitHub App must have the `checks:write` permission to create check runs.
     *
     * In a check suite, GitHub limits the number of check runs with the same name to 1000. Once these check runs exceed 1000, GitHub will start to automatically delete older check runs.
     * operationId: checks/create
     * Request URI: /repos/{owner}/{repo}/check-runs
     */
    async checks$create(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/check-runs`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a check run
     * **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
     *
     * Gets a single check run using its `id`. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to get check runs. OAuth Apps and authenticated users must have the `repo` scope to get check runs in a private repository.
     * operationId: checks/get
     * Request URI: /repos/{owner}/{repo}/check-runs/{check_run_id}
     */
    async checks$get(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/check-runs/${params.parameter.check_run_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update a check run
     * **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
     *
     * Updates a check run for a specific commit in a repository. Your GitHub App must have the `checks:write` permission to edit check runs.
     * operationId: checks/update
     * Request URI: /repos/{owner}/{repo}/check-runs/{check_run_id}
     */
    async checks$update(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/check-runs/${params.parameter.check_run_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List check run annotations
     * Lists annotations for a check run using the annotation `id`. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to get annotations for a check run. OAuth Apps and authenticated users must have the `repo` scope to get annotations for a check run in a private repository.
     * operationId: checks/list-annotations
     * Request URI: /repos/{owner}/{repo}/check-runs/{check_run_id}/annotations
     */
    async checks$list$annotations(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/check-runs/${params.parameter.check_run_id}/annotations`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Rerequest a check run
     * Triggers GitHub to rerequest an existing check run, without pushing new code to a repository. This endpoint will trigger the [`check_run` webhook](https://docs.github.com/enterprise-server@3.4/webhooks/event-payloads/#check_run) event with the action `rerequested`. When a check run is `rerequested`, its `status` is reset to `queued` and the `conclusion` is cleared.
     *
     * To rerequest a check run, your GitHub App must have the `checks:read` permission on a private repository or pull access to a public repository.
     * operationId: checks/rerequest-run
     * Request URI: /repos/{owner}/{repo}/check-runs/{check_run_id}/rerequest
     */
    async checks$rerequest$run(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/check-runs/${params.parameter.check_run_id}/rerequest`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Create a check suite
     * **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array and a `null` value for `head_branch`.
     *
     * By default, check suites are automatically created when you create a [check run](https://docs.github.com/enterprise-server@3.4/rest/reference/checks#check-runs). You only need to use this endpoint for manually creating check suites when you've disabled automatic creation using "[Update repository preferences for check suites](https://docs.github.com/enterprise-server@3.4/rest/reference/checks#update-repository-preferences-for-check-suites)". Your GitHub App must have the `checks:write` permission to create check suites.
     * operationId: checks/create-suite
     * Request URI: /repos/{owner}/{repo}/check-suites
     */
    async checks$create$suite(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/check-suites`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Update repository preferences for check suites
     * Changes the default automatic flow when creating check suites. By default, a check suite is automatically created each time code is pushed to a repository. When you disable the automatic creation of check suites, you can manually [Create a check suite](https://docs.github.com/enterprise-server@3.4/rest/reference/checks#create-a-check-suite). You must have admin permissions in the repository to set preferences for check suites.
     * operationId: checks/set-suites-preferences
     * Request URI: /repos/{owner}/{repo}/check-suites/preferences
     */
    async checks$set$suites$preferences(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/check-suites/preferences`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a check suite
     * **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array and a `null` value for `head_branch`.
     *
     * Gets a single check suite using its `id`. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to get check suites. OAuth Apps and authenticated users must have the `repo` scope to get check suites in a private repository.
     * operationId: checks/get-suite
     * Request URI: /repos/{owner}/{repo}/check-suites/{check_suite_id}
     */
    async checks$get$suite(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/check-suites/${params.parameter.check_suite_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List check runs in a check suite
     * **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
     *
     * Lists check runs for a check suite using its `id`. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to get check runs. OAuth Apps and authenticated users must have the `repo` scope to get check runs in a private repository.
     * operationId: checks/list-for-suite
     * Request URI: /repos/{owner}/{repo}/check-suites/{check_suite_id}/check-runs
     */
    async checks$list$for$suite(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/check-suites/${params.parameter.check_suite_id}/check-runs`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            check_name: { value: params.parameter.check_name, explode: false },
            status: { value: params.parameter.status, explode: false },
            filter: { value: params.parameter.filter, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Rerequest a check suite
     * Triggers GitHub to rerequest an existing check suite, without pushing new code to a repository. This endpoint will trigger the [`check_suite` webhook](https://docs.github.com/enterprise-server@3.4/webhooks/event-payloads/#check_suite) event with the action `rerequested`. When a check suite is `rerequested`, its `status` is reset to `queued` and the `conclusion` is cleared.
     *
     * To rerequest a check suite, your GitHub App must have the `checks:read` permission on a private repository or pull access to a public repository.
     * operationId: checks/rerequest-suite
     * Request URI: /repos/{owner}/{repo}/check-suites/{check_suite_id}/rerequest
     */
    async checks$rerequest$suite(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/check-suites/${params.parameter.check_suite_id}/rerequest`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * List code scanning alerts for a repository
     * Lists all open code scanning alerts for the default branch (usually `main`
     * or `master`). You must use an access token with the `security_events` scope to use
     * this endpoint with private repos, the `public_repo` scope also grants permission to read
     * security events on public repos only. GitHub Apps must have the `security_events` read
     * permission to use this endpoint.
     *
     * The response includes a `most_recent_instance` object.
     * This provides details of the most recent instance of this alert
     * for the default branch or for the specified Git reference
     * (if you used `ref` in the request).
     * operationId: code-scanning/list-alerts-for-repo
     * Request URI: /repos/{owner}/{repo}/code-scanning/alerts
     */
    async code$scanning$list$alerts$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/code-scanning/alerts`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            tool_name: { value: params.parameter.tool_name, explode: false },
            tool_guid: { value: params.parameter.tool_guid, explode: false },
            page: { value: params.parameter.page, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            ref: { value: params.parameter.ref, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            state: { value: params.parameter.state, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a code scanning alert
     * Gets a single code scanning alert. You must use an access token with the `security_events` scope to use this endpoint with private repos, the `public_repo` scope also grants permission to read security events on public repos only. GitHub Apps must have the `security_events` read permission to use this endpoint.
     *
     * **Deprecation notice**:
     * The instances field is deprecated and will, in future, not be included in the response for this endpoint. The example response reflects this change. The same information can now be retrieved via a GET request to the URL specified by `instances_url`.
     * operationId: code-scanning/get-alert
     * Request URI: /repos/{owner}/{repo}/code-scanning/alerts/{alert_number}
     */
    async code$scanning$get$alert(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/code-scanning/alerts/${params.parameter.alert_number}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update a code scanning alert
     * Updates the status of a single code scanning alert. You must use an access token with the `security_events` scope to use this endpoint with private repositories. You can also use tokens with the `public_repo` scope for public repositories only. GitHub Apps must have the `security_events` write permission to use this endpoint.
     * operationId: code-scanning/update-alert
     * Request URI: /repos/{owner}/{repo}/code-scanning/alerts/{alert_number}
     */
    async code$scanning$update$alert(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/code-scanning/alerts/${params.parameter.alert_number}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List instances of a code scanning alert
     * Lists all instances of the specified code scanning alert.
     * You must use an access token with the `security_events` scope to use this endpoint with private repos,
     * the `public_repo` scope also grants permission to read security events on public repos only.
     * GitHub Apps must have the `security_events` read permission to use this endpoint.
     * operationId: code-scanning/list-alert-instances
     * Request URI: /repos/{owner}/{repo}/code-scanning/alerts/{alert_number}/instances
     */
    async code$scanning$list$alert$instances(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/code-scanning/alerts/${params.parameter.alert_number}/instances`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            page: { value: params.parameter.page, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            ref: { value: params.parameter.ref, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List code scanning analyses for a repository
     * Lists the details of all code scanning analyses for a repository,
     * starting with the most recent.
     * The response is paginated and you can use the `page` and `per_page` parameters
     * to list the analyses you're interested in.
     * By default 30 analyses are listed per page.
     *
     * The `rules_count` field in the response give the number of rules
     * that were run in the analysis.
     * For very old analyses this data is not available,
     * and `0` is returned in this field.
     *
     * You must use an access token with the `security_events` scope to use this endpoint with private repos,
     * the `public_repo` scope also grants permission to read security events on public repos only.
     * GitHub Apps must have the `security_events` read permission to use this endpoint.
     *
     * **Deprecation notice**:
     * The `tool_name` field is deprecated and will, in future, not be included in the response for this endpoint. The example response reflects this change. The tool name can now be found inside the `tool` field.
     * operationId: code-scanning/list-recent-analyses
     * Request URI: /repos/{owner}/{repo}/code-scanning/analyses
     */
    async code$scanning$list$recent$analyses(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/code-scanning/analyses`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            tool_name: { value: params.parameter.tool_name, explode: false },
            tool_guid: { value: params.parameter.tool_guid, explode: false },
            page: { value: params.parameter.page, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            ref: { value: params.parameter.ref, explode: false },
            sarif_id: { value: params.parameter.sarif_id, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a code scanning analysis for a repository
     * Gets a specified code scanning analysis for a repository.
     * You must use an access token with the `security_events` scope to use this endpoint with private repos,
     * the `public_repo` scope also grants permission to read security events on public repos only.
     * GitHub Apps must have the `security_events` read permission to use this endpoint.
     *
     * The default JSON response contains fields that describe the analysis.
     * This includes the Git reference and commit SHA to which the analysis relates,
     * the datetime of the analysis, the name of the code scanning tool,
     * and the number of alerts.
     *
     * The `rules_count` field in the default response give the number of rules
     * that were run in the analysis.
     * For very old analyses this data is not available,
     * and `0` is returned in this field.
     *
     * If you use the Accept header `application/sarif+json`,
     * the response contains the analysis data that was uploaded.
     * This is formatted as
     * [SARIF version 2.1.0](https://docs.oasis-open.org/sarif/sarif/v2.1.0/cs01/sarif-v2.1.0-cs01.html).
     * operationId: code-scanning/get-analysis
     * Request URI: /repos/{owner}/{repo}/code-scanning/analyses/{analysis_id}
     */
    async code$scanning$get$analysis(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/code-scanning/analyses/${params.parameter.analysis_id}`;
        const headers = {
            Accept: params.headers.Accept,
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a code scanning analysis from a repository
     * Deletes a specified code scanning analysis from a repository. For
     * private repositories, you must use an access token with the `repo` scope. For public repositories,
     * you must use an access token with `public_repo` scope.
     * GitHub Apps must have the `security_events` write permission to use this endpoint.
     *
     * You can delete one analysis at a time.
     * To delete a series of analyses, start with the most recent analysis and work backwards.
     * Conceptually, the process is similar to the undo function in a text editor.
     *
     * When you list the analyses for a repository,
     * one or more will be identified as deletable in the response:
     *
     * ```
     * "deletable": true
     * ```
     *
     * An analysis is deletable when it's the most recent in a set of analyses.
     * Typically, a repository will have multiple sets of analyses
     * for each enabled code scanning tool,
     * where a set is determined by a unique combination of analysis values:
     *
     * * `ref`
     * * `tool`
     * * `analysis_key`
     * * `environment`
     *
     * If you attempt to delete an analysis that is not the most recent in a set,
     * you'll get a 400 response with the message:
     *
     * ```
     * Analysis specified is not deletable.
     * ```
     *
     * The response from a successful `DELETE` operation provides you with
     * two alternative URLs for deleting the next analysis in the set:
     * `next_analysis_url` and `confirm_delete_url`.
     * Use the `next_analysis_url` URL if you want to avoid accidentally deleting the final analysis
     * in a set. This is a useful option if you want to preserve at least one analysis
     * for the specified tool in your repository.
     * Use the `confirm_delete_url` URL if you are content to remove all analyses for a tool.
     * When you delete the last analysis in a set, the value of `next_analysis_url` and `confirm_delete_url`
     * in the 200 response is `null`.
     *
     * As an example of the deletion process,
     * let's imagine that you added a workflow that configured a particular code scanning tool
     * to analyze the code in a repository. This tool has added 15 analyses:
     * 10 on the default branch, and another 5 on a topic branch.
     * You therefore have two separate sets of analyses for this tool.
     * You've now decided that you want to remove all of the analyses for the tool.
     * To do this you must make 15 separate deletion requests.
     * To start, you must find an analysis that's identified as deletable.
     * Each set of analyses always has one that's identified as deletable.
     * Having found the deletable analysis for one of the two sets,
     * delete this analysis and then continue deleting the next analysis in the set until they're all deleted.
     * Then repeat the process for the second set.
     * The procedure therefore consists of a nested loop:
     *
     * **Outer loop**:
     * * List the analyses for the repository, filtered by tool.
     * * Parse this list to find a deletable analysis. If found:
     *
     *   **Inner loop**:
     *   * Delete the identified analysis.
     *   * Parse the response for the value of `confirm_delete_url` and, if found, use this in the next iteration.
     *
     * The above process assumes that you want to remove all trace of the tool's analyses from the GitHub user interface, for the specified repository, and it therefore uses the `confirm_delete_url` value. Alternatively, you could use the `next_analysis_url` value, which would leave the last analysis in each set undeleted to avoid removing a tool's analysis entirely.
     * operationId: code-scanning/delete-analysis
     * Request URI: /repos/{owner}/{repo}/code-scanning/analyses/{analysis_id}
     */
    async code$scanning$delete$analysis(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/code-scanning/analyses/${params.parameter.analysis_id}`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            confirm_delete: { value: params.parameter.confirm_delete, explode: false },
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * Upload an analysis as SARIF data
     * Uploads SARIF data containing the results of a code scanning analysis to make the results available in a repository. You must use an access token with the `security_events` scope to use this endpoint for private repositories. You can also use tokens with the `public_repo` scope for public repositories only. GitHub Apps must have the `security_events` write permission to use this endpoint.
     *
     * There are two places where you can upload code scanning results.
     *  - If you upload to a pull request, for example `--ref refs/pull/42/merge` or `--ref refs/pull/42/head`, then the results appear as alerts in a pull request check. For more information, see "[Triaging code scanning alerts in pull requests](/code-security/secure-coding/triaging-code-scanning-alerts-in-pull-requests)."
     *  - If you upload to a branch, for example `--ref refs/heads/my-branch`, then the results appear in the **Security** tab for your repository. For more information, see "[Managing code scanning alerts for your repository](/code-security/secure-coding/managing-code-scanning-alerts-for-your-repository#viewing-the-alerts-for-a-repository)."
     *
     * You must compress the SARIF-formatted analysis data that you want to upload, using `gzip`, and then encode it as a Base64 format string. For example:
     *
     * ```
     * gzip -c analysis-data.sarif | base64 -w0
     * ```
     *
     * SARIF upload supports a maximum of 5000 results per analysis run. Any results over this limit are ignored and any SARIF uploads with more than 25,000 results are rejected. Typically, but not necessarily, a SARIF file contains a single run of a single tool. If a code scanning tool generates too many results, you should update the analysis configuration to run only the most important rules or queries.
     *
     * The `202 Accepted`, response includes an `id` value.
     * You can use this ID to check the status of the upload by using this for the `/sarifs/{sarif_id}` endpoint.
     * For more information, see "[Get information about a SARIF upload](/rest/reference/code-scanning#get-information-about-a-sarif-upload)."
     * operationId: code-scanning/upload-sarif
     * Request URI: /repos/{owner}/{repo}/code-scanning/sarifs
     */
    async code$scanning$upload$sarif(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/code-scanning/sarifs`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get information about a SARIF upload
     * Gets information about a SARIF upload, including the status and the URL of the analysis that was uploaded so that you can retrieve details of the analysis. For more information, see "[Get a code scanning analysis for a repository](/rest/reference/code-scanning#get-a-code-scanning-analysis-for-a-repository)." You must use an access token with the `security_events` scope to use this endpoint with private repos, the `public_repo` scope also grants permission to read security events on public repos only. GitHub Apps must have the `security_events` read permission to use this endpoint.
     * operationId: code-scanning/get-sarif
     * Request URI: /repos/{owner}/{repo}/code-scanning/sarifs/{sarif_id}
     */
    async code$scanning$get$sarif(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/code-scanning/sarifs/${params.parameter.sarif_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List repository collaborators
     * For organization-owned repositories, the list of collaborators includes outside collaborators, organization members that are direct collaborators, organization members with access through team memberships, organization members with access through default organization permissions, and organization owners.
     *
     * Team members will include the members of child teams.
     *
     * You must authenticate using an access token with the `read:org` and `repo` scopes with push access to use this
     * endpoint. GitHub Apps must have the `members` organization permission and `metadata` repository permission to use this
     * endpoint.
     * operationId: repos/list-collaborators
     * Request URI: /repos/{owner}/{repo}/collaborators
     */
    async repos$list$collaborators(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/collaborators`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            affiliation: { value: params.parameter.affiliation, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Check if a user is a repository collaborator
     * For organization-owned repositories, the list of collaborators includes outside collaborators, organization members that are direct collaborators, organization members with access through team memberships, organization members with access through default organization permissions, and organization owners.
     *
     * Team members will include the members of child teams.
     *
     * You must authenticate using an access token with the `read:org` and `repo` scopes with push access to use this
     * endpoint. GitHub Apps must have the `members` organization permission and `metadata` repository permission to use this
     * endpoint.
     * operationId: repos/check-collaborator
     * Request URI: /repos/{owner}/{repo}/collaborators/{username}
     */
    async repos$check$collaborator(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/collaborators/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Add a repository collaborator
     * This endpoint triggers [notifications](https://docs.github.com/en/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     *
     * For more information on permission levels, see "[Repository permission levels for an organization](https://docs.github.com/en/github/setting-up-and-managing-organizations-and-teams/repository-permission-levels-for-an-organization#permission-levels-for-repositories-owned-by-an-organization)". There are restrictions on which permissions can be granted to organization members when an organization base role is in place. In this case, the permission being given must be equal to or higher than the org base permission. Otherwise, the request will fail with:
     *
     * ```
     * Cannot assign {member} permission of {role name}
     * ```
     *
     * Note that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#http-verbs)."
     *
     * The invitee will receive a notification that they have been invited to the repository, which they must accept or decline. They may do this via the notifications page, the email they receive, or by using the [repository invitations API endpoints](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#invitations).
     *
     * **Rate limits**
     *
     * You are limited to sending 50 invitations to a repository per 24 hour period. Note there is no limit if you are inviting organization members to an organization repository.
     * operationId: repos/add-collaborator
     * Request URI: /repos/{owner}/{repo}/collaborators/{username}
     */
    async repos$add$collaborator(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/collaborators/${params.parameter.username}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove a repository collaborator
     * operationId: repos/remove-collaborator
     * Request URI: /repos/{owner}/{repo}/collaborators/{username}
     */
    async repos$remove$collaborator(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/collaborators/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get repository permissions for a user
     * Checks the repository permission of a collaborator. The possible repository permissions are `admin`, `write`, `read`, and `none`.
     * operationId: repos/get-collaborator-permission-level
     * Request URI: /repos/{owner}/{repo}/collaborators/{username}/permission
     */
    async repos$get$collaborator$permission$level(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/collaborators/${params.parameter.username}/permission`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List commit comments for a repository
     * Commit Comments use [these custom media types](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#custom-media-types). You can read more about the use of media types in the API [here](https://docs.github.com/enterprise-server@3.4/rest/overview/media-types/).
     *
     * Comments are ordered by ascending ID.
     * operationId: repos/list-commit-comments-for-repo
     * Request URI: /repos/{owner}/{repo}/comments
     */
    async repos$list$commit$comments$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/comments`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a commit comment
     * operationId: repos/get-commit-comment
     * Request URI: /repos/{owner}/{repo}/comments/{comment_id}
     */
    async repos$get$commit$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/comments/${params.parameter.comment_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a commit comment
     * operationId: repos/delete-commit-comment
     * Request URI: /repos/{owner}/{repo}/comments/{comment_id}
     */
    async repos$delete$commit$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/comments/${params.parameter.comment_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a commit comment
     * operationId: repos/update-commit-comment
     * Request URI: /repos/{owner}/{repo}/comments/{comment_id}
     */
    async repos$update$commit$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/comments/${params.parameter.comment_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List reactions for a commit comment
     * List the reactions to a [commit comment](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#comments).
     * operationId: reactions/list-for-commit-comment
     * Request URI: /repos/{owner}/{repo}/comments/{comment_id}/reactions
     */
    async reactions$list$for$commit$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/comments/${params.parameter.comment_id}/reactions`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            content: { value: params.parameter.content, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create reaction for a commit comment
     * Create a reaction to a [commit comment](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#comments). A response with an HTTP `200` status means that you already added the reaction type to this commit comment.
     * operationId: reactions/create-for-commit-comment
     * Request URI: /repos/{owner}/{repo}/comments/{comment_id}/reactions
     */
    async reactions$create$for$commit$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/comments/${params.parameter.comment_id}/reactions`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete a commit comment reaction
     * **Note:** You can also specify a repository by `repository_id` using the route `DELETE /repositories/:repository_id/comments/:comment_id/reactions/:reaction_id`.
     *
     * Delete a reaction to a [commit comment](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#comments).
     * operationId: reactions/delete-for-commit-comment
     * Request URI: /repos/{owner}/{repo}/comments/{comment_id}/reactions/{reaction_id}
     */
    async reactions$delete$for$commit$comment(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/comments/${params.parameter.comment_id}/reactions/${params.parameter.reaction_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List commits
     * **Signature verification object**
     *
     * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
     *
     * | Name | Type | Description |
     * | ---- | ---- | ----------- |
     * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
     * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
     * | `signature` | `string` | The signature that was extracted from the commit. |
     * | `payload` | `string` | The value that was signed. |
     *
     * These are the possible values for `reason` in the `verification` object:
     *
     * | Value | Description |
     * | ----- | ----------- |
     * | `expired_key` | The key that made the signature is expired. |
     * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
     * | `gpgverify_error` | There was an error communicating with the signature verification service. |
     * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
     * | `unsigned` | The object does not include a signature. |
     * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
     * | `no_user` | No user was associated with the `committer` email address in the commit. |
     * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on her/his account. |
     * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
     * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
     * | `malformed_signature` | There was an error parsing the signature. |
     * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
     * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
     * operationId: repos/list-commits
     * Request URI: /repos/{owner}/{repo}/commits
     */
    async repos$list$commits(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/commits`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            sha: { value: params.parameter.sha, explode: false },
            path: { value: params.parameter.path, explode: false },
            author: { value: params.parameter.author, explode: false },
            since: { value: params.parameter.since, explode: false },
            until: { value: params.parameter.until, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List branches for HEAD commit
     * Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Returns all branches where the given commit SHA is the HEAD, or latest commit for the branch.
     * operationId: repos/list-branches-for-head-commit
     * Request URI: /repos/{owner}/{repo}/commits/{commit_sha}/branches-where-head
     */
    async repos$list$branches$for$head$commit(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/commits/${params.parameter.commit_sha}/branches-where-head`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List commit comments
     * Use the `:commit_sha` to specify the commit that will have its comments listed.
     * operationId: repos/list-comments-for-commit
     * Request URI: /repos/{owner}/{repo}/commits/{commit_sha}/comments
     */
    async repos$list$comments$for$commit(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/commits/${params.parameter.commit_sha}/comments`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a commit comment
     * Create a comment for a commit using its `:commit_sha`.
     *
     * This endpoint triggers [notifications](https://docs.github.com/en/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     * operationId: repos/create-commit-comment
     * Request URI: /repos/{owner}/{repo}/commits/{commit_sha}/comments
     */
    async repos$create$commit$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/commits/${params.parameter.commit_sha}/comments`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List pull requests associated with a commit
     * Lists the merged pull request that introduced the commit to the repository. If the commit is not present in the default branch, additionally returns open pull requests associated with the commit. The results may include open and closed pull requests. Additional preview headers may be required to see certain details for associated pull requests, such as whether a pull request is in a draft state. For more information about previews that might affect this endpoint, see the [List pull requests](https://docs.github.com/enterprise-server@3.4/rest/reference/pulls#list-pull-requests) endpoint.
     * operationId: repos/list-pull-requests-associated-with-commit
     * Request URI: /repos/{owner}/{repo}/commits/{commit_sha}/pulls
     */
    async repos$list$pull$requests$associated$with$commit(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/commits/${params.parameter.commit_sha}/pulls`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a commit
     * Returns the contents of a single commit reference. You must have `read` access for the repository to use this endpoint.
     *
     * **Note:** If there are more than 300 files in the commit diff, the response will include pagination link headers for the remaining files, up to a limit of 3000 files. Each page contains the static commit information, and the only changes are to the file listing.
     *
     * You can pass the appropriate [media type](https://docs.github.com/enterprise-server@3.4/rest/overview/media-types/#commits-commit-comparison-and-pull-requests) to  fetch `diff` and `patch` formats. Diffs with binary data will have no `patch` property.
     *
     * To return only the SHA-1 hash of the commit reference, you can provide the `sha` custom [media type](https://docs.github.com/enterprise-server@3.4/rest/overview/media-types/#commits-commit-comparison-and-pull-requests) in the `Accept` header. You can use this endpoint to check if a remote reference's SHA-1 hash is the same as your local reference's SHA-1 hash by providing the local SHA-1 reference as the ETag.
     *
     * **Signature verification object**
     *
     * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
     *
     * | Name | Type | Description |
     * | ---- | ---- | ----------- |
     * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
     * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
     * | `signature` | `string` | The signature that was extracted from the commit. |
     * | `payload` | `string` | The value that was signed. |
     *
     * These are the possible values for `reason` in the `verification` object:
     *
     * | Value | Description |
     * | ----- | ----------- |
     * | `expired_key` | The key that made the signature is expired. |
     * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
     * | `gpgverify_error` | There was an error communicating with the signature verification service. |
     * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
     * | `unsigned` | The object does not include a signature. |
     * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
     * | `no_user` | No user was associated with the `committer` email address in the commit. |
     * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on her/his account. |
     * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
     * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
     * | `malformed_signature` | There was an error parsing the signature. |
     * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
     * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
     * operationId: repos/get-commit
     * Request URI: /repos/{owner}/{repo}/commits/{ref}
     */
    async repos$get$commit(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/commits/${params.parameter.ref}`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            page: { value: params.parameter.page, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List check runs for a Git reference
     * **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
     *
     * Lists check runs for a commit ref. The `ref` can be a SHA, branch name, or a tag name. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to get check runs. OAuth Apps and authenticated users must have the `repo` scope to get check runs in a private repository.
     * operationId: checks/list-for-ref
     * Request URI: /repos/{owner}/{repo}/commits/{ref}/check-runs
     */
    async checks$list$for$ref(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/commits/${params.parameter.ref}/check-runs`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            check_name: { value: params.parameter.check_name, explode: false },
            status: { value: params.parameter.status, explode: false },
            filter: { value: params.parameter.filter, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
            app_id: { value: params.parameter.app_id, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List check suites for a Git reference
     * **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array and a `null` value for `head_branch`.
     *
     * Lists check suites for a commit `ref`. The `ref` can be a SHA, branch name, or a tag name. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to list check suites. OAuth Apps and authenticated users must have the `repo` scope to get check suites in a private repository.
     * operationId: checks/list-suites-for-ref
     * Request URI: /repos/{owner}/{repo}/commits/{ref}/check-suites
     */
    async checks$list$suites$for$ref(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/commits/${params.parameter.ref}/check-suites`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            app_id: { value: params.parameter.app_id, explode: false },
            check_name: { value: params.parameter.check_name, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get the combined status for a specific reference
     * Users with pull access in a repository can access a combined view of commit statuses for a given ref. The ref can be a SHA, a branch name, or a tag name.
     *
     *
     * Additionally, a combined `state` is returned. The `state` is one of:
     *
     * *   **failure** if any of the contexts report as `error` or `failure`
     * *   **pending** if there are no statuses or a context is `pending`
     * *   **success** if the latest status for all contexts is `success`
     * operationId: repos/get-combined-status-for-ref
     * Request URI: /repos/{owner}/{repo}/commits/{ref}/status
     */
    async repos$get$combined$status$for$ref(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/commits/${params.parameter.ref}/status`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List commit statuses for a reference
     * Users with pull access in a repository can view commit statuses for a given ref. The ref can be a SHA, a branch name, or a tag name. Statuses are returned in reverse chronological order. The first status in the list will be the latest one.
     *
     * This resource is also available via a legacy route: `GET /repos/:owner/:repo/statuses/:ref`.
     * operationId: repos/list-commit-statuses-for-ref
     * Request URI: /repos/{owner}/{repo}/commits/{ref}/statuses
     */
    async repos$list$commit$statuses$for$ref(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/commits/${params.parameter.ref}/statuses`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Compare two commits
     * The `basehead` param is comprised of two parts: `base` and `head`. Both must be branch names in `repo`. To compare branches across other repositories in the same network as `repo`, use the format `<USERNAME>:branch`.
     *
     * The response from the API is equivalent to running the `git log base..head` command; however, commits are returned in chronological order. Pass the appropriate [media type](https://docs.github.com/enterprise-server@3.4/rest/overview/media-types/#commits-commit-comparison-and-pull-requests) to fetch diff and patch formats.
     *
     * The response also includes details on the files that were changed between the two commits. This includes the status of the change (for example, if a file was added, removed, modified, or renamed), and details of the change itself. For example, files with a `renamed` status have a `previous_filename` field showing the previous filename of the file, and files with a `modified` status have a `patch` field showing the changes made to the file.
     *
     * **Working with large comparisons**
     *
     * To process a response with a large number of commits, you can use (`per_page` or `page`) to paginate the results. When using paging, the list of changed files is only returned with page 1, but includes all changed files for the entire comparison. For more information on working with pagination, see "[Traversing with pagination](/rest/guides/traversing-with-pagination)."
     *
     * When calling this API without any paging parameters (`per_page` or `page`), the returned list is limited to 250 commits and the last commit in the list is the most recent of the entire comparison. When a paging parameter is specified, the first commit in the returned list of each page is the earliest.
     *
     * **Signature verification object**
     *
     * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
     *
     * | Name | Type | Description |
     * | ---- | ---- | ----------- |
     * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
     * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
     * | `signature` | `string` | The signature that was extracted from the commit. |
     * | `payload` | `string` | The value that was signed. |
     *
     * These are the possible values for `reason` in the `verification` object:
     *
     * | Value | Description |
     * | ----- | ----------- |
     * | `expired_key` | The key that made the signature is expired. |
     * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
     * | `gpgverify_error` | There was an error communicating with the signature verification service. |
     * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
     * | `unsigned` | The object does not include a signature. |
     * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
     * | `no_user` | No user was associated with the `committer` email address in the commit. |
     * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on her/his account. |
     * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
     * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
     * | `malformed_signature` | There was an error parsing the signature. |
     * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
     * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
     * operationId: repos/compare-commits
     * Request URI: /repos/{owner}/{repo}/compare/{basehead}
     */
    async repos$compare$commits(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/compare/${params.parameter.basehead}`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            page: { value: params.parameter.page, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get repository content
     * Gets the contents of a file or directory in a repository. Specify the file path or directory in `:path`. If you omit
     * `:path`, you will receive the contents of the repository's root directory. See the description below regarding what the API response includes for directories.
     *
     * Files and symlinks support [a custom media type](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#custom-media-types) for
     * retrieving the raw content or rendered HTML (when supported). All content types support [a custom media
     * type](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#custom-media-types) to ensure the content is returned in a consistent
     * object format.
     *
     * **Note**:
     * *   To get a repository's contents recursively, you can [recursively get the tree](https://docs.github.com/enterprise-server@3.4/rest/reference/git#trees).
     * *   This API has an upper limit of 1,000 files for a directory. If you need to retrieve more files, use the [Git Trees
     * API](https://docs.github.com/enterprise-server@3.4/rest/reference/git#get-a-tree).
     * *   This API supports files up to 1 megabyte in size.
     *
     * #### If the content is a directory
     * The response will be an array of objects, one object for each item in the directory.
     * When listing the contents of a directory, submodules have their "type" specified as "file". Logically, the value
     * _should_ be "submodule". This behavior exists in API v3 [for backwards compatibility purposes](https://git.io/v1YCW).
     * In the next major version of the API, the type will be returned as "submodule".
     *
     * #### If the content is a symlink
     * If the requested `:path` points to a symlink, and the symlink's target is a normal file in the repository, then the
     * API responds with the content of the file (in the format shown in the example. Otherwise, the API responds with an object
     * describing the symlink itself.
     *
     * #### If the content is a submodule
     * The `submodule_git_url` identifies the location of the submodule repository, and the `sha` identifies a specific
     * commit within the submodule repository. Git uses the given URL when cloning the submodule repository, and checks out
     * the submodule at that specific commit.
     *
     * If the submodule repository is not hosted on github.com, the Git URLs (`git_url` and `_links["git"]`) and the
     * github.com URLs (`html_url` and `_links["html"]`) will have null values.
     * operationId: repos/get-content
     * Request URI: /repos/{owner}/{repo}/contents/{path}
     */
    async repos$get$content(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/contents/${params.parameter.path}`;
        const headers = {
            Accept: params.headers.Accept,
        };
        const queryParameters = {
            ref: { value: params.parameter.ref, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create or update file contents
     * Creates a new file or replaces an existing file in a repository.
     * operationId: repos/create-or-update-file-contents
     * Request URI: /repos/{owner}/{repo}/contents/{path}
     */
    async repos$create$or$update$file$contents(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/contents/${params.parameter.path}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete a file
     * Deletes a file in a repository.
     *
     * You can provide an additional `committer` parameter, which is an object containing information about the committer. Or, you can provide an `author` parameter, which is an object containing information about the author.
     *
     * The `author` section is optional and is filled in with the `committer` information if omitted. If the `committer` information is omitted, the authenticated user's information is used.
     *
     * You must provide values for both `name` and `email`, whether you choose to use `author` or `committer`. Otherwise, you'll receive a `422` status code.
     * operationId: repos/delete-file
     * Request URI: /repos/{owner}/{repo}/contents/{path}
     */
    async repos$delete$file(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/contents/${params.parameter.path}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List repository contributors
     * Lists contributors to the specified repository and sorts them by the number of commits per contributor in descending order. This endpoint may return information that is a few hours old because the GitHub REST API v3 caches contributor data to improve performance.
     *
     * GitHub identifies contributors by author email address. This endpoint groups contribution counts by GitHub user, which includes all associated email addresses. To improve performance, only the first 500 author email addresses in the repository link to GitHub users. The rest will appear as anonymous contributors without associated GitHub user information.
     * operationId: repos/list-contributors
     * Request URI: /repos/{owner}/{repo}/contributors
     */
    async repos$list$contributors(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/contributors`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            anon: { value: params.parameter.anon, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List repository secrets
     * Lists all secrets available in a repository without revealing their encrypted values. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` repository permission to use this endpoint.
     * operationId: dependabot/list-repo-secrets
     * Request URI: /repos/{owner}/{repo}/dependabot/secrets
     */
    async dependabot$list$repo$secrets(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/dependabot/secrets`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a repository public key
     * Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `dependabot_secrets` repository permission to use this endpoint.
     * operationId: dependabot/get-repo-public-key
     * Request URI: /repos/{owner}/{repo}/dependabot/secrets/public-key
     */
    async dependabot$get$repo$public$key(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/dependabot/secrets/public-key`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get a repository secret
     * Gets a single repository secret without revealing its encrypted value. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` repository permission to use this endpoint.
     * operationId: dependabot/get-repo-secret
     * Request URI: /repos/{owner}/{repo}/dependabot/secrets/{secret_name}
     */
    async dependabot$get$repo$secret(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/dependabot/secrets/${params.parameter.secret_name}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create or update a repository secret
     * Creates or updates a repository secret with an encrypted value. Encrypt your secret using
     * [LibSodium](https://libsodium.gitbook.io/doc/bindings_for_other_languages). You must authenticate using an access
     * token with the `repo` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` repository
     * permission to use this endpoint.
     *
     * #### Example encrypting a secret using Node.js
     *
     * Encrypt your secret using the [tweetsodium](https://github.com/github/tweetsodium) library.
     *
     * ```
     * const sodium = require('tweetsodium');
     *
     * const key = "base64-encoded-public-key";
     * const value = "plain-text-secret";
     *
     * // Convert the message and key to Uint8Array's (Buffer implements that interface)
     * const messageBytes = Buffer.from(value);
     * const keyBytes = Buffer.from(key, 'base64');
     *
     * // Encrypt using LibSodium.
     * const encryptedBytes = sodium.seal(messageBytes, keyBytes);
     *
     * // Base64 the encrypted secret
     * const encrypted = Buffer.from(encryptedBytes).toString('base64');
     *
     * console.log(encrypted);
     * ```
     *
     *
     * #### Example encrypting a secret using Python
     *
     * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
     *
     * ```
     * from base64 import b64encode
     * from nacl import encoding, public
     *
     * def encrypt(public_key: str, secret_value: str) -> str:
     *   """Encrypt a Unicode string using the public key."""
     *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
     *   sealed_box = public.SealedBox(public_key)
     *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
     *   return b64encode(encrypted).decode("utf-8")
     * ```
     *
     * #### Example encrypting a secret using C#
     *
     * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
     *
     * ```
     * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
     * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
     *
     * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
     *
     * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
     * ```
     *
     * #### Example encrypting a secret using Ruby
     *
     * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
     *
     * ```ruby
     * require "rbnacl"
     * require "base64"
     *
     * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
     * public_key = RbNaCl::PublicKey.new(key)
     *
     * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
     * encrypted_secret = box.encrypt("my_secret")
     *
     * # Print the base64 encoded secret
     * puts Base64.strict_encode64(encrypted_secret)
     * ```
     * operationId: dependabot/create-or-update-repo-secret
     * Request URI: /repos/{owner}/{repo}/dependabot/secrets/{secret_name}
     */
    async dependabot$create$or$update$repo$secret(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/dependabot/secrets/${params.parameter.secret_name}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete a repository secret
     * Deletes a secret in a repository using the secret name. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` repository permission to use this endpoint.
     * operationId: dependabot/delete-repo-secret
     * Request URI: /repos/{owner}/{repo}/dependabot/secrets/{secret_name}
     */
    async dependabot$delete$repo$secret(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/dependabot/secrets/${params.parameter.secret_name}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List deployments
     * Simple filtering of deployments is available via query parameters:
     * operationId: repos/list-deployments
     * Request URI: /repos/{owner}/{repo}/deployments
     */
    async repos$list$deployments(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/deployments`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            sha: { value: params.parameter.sha, explode: false },
            ref: { value: params.parameter.ref, explode: false },
            task: { value: params.parameter.task, explode: false },
            environment: { value: params.parameter.environment, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a deployment
     * Deployments offer a few configurable parameters with certain defaults.
     *
     * The `ref` parameter can be any named branch, tag, or SHA. At GitHub Enterprise Server we often deploy branches and verify them
     * before we merge a pull request.
     *
     * The `environment` parameter allows deployments to be issued to different runtime environments. Teams often have
     * multiple environments for verifying their applications, such as `production`, `staging`, and `qa`. This parameter
     * makes it easier to track which environments have requested deployments. The default environment is `production`.
     *
     * The `auto_merge` parameter is used to ensure that the requested ref is not behind the repository's default branch. If
     * the ref _is_ behind the default branch for the repository, we will attempt to merge it for you. If the merge succeeds,
     * the API will return a successful merge commit. If merge conflicts prevent the merge from succeeding, the API will
     * return a failure response.
     *
     * By default, [commit statuses](https://docs.github.com/enterprise-server@3.4/rest/reference/commits#commit-statuses) for every submitted context must be in a `success`
     * state. The `required_contexts` parameter allows you to specify a subset of contexts that must be `success`, or to
     * specify contexts that have not yet been submitted. You are not required to use commit statuses to deploy. If you do
     * not require any contexts or create any commit statuses, the deployment will always succeed.
     *
     * The `payload` parameter is available for any extra information that a deployment system might need. It is a JSON text
     * field that will be passed on when a deployment event is dispatched.
     *
     * The `task` parameter is used by the deployment system to allow different execution paths. In the web world this might
     * be `deploy:migrations` to run schema changes on the system. In the compiled world this could be a flag to compile an
     * application with debugging enabled.
     *
     * Users with `repo` or `repo_deployment` scopes can create a deployment for a given ref.
     *
     * #### Merged branch response
     * You will see this response when GitHub automatically merges the base branch into the topic branch instead of creating
     * a deployment. This auto-merge happens when:
     * *   Auto-merge option is enabled in the repository
     * *   Topic branch does not include the latest changes on the base branch, which is `master` in the response example
     * *   There are no merge conflicts
     *
     * If there are no new commits in the base branch, a new request to create a deployment should give a successful
     * response.
     *
     * #### Merge conflict response
     * This error happens when the `auto_merge` option is enabled and when the default branch (in this case `master`), can't
     * be merged into the branch that's being deployed (in this case `topic-branch`), due to merge conflicts.
     *
     * #### Failed commit status checks
     * This error happens when the `required_contexts` parameter indicates that one or more contexts need to have a `success`
     * status for the commit to be deployed, but one or more of the required contexts do not have a state of `success`.
     * operationId: repos/create-deployment
     * Request URI: /repos/{owner}/{repo}/deployments
     */
    async repos$create$deployment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/deployments`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a deployment
     * operationId: repos/get-deployment
     * Request URI: /repos/{owner}/{repo}/deployments/{deployment_id}
     */
    async repos$get$deployment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/deployments/${params.parameter.deployment_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a deployment
     * If the repository only has one deployment, you can delete the deployment regardless of its status. If the repository has more than one deployment, you can only delete inactive deployments. This ensures that repositories with multiple deployments will always have an active deployment. Anyone with `repo` or `repo_deployment` scopes can delete a deployment.
     *
     * To set a deployment as inactive, you must:
     *
     * *   Create a new deployment that is active so that the system has a record of the current state, then delete the previously active deployment.
     * *   Mark the active deployment as inactive by adding any non-successful deployment status.
     *
     * For more information, see "[Create a deployment](https://docs.github.com/enterprise-server@3.4/rest/reference/repos/#create-a-deployment)" and "[Create a deployment status](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#create-a-deployment-status)."
     * operationId: repos/delete-deployment
     * Request URI: /repos/{owner}/{repo}/deployments/{deployment_id}
     */
    async repos$delete$deployment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/deployments/${params.parameter.deployment_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List deployment statuses
     * Users with pull access can view deployment statuses for a deployment:
     * operationId: repos/list-deployment-statuses
     * Request URI: /repos/{owner}/{repo}/deployments/{deployment_id}/statuses
     */
    async repos$list$deployment$statuses(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/deployments/${params.parameter.deployment_id}/statuses`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a deployment status
     * Users with `push` access can create deployment statuses for a given deployment.
     *
     * GitHub Apps require `read & write` access to "Deployments" and `read-only` access to "Repo contents" (for private repos). OAuth Apps require the `repo_deployment` scope.
     * operationId: repos/create-deployment-status
     * Request URI: /repos/{owner}/{repo}/deployments/{deployment_id}/statuses
     */
    async repos$create$deployment$status(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/deployments/${params.parameter.deployment_id}/statuses`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a deployment status
     * Users with pull access can view a deployment status for a deployment:
     * operationId: repos/get-deployment-status
     * Request URI: /repos/{owner}/{repo}/deployments/{deployment_id}/statuses/{status_id}
     */
    async repos$get$deployment$status(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/deployments/${params.parameter.deployment_id}/statuses/${params.parameter.status_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create a repository dispatch event
     * You can use this endpoint to trigger a webhook event called `repository_dispatch` when you want activity that happens outside of GitHub Enterprise Server to trigger a GitHub Actions workflow or GitHub App webhook. You must configure your GitHub Actions workflow or GitHub App to run when the `repository_dispatch` event occurs. For an example `repository_dispatch` webhook payload, see "[RepositoryDispatchEvent](https://docs.github.com/enterprise-server@3.4/webhooks/event-payloads/#repository_dispatch)."
     *
     * The `client_payload` parameter is available for any extra information that your workflow might need. This parameter is a JSON payload that will be passed on when the webhook event is dispatched. For example, the `client_payload` can include a message that a user would like to send using a GitHub Actions workflow. Or the `client_payload` can be used as a test to debug your workflow.
     *
     * This endpoint requires write access to the repository by providing either:
     *
     *   - Personal access tokens with `repo` scope. For more information, see "[Creating a personal access token for the command line](https://docs.github.com/articles/creating-a-personal-access-token-for-the-command-line)" in the GitHub Help documentation.
     *   - GitHub Apps with both `metadata:read` and `contents:read&write` permissions.
     *
     * This input example shows how you can use the `client_payload` as a test to debug your workflow.
     * operationId: repos/create-dispatch-event
     * Request URI: /repos/{owner}/{repo}/dispatches
     */
    async repos$create$dispatch$event(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/dispatches`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get all environments
     * Get all environments for a repository.
     *
     * Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     * operationId: repos/get-all-environments
     * Request URI: /repos/{owner}/{repo}/environments
     */
    async repos$get$all$environments(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/environments`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get an environment
     * Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     * operationId: repos/get-environment
     * Request URI: /repos/{owner}/{repo}/environments/{environment_name}
     */
    async repos$get$environment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/environments/${params.parameter.environment_name}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create or update an environment
     * Create or update an environment with protection rules, such as required reviewers. For more information about environment protection rules, see "[Environments](/actions/reference/environments#environment-protection-rules)."
     *
     * **Note:** Although you can use this operation to specify that only branches that match specified name patterns can deploy to this environment, you must use the UI to set the name patterns. For more information, see "[Environments](/actions/reference/environments#deployment-branches)."
     *
     * **Note:** To create or update secrets for an environment, see "[Secrets](/rest/reference/actions#secrets)."
     *
     * You must authenticate using an access token with the repo scope to use this endpoint.
     * operationId: repos/create-or-update-environment
     * Request URI: /repos/{owner}/{repo}/environments/{environment_name}
     */
    async repos$create$or$update$environment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/environments/${params.parameter.environment_name}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete an environment
     * You must authenticate using an access token with the repo scope to use this endpoint.
     * operationId: repos/delete-an-environment
     * Request URI: /repos/{owner}/{repo}/environments/{environment_name}
     */
    async repos$delete$an$environment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/environments/${params.parameter.environment_name}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List repository events
     * operationId: activity/list-repo-events
     * Request URI: /repos/{owner}/{repo}/events
     */
    async activity$list$repo$events(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/events`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List forks
     * operationId: repos/list-forks
     * Request URI: /repos/{owner}/{repo}/forks
     */
    async repos$list$forks(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/forks`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            sort: { value: params.parameter.sort, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a fork
     * Create a fork for the authenticated user.
     *
     * **Note**: Forking a Repository happens asynchronously. You may have to wait a short period of time before you can access the git objects. If this takes longer than 5 minutes, be sure to contact [GitHub Enterprise Server Support](https://support.github.com/contact?tags=dotcom-rest-api).
     * operationId: repos/create-fork
     * Request URI: /repos/{owner}/{repo}/forks
     */
    async repos$create$fork(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/forks`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Create a blob
     * operationId: git/create-blob
     * Request URI: /repos/{owner}/{repo}/git/blobs
     */
    async git$create$blob(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/git/blobs`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a blob
     * The `content` in the response will always be Base64 encoded.
     *
     * _Note_: This API supports blobs up to 100 megabytes in size.
     * operationId: git/get-blob
     * Request URI: /repos/{owner}/{repo}/git/blobs/{file_sha}
     */
    async git$get$blob(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/git/blobs/${params.parameter.file_sha}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create a commit
     * Creates a new Git [commit object](https://git-scm.com/book/en/v1/Git-Internals-Git-Objects#Commit-Objects).
     *
     * **Signature verification object**
     *
     * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
     *
     * | Name | Type | Description |
     * | ---- | ---- | ----------- |
     * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
     * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
     * | `signature` | `string` | The signature that was extracted from the commit. |
     * | `payload` | `string` | The value that was signed. |
     *
     * These are the possible values for `reason` in the `verification` object:
     *
     * | Value | Description |
     * | ----- | ----------- |
     * | `expired_key` | The key that made the signature is expired. |
     * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
     * | `gpgverify_error` | There was an error communicating with the signature verification service. |
     * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
     * | `unsigned` | The object does not include a signature. |
     * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
     * | `no_user` | No user was associated with the `committer` email address in the commit. |
     * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on her/his account. |
     * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
     * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
     * | `malformed_signature` | There was an error parsing the signature. |
     * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
     * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
     * operationId: git/create-commit
     * Request URI: /repos/{owner}/{repo}/git/commits
     */
    async git$create$commit(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/git/commits`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a commit
     * Gets a Git [commit object](https://git-scm.com/book/en/v1/Git-Internals-Git-Objects#Commit-Objects).
     *
     * **Signature verification object**
     *
     * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
     *
     * | Name | Type | Description |
     * | ---- | ---- | ----------- |
     * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
     * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
     * | `signature` | `string` | The signature that was extracted from the commit. |
     * | `payload` | `string` | The value that was signed. |
     *
     * These are the possible values for `reason` in the `verification` object:
     *
     * | Value | Description |
     * | ----- | ----------- |
     * | `expired_key` | The key that made the signature is expired. |
     * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
     * | `gpgverify_error` | There was an error communicating with the signature verification service. |
     * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
     * | `unsigned` | The object does not include a signature. |
     * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
     * | `no_user` | No user was associated with the `committer` email address in the commit. |
     * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on her/his account. |
     * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
     * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
     * | `malformed_signature` | There was an error parsing the signature. |
     * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
     * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
     * operationId: git/get-commit
     * Request URI: /repos/{owner}/{repo}/git/commits/{commit_sha}
     */
    async git$get$commit(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/git/commits/${params.parameter.commit_sha}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List matching references
     * Returns an array of references from your Git database that match the supplied name. The `:ref` in the URL must be formatted as `heads/<branch name>` for branches and `tags/<tag name>` for tags. If the `:ref` doesn't exist in the repository, but existing refs start with `:ref`, they will be returned as an array.
     *
     * When you use this endpoint without providing a `:ref`, it will return an array of all the references from your Git database, including notes and stashes if they exist on the server. Anything in the namespace is returned, not just `heads` and `tags`.
     *
     * **Note:** You need to explicitly [request a pull request](https://docs.github.com/enterprise-server@3.4/rest/reference/pulls#get-a-pull-request) to trigger a test merge commit, which checks the mergeability of pull requests. For more information, see "[Checking mergeability of pull requests](https://docs.github.com/enterprise-server@3.4/rest/guides/getting-started-with-the-git-database-api#checking-mergeability-of-pull-requests)".
     *
     * If you request matching references for a branch named `feature` but the branch `feature` doesn't exist, the response can still include other matching head refs that start with the word `feature`, such as `featureA` and `featureB`.
     * operationId: git/list-matching-refs
     * Request URI: /repos/{owner}/{repo}/git/matching-refs/{ref}
     */
    async git$list$matching$refs(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/git/matching-refs/${params.parameter.ref}`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a reference
     * Returns a single reference from your Git database. The `:ref` in the URL must be formatted as `heads/<branch name>` for branches and `tags/<tag name>` for tags. If the `:ref` doesn't match an existing ref, a `404` is returned.
     *
     * **Note:** You need to explicitly [request a pull request](https://docs.github.com/enterprise-server@3.4/rest/reference/pulls#get-a-pull-request) to trigger a test merge commit, which checks the mergeability of pull requests. For more information, see "[Checking mergeability of pull requests](https://docs.github.com/enterprise-server@3.4/rest/guides/getting-started-with-the-git-database-api#checking-mergeability-of-pull-requests)".
     * operationId: git/get-ref
     * Request URI: /repos/{owner}/{repo}/git/ref/{ref}
     */
    async git$get$ref(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/git/ref/${params.parameter.ref}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create a reference
     * Creates a reference for your repository. You are unable to create new references for empty repositories, even if the commit SHA-1 hash used exists. Empty repositories are repositories without branches.
     * operationId: git/create-ref
     * Request URI: /repos/{owner}/{repo}/git/refs
     */
    async git$create$ref(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/git/refs`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete a reference
     * operationId: git/delete-ref
     * Request URI: /repos/{owner}/{repo}/git/refs/{ref}
     */
    async git$delete$ref(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/git/refs/${params.parameter.ref}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a reference
     * operationId: git/update-ref
     * Request URI: /repos/{owner}/{repo}/git/refs/{ref}
     */
    async git$update$ref(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/git/refs/${params.parameter.ref}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Create a tag object
     * Note that creating a tag object does not create the reference that makes a tag in Git. If you want to create an annotated tag in Git, you have to do this call to create the tag object, and then [create](https://docs.github.com/enterprise-server@3.4/rest/reference/git#create-a-reference) the `refs/tags/[tag]` reference. If you want to create a lightweight tag, you only have to [create](https://docs.github.com/enterprise-server@3.4/rest/reference/git#create-a-reference) the tag reference - this call would be unnecessary.
     *
     * **Signature verification object**
     *
     * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
     *
     * | Name | Type | Description |
     * | ---- | ---- | ----------- |
     * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
     * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
     * | `signature` | `string` | The signature that was extracted from the commit. |
     * | `payload` | `string` | The value that was signed. |
     *
     * These are the possible values for `reason` in the `verification` object:
     *
     * | Value | Description |
     * | ----- | ----------- |
     * | `expired_key` | The key that made the signature is expired. |
     * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
     * | `gpgverify_error` | There was an error communicating with the signature verification service. |
     * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
     * | `unsigned` | The object does not include a signature. |
     * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
     * | `no_user` | No user was associated with the `committer` email address in the commit. |
     * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on her/his account. |
     * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
     * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
     * | `malformed_signature` | There was an error parsing the signature. |
     * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
     * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
     * operationId: git/create-tag
     * Request URI: /repos/{owner}/{repo}/git/tags
     */
    async git$create$tag(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/git/tags`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a tag
     * **Signature verification object**
     *
     * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
     *
     * | Name | Type | Description |
     * | ---- | ---- | ----------- |
     * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
     * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
     * | `signature` | `string` | The signature that was extracted from the commit. |
     * | `payload` | `string` | The value that was signed. |
     *
     * These are the possible values for `reason` in the `verification` object:
     *
     * | Value | Description |
     * | ----- | ----------- |
     * | `expired_key` | The key that made the signature is expired. |
     * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
     * | `gpgverify_error` | There was an error communicating with the signature verification service. |
     * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
     * | `unsigned` | The object does not include a signature. |
     * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
     * | `no_user` | No user was associated with the `committer` email address in the commit. |
     * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on her/his account. |
     * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
     * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
     * | `malformed_signature` | There was an error parsing the signature. |
     * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
     * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
     * operationId: git/get-tag
     * Request URI: /repos/{owner}/{repo}/git/tags/{tag_sha}
     */
    async git$get$tag(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/git/tags/${params.parameter.tag_sha}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create a tree
     * The tree creation API accepts nested entries. If you specify both a tree and a nested path modifying that tree, this endpoint will overwrite the contents of the tree with the new path contents, and create a new tree structure.
     *
     * If you use this endpoint to add, delete, or modify the file contents in a tree, you will need to commit the tree and then update a branch to point to the commit. For more information see "[Create a commit](https://docs.github.com/enterprise-server@3.4/rest/reference/git#create-a-commit)" and "[Update a reference](https://docs.github.com/enterprise-server@3.4/rest/reference/git#update-a-reference)."
     * operationId: git/create-tree
     * Request URI: /repos/{owner}/{repo}/git/trees
     */
    async git$create$tree(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/git/trees`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a tree
     * Returns a single tree using the SHA1 value for that tree.
     *
     * If `truncated` is `true` in the response then the number of items in the `tree` array exceeded our maximum limit. If you need to fetch more items, use the non-recursive method of fetching trees, and fetch one sub-tree at a time.
     * operationId: git/get-tree
     * Request URI: /repos/{owner}/{repo}/git/trees/{tree_sha}
     */
    async git$get$tree(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/git/trees/${params.parameter.tree_sha}`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            recursive: { value: params.parameter.recursive, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List repository webhooks
     * operationId: repos/list-webhooks
     * Request URI: /repos/{owner}/{repo}/hooks
     */
    async repos$list$webhooks(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/hooks`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a repository webhook
     * Repositories can have multiple webhooks installed. Each webhook should have a unique `config`. Multiple webhooks can
     * share the same `config` as long as those webhooks do not have any `events` that overlap.
     * operationId: repos/create-webhook
     * Request URI: /repos/{owner}/{repo}/hooks
     */
    async repos$create$webhook(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/hooks`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a repository webhook
     * Returns a webhook configured in a repository. To get only the webhook `config` properties, see "[Get a webhook configuration for a repository](/rest/reference/repos#get-a-webhook-configuration-for-a-repository)."
     * operationId: repos/get-webhook
     * Request URI: /repos/{owner}/{repo}/hooks/{hook_id}
     */
    async repos$get$webhook(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/hooks/${params.parameter.hook_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a repository webhook
     * operationId: repos/delete-webhook
     * Request URI: /repos/{owner}/{repo}/hooks/{hook_id}
     */
    async repos$delete$webhook(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/hooks/${params.parameter.hook_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a repository webhook
     * Updates a webhook configured in a repository. If you previously had a `secret` set, you must provide the same `secret` or set a new `secret` or the secret will be removed. If you are only updating individual webhook `config` properties, use "[Update a webhook configuration for a repository](/rest/reference/repos#update-a-webhook-configuration-for-a-repository)."
     * operationId: repos/update-webhook
     * Request URI: /repos/{owner}/{repo}/hooks/{hook_id}
     */
    async repos$update$webhook(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/hooks/${params.parameter.hook_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a webhook configuration for a repository
     * Returns the webhook configuration for a repository. To get more information about the webhook, including the `active` state and `events`, use "[Get a repository webhook](/rest/reference/orgs#get-a-repository-webhook)."
     *
     * Access tokens must have the `read:repo_hook` or `repo` scope, and GitHub Apps must have the `repository_hooks:read` permission.
     * operationId: repos/get-webhook-config-for-repo
     * Request URI: /repos/{owner}/{repo}/hooks/{hook_id}/config
     */
    async repos$get$webhook$config$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/hooks/${params.parameter.hook_id}/config`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update a webhook configuration for a repository
     * Updates the webhook configuration for a repository. To update more information about the webhook, including the `active` state and `events`, use "[Update a repository webhook](/rest/reference/orgs#update-a-repository-webhook)."
     *
     * Access tokens must have the `write:repo_hook` or `repo` scope, and GitHub Apps must have the `repository_hooks:write` permission.
     * operationId: repos/update-webhook-config-for-repo
     * Request URI: /repos/{owner}/{repo}/hooks/{hook_id}/config
     */
    async repos$update$webhook$config$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/hooks/${params.parameter.hook_id}/config`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List deliveries for a repository webhook
     * Returns a list of webhook deliveries for a webhook configured in a repository.
     * operationId: repos/list-webhook-deliveries
     * Request URI: /repos/{owner}/{repo}/hooks/{hook_id}/deliveries
     */
    async repos$list$webhook$deliveries(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/hooks/${params.parameter.hook_id}/deliveries`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            cursor: { value: params.parameter.cursor, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a delivery for a repository webhook
     * Returns a delivery for a webhook configured in a repository.
     * operationId: repos/get-webhook-delivery
     * Request URI: /repos/{owner}/{repo}/hooks/{hook_id}/deliveries/{delivery_id}
     */
    async repos$get$webhook$delivery(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/hooks/${params.parameter.hook_id}/deliveries/${params.parameter.delivery_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Redeliver a delivery for a repository webhook
     * Redeliver a webhook delivery for a webhook configured in a repository.
     * operationId: repos/redeliver-webhook-delivery
     * Request URI: /repos/{owner}/{repo}/hooks/{hook_id}/deliveries/{delivery_id}/attempts
     */
    async repos$redeliver$webhook$delivery(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/hooks/${params.parameter.hook_id}/deliveries/${params.parameter.delivery_id}/attempts`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Ping a repository webhook
     * This will trigger a [ping event](https://docs.github.com/enterprise-server@3.4/webhooks/#ping-event) to be sent to the hook.
     * operationId: repos/ping-webhook
     * Request URI: /repos/{owner}/{repo}/hooks/{hook_id}/pings
     */
    async repos$ping$webhook(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/hooks/${params.parameter.hook_id}/pings`;
        const headers = {};
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Test the push repository webhook
     * This will trigger the hook with the latest push to the current repository if the hook is subscribed to `push` events. If the hook is not subscribed to `push` events, the server will respond with 204 but no test POST will be generated.
     *
     * **Note**: Previously `/repos/:owner/:repo/hooks/:hook_id/test`
     * operationId: repos/test-push-webhook
     * Request URI: /repos/{owner}/{repo}/hooks/{hook_id}/tests
     */
    async repos$test$push$webhook(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/hooks/${params.parameter.hook_id}/tests`;
        const headers = {};
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Get a repository installation for the authenticated app
     * Enables an authenticated GitHub App to find the repository's installation information. The installation's account type will be either an organization or a user account, depending which account the repository belongs to.
     *
     * You must use a [JWT](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     * operationId: apps/get-repo-installation
     * Request URI: /repos/{owner}/{repo}/installation
     */
    async apps$get$repo$installation(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/installation`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List repository invitations
     * When authenticating as a user with admin rights to a repository, this endpoint will list all currently open repository invitations.
     * operationId: repos/list-invitations
     * Request URI: /repos/{owner}/{repo}/invitations
     */
    async repos$list$invitations(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/invitations`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Delete a repository invitation
     * operationId: repos/delete-invitation
     * Request URI: /repos/{owner}/{repo}/invitations/{invitation_id}
     */
    async repos$delete$invitation(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/invitations/${params.parameter.invitation_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a repository invitation
     * operationId: repos/update-invitation
     * Request URI: /repos/{owner}/{repo}/invitations/{invitation_id}
     */
    async repos$update$invitation(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/invitations/${params.parameter.invitation_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List repository issues
     * List issues in a repository.
     *
     * **Note**: GitHub's REST API v3 considers every pull request an issue, but not every issue is a pull request. For this
     * reason, "Issues" endpoints may return both issues and pull requests in the response. You can identify pull requests by
     * the `pull_request` key. Be aware that the `id` of a pull request returned from "Issues" endpoints will be an _issue id_. To find out the pull
     * request id, use the "[List pull requests](https://docs.github.com/enterprise-server@3.4/rest/reference/pulls#list-pull-requests)" endpoint.
     * operationId: issues/list-for-repo
     * Request URI: /repos/{owner}/{repo}/issues
     */
    async issues$list$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            milestone: { value: params.parameter.milestone, explode: false },
            state: { value: params.parameter.state, explode: false },
            assignee: { value: params.parameter.assignee, explode: false },
            creator: { value: params.parameter.creator, explode: false },
            mentioned: { value: params.parameter.mentioned, explode: false },
            labels: { value: params.parameter.labels, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            since: { value: params.parameter.since, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create an issue
     * Any user with pull access to a repository can create an issue. If [issues are disabled in the repository](https://docs.github.com/articles/disabling-issues/), the API returns a `410 Gone` status.
     *
     * This endpoint triggers [notifications](https://docs.github.com/enterprise-server@3.4/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     * operationId: issues/create
     * Request URI: /repos/{owner}/{repo}/issues
     */
    async issues$create(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List issue comments for a repository
     * By default, Issue Comments are ordered by ascending ID.
     * operationId: issues/list-comments-for-repo
     * Request URI: /repos/{owner}/{repo}/issues/comments
     */
    async issues$list$comments$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/comments`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            sort: { value: params.parameter.sort, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            since: { value: params.parameter.since, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get an issue comment
     * operationId: issues/get-comment
     * Request URI: /repos/{owner}/{repo}/issues/comments/{comment_id}
     */
    async issues$get$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/comments/${params.parameter.comment_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete an issue comment
     * operationId: issues/delete-comment
     * Request URI: /repos/{owner}/{repo}/issues/comments/{comment_id}
     */
    async issues$delete$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/comments/${params.parameter.comment_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update an issue comment
     * operationId: issues/update-comment
     * Request URI: /repos/{owner}/{repo}/issues/comments/{comment_id}
     */
    async issues$update$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/comments/${params.parameter.comment_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List reactions for an issue comment
     * List the reactions to an [issue comment](https://docs.github.com/enterprise-server@3.4/rest/reference/issues#comments).
     * operationId: reactions/list-for-issue-comment
     * Request URI: /repos/{owner}/{repo}/issues/comments/{comment_id}/reactions
     */
    async reactions$list$for$issue$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/comments/${params.parameter.comment_id}/reactions`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            content: { value: params.parameter.content, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create reaction for an issue comment
     * Create a reaction to an [issue comment](https://docs.github.com/enterprise-server@3.4/rest/reference/issues#comments). A response with an HTTP `200` status means that you already added the reaction type to this issue comment.
     * operationId: reactions/create-for-issue-comment
     * Request URI: /repos/{owner}/{repo}/issues/comments/{comment_id}/reactions
     */
    async reactions$create$for$issue$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/comments/${params.parameter.comment_id}/reactions`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete an issue comment reaction
     * **Note:** You can also specify a repository by `repository_id` using the route `DELETE delete /repositories/:repository_id/issues/comments/:comment_id/reactions/:reaction_id`.
     *
     * Delete a reaction to an [issue comment](https://docs.github.com/enterprise-server@3.4/rest/reference/issues#comments).
     * operationId: reactions/delete-for-issue-comment
     * Request URI: /repos/{owner}/{repo}/issues/comments/{comment_id}/reactions/{reaction_id}
     */
    async reactions$delete$for$issue$comment(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/comments/${params.parameter.comment_id}/reactions/${params.parameter.reaction_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List issue events for a repository
     * operationId: issues/list-events-for-repo
     * Request URI: /repos/{owner}/{repo}/issues/events
     */
    async issues$list$events$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/events`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get an issue event
     * operationId: issues/get-event
     * Request URI: /repos/{owner}/{repo}/issues/events/{event_id}
     */
    async issues$get$event(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/events/${params.parameter.event_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get an issue
     * The API returns a [`301 Moved Permanently` status](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#http-redirects-redirects) if the issue was
     * [transferred](https://docs.github.com/articles/transferring-an-issue-to-another-repository/) to another repository. If
     * the issue was transferred to or deleted from a repository where the authenticated user lacks read access, the API
     * returns a `404 Not Found` status. If the issue was deleted from a repository where the authenticated user has read
     * access, the API returns a `410 Gone` status. To receive webhook events for transferred and deleted issues, subscribe
     * to the [`issues`](https://docs.github.com/enterprise-server@3.4/webhooks/event-payloads/#issues) webhook.
     *
     * **Note**: GitHub's REST API v3 considers every pull request an issue, but not every issue is a pull request. For this
     * reason, "Issues" endpoints may return both issues and pull requests in the response. You can identify pull requests by
     * the `pull_request` key. Be aware that the `id` of a pull request returned from "Issues" endpoints will be an _issue id_. To find out the pull
     * request id, use the "[List pull requests](https://docs.github.com/enterprise-server@3.4/rest/reference/pulls#list-pull-requests)" endpoint.
     * operationId: issues/get
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}
     */
    async issues$get(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update an issue
     * Issue owners and users with push access can edit an issue.
     * operationId: issues/update
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}
     */
    async issues$update(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Add assignees to an issue
     * Adds up to 10 assignees to an issue. Users already assigned to an issue are not replaced.
     * operationId: issues/add-assignees
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/assignees
     */
    async issues$add$assignees(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/assignees`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove assignees from an issue
     * Removes one or more assignees from an issue.
     * operationId: issues/remove-assignees
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/assignees
     */
    async issues$remove$assignees(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/assignees`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List issue comments
     * Issue Comments are ordered by ascending ID.
     * operationId: issues/list-comments
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/comments
     */
    async issues$list$comments(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/comments`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            since: { value: params.parameter.since, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create an issue comment
     * This endpoint triggers [notifications](https://docs.github.com/enterprise-server@3.4/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     * operationId: issues/create-comment
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/comments
     */
    async issues$create$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/comments`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List issue events
     * operationId: issues/list-events
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/events
     */
    async issues$list$events(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/events`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List labels for an issue
     * operationId: issues/list-labels-on-issue
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/labels
     */
    async issues$list$labels$on$issue(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/labels`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Set labels for an issue
     * Removes any previous labels and sets the new labels for an issue.
     * operationId: issues/set-labels
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/labels
     */
    async issues$set$labels(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/labels`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Add labels to an issue
     * operationId: issues/add-labels
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/labels
     */
    async issues$add$labels(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/labels`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove all labels from an issue
     * operationId: issues/remove-all-labels
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/labels
     */
    async issues$remove$all$labels(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/labels`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Remove a label from an issue
     * Removes the specified label from the issue, and returns the remaining labels on the issue. This endpoint returns a `404 Not Found` status if the label does not exist.
     * operationId: issues/remove-label
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/labels/{name}
     */
    async issues$remove$label(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/labels/${params.parameter.name}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Lock an issue
     * Users with push access can lock an issue or pull request's conversation.
     *
     * Note that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#http-verbs)."
     * operationId: issues/lock
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/lock
     */
    async issues$lock(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/lock`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Unlock an issue
     * Users with push access can unlock an issue's conversation.
     * operationId: issues/unlock
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/lock
     */
    async issues$unlock(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/lock`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List reactions for an issue
     * List the reactions to an [issue](https://docs.github.com/enterprise-server@3.4/rest/reference/issues).
     * operationId: reactions/list-for-issue
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/reactions
     */
    async reactions$list$for$issue(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/reactions`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            content: { value: params.parameter.content, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create reaction for an issue
     * Create a reaction to an [issue](https://docs.github.com/enterprise-server@3.4/rest/reference/issues/). A response with an HTTP `200` status means that you already added the reaction type to this issue.
     * operationId: reactions/create-for-issue
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/reactions
     */
    async reactions$create$for$issue(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/reactions`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete an issue reaction
     * **Note:** You can also specify a repository by `repository_id` using the route `DELETE /repositories/:repository_id/issues/:issue_number/reactions/:reaction_id`.
     *
     * Delete a reaction to an [issue](https://docs.github.com/enterprise-server@3.4/rest/reference/issues/).
     * operationId: reactions/delete-for-issue
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/reactions/{reaction_id}
     */
    async reactions$delete$for$issue(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/reactions/${params.parameter.reaction_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List timeline events for an issue
     * operationId: issues/list-events-for-timeline
     * Request URI: /repos/{owner}/{repo}/issues/{issue_number}/timeline
     */
    async issues$list$events$for$timeline(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/issues/${params.parameter.issue_number}/timeline`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List deploy keys
     * operationId: repos/list-deploy-keys
     * Request URI: /repos/{owner}/{repo}/keys
     */
    async repos$list$deploy$keys(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/keys`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a deploy key
     * You can create a read-only deploy key.
     * operationId: repos/create-deploy-key
     * Request URI: /repos/{owner}/{repo}/keys
     */
    async repos$create$deploy$key(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/keys`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a deploy key
     * operationId: repos/get-deploy-key
     * Request URI: /repos/{owner}/{repo}/keys/{key_id}
     */
    async repos$get$deploy$key(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/keys/${params.parameter.key_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a deploy key
     * Deploy keys are immutable. If you need to update a key, remove the key and create a new one instead.
     * operationId: repos/delete-deploy-key
     * Request URI: /repos/{owner}/{repo}/keys/{key_id}
     */
    async repos$delete$deploy$key(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/keys/${params.parameter.key_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List labels for a repository
     * operationId: issues/list-labels-for-repo
     * Request URI: /repos/{owner}/{repo}/labels
     */
    async issues$list$labels$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/labels`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a label
     * operationId: issues/create-label
     * Request URI: /repos/{owner}/{repo}/labels
     */
    async issues$create$label(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/labels`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a label
     * operationId: issues/get-label
     * Request URI: /repos/{owner}/{repo}/labels/{name}
     */
    async issues$get$label(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/labels/${params.parameter.name}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a label
     * operationId: issues/delete-label
     * Request URI: /repos/{owner}/{repo}/labels/{name}
     */
    async issues$delete$label(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/labels/${params.parameter.name}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a label
     * operationId: issues/update-label
     * Request URI: /repos/{owner}/{repo}/labels/{name}
     */
    async issues$update$label(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/labels/${params.parameter.name}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List repository languages
     * Lists languages for the specified repository. The value shown for each language is the number of bytes of code written in that language.
     * operationId: repos/list-languages
     * Request URI: /repos/{owner}/{repo}/languages
     */
    async repos$list$languages(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/languages`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Enable Git LFS for a repository
     * operationId: repos/enable-lfs-for-repo
     * Request URI: /repos/{owner}/{repo}/lfs
     */
    async repos$enable$lfs$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/lfs`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Disable Git LFS for a repository
     * operationId: repos/disable-lfs-for-repo
     * Request URI: /repos/{owner}/{repo}/lfs
     */
    async repos$disable$lfs$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/lfs`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get the license for a repository
     * This method returns the contents of the repository's license file, if one is detected.
     *
     * Similar to [Get repository content](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#get-repository-content), this method also supports [custom media types](https://docs.github.com/enterprise-server@3.4/rest/overview/media-types) for retrieving the raw license content or rendered license HTML.
     * operationId: licenses/get-for-repo
     * Request URI: /repos/{owner}/{repo}/license
     */
    async licenses$get$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/license`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Sync a fork branch with the upstream repository
     * Sync a branch of a forked repository to keep it up-to-date with the upstream repository.
     * operationId: repos/merge-upstream
     * Request URI: /repos/{owner}/{repo}/merge-upstream
     */
    async repos$merge$upstream(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/merge-upstream`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Merge a branch
     * operationId: repos/merge
     * Request URI: /repos/{owner}/{repo}/merges
     */
    async repos$merge(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/merges`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List milestones
     * operationId: issues/list-milestones
     * Request URI: /repos/{owner}/{repo}/milestones
     */
    async issues$list$milestones(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/milestones`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            state: { value: params.parameter.state, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a milestone
     * operationId: issues/create-milestone
     * Request URI: /repos/{owner}/{repo}/milestones
     */
    async issues$create$milestone(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/milestones`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a milestone
     * operationId: issues/get-milestone
     * Request URI: /repos/{owner}/{repo}/milestones/{milestone_number}
     */
    async issues$get$milestone(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/milestones/${params.parameter.milestone_number}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a milestone
     * operationId: issues/delete-milestone
     * Request URI: /repos/{owner}/{repo}/milestones/{milestone_number}
     */
    async issues$delete$milestone(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/milestones/${params.parameter.milestone_number}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a milestone
     * operationId: issues/update-milestone
     * Request URI: /repos/{owner}/{repo}/milestones/{milestone_number}
     */
    async issues$update$milestone(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/milestones/${params.parameter.milestone_number}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List labels for issues in a milestone
     * operationId: issues/list-labels-for-milestone
     * Request URI: /repos/{owner}/{repo}/milestones/{milestone_number}/labels
     */
    async issues$list$labels$for$milestone(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/milestones/${params.parameter.milestone_number}/labels`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List repository notifications for the authenticated user
     * List all notifications for the current user.
     * operationId: activity/list-repo-notifications-for-authenticated-user
     * Request URI: /repos/{owner}/{repo}/notifications
     */
    async activity$list$repo$notifications$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/notifications`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            all: { value: params.parameter.all, explode: false },
            participating: { value: params.parameter.participating, explode: false },
            since: { value: params.parameter.since, explode: false },
            before: { value: params.parameter.before, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Mark repository notifications as read
     * Marks all notifications in a repository as "read" removes them from the [default view on GitHub Enterprise Server](https://github.com/notifications). If the number of notifications is too large to complete in one request, you will receive a `202 Accepted` status and GitHub Enterprise Server will run an asynchronous process to mark notifications as "read." To check whether any "unread" notifications remain, you can use the [List repository notifications for the authenticated user](https://docs.github.com/enterprise-server@3.4/rest/reference/activity#list-repository-notifications-for-the-authenticated-user) endpoint and pass the query parameter `all=false`.
     * operationId: activity/mark-repo-notifications-as-read
     * Request URI: /repos/{owner}/{repo}/notifications
     */
    async activity$mark$repo$notifications$as$read(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/notifications`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a GitHub Enterprise Server Pages site
     * operationId: repos/get-pages
     * Request URI: /repos/{owner}/{repo}/pages
     */
    async repos$get$pages(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pages`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update information about a GitHub Enterprise Server Pages site
     * Updates information for a GitHub Enterprise Server Pages site. For more information, see "[About GitHub Pages](/github/working-with-github-pages/about-github-pages).
     * operationId: repos/update-information-about-pages-site
     * Request URI: /repos/{owner}/{repo}/pages
     */
    async repos$update$information$about$pages$site(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pages`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Create a GitHub Enterprise Server Pages site
     * Configures a GitHub Enterprise Server Pages site. For more information, see "[About GitHub Pages](/github/working-with-github-pages/about-github-pages)."
     * operationId: repos/create-pages-site
     * Request URI: /repos/{owner}/{repo}/pages
     */
    async repos$create$pages$site(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pages`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete a GitHub Enterprise Server Pages site
     * operationId: repos/delete-pages-site
     * Request URI: /repos/{owner}/{repo}/pages
     */
    async repos$delete$pages$site(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pages`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List GitHub Enterprise Server Pages builds
     * operationId: repos/list-pages-builds
     * Request URI: /repos/{owner}/{repo}/pages/builds
     */
    async repos$list$pages$builds(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pages/builds`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Request a GitHub Enterprise Server Pages build
     * You can request that your site be built from the latest revision on the default branch. This has the same effect as pushing a commit to your default branch, but does not require an additional commit. Manually triggering page builds can be helpful when diagnosing build warnings and failures.
     *
     * Build requests are limited to one concurrent build per repository and one concurrent build per requester. If you request a build while another is still in progress, the second request will be queued until the first completes.
     * operationId: repos/request-pages-build
     * Request URI: /repos/{owner}/{repo}/pages/builds
     */
    async repos$request$pages$build(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pages/builds`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Get latest Pages build
     * operationId: repos/get-latest-pages-build
     * Request URI: /repos/{owner}/{repo}/pages/builds/latest
     */
    async repos$get$latest$pages$build(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pages/builds/latest`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get GitHub Enterprise Server Pages build
     * operationId: repos/get-pages-build
     * Request URI: /repos/{owner}/{repo}/pages/builds/{build_id}
     */
    async repos$get$pages$build(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pages/builds/${params.parameter.build_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List pre-receive hooks for a repository
     * List all pre-receive hooks that are enabled or testing for this repository as well as any disabled hooks that are allowed to be enabled at the repository level. Pre-receive hooks that are disabled at a higher level and are not configurable will not be listed.
     * operationId: enterprise-admin/list-pre-receive-hooks-for-repo
     * Request URI: /repos/{owner}/{repo}/pre-receive-hooks
     */
    async enterprise$admin$list$pre$receive$hooks$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pre-receive-hooks`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            sort: { value: params.parameter.sort, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a pre-receive hook for a repository
     * operationId: enterprise-admin/get-pre-receive-hook-for-repo
     * Request URI: /repos/{owner}/{repo}/pre-receive-hooks/{pre_receive_hook_id}
     */
    async enterprise$admin$get$pre$receive$hook$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pre-receive-hooks/${params.parameter.pre_receive_hook_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Remove pre-receive hook enforcement for a repository
     * Deletes any overridden enforcement on this repository for the specified hook.
     *
     * Responds with effective values inherited from owner and/or global level.
     * operationId: enterprise-admin/remove-pre-receive-hook-enforcement-for-repo
     * Request URI: /repos/{owner}/{repo}/pre-receive-hooks/{pre_receive_hook_id}
     */
    async enterprise$admin$remove$pre$receive$hook$enforcement$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pre-receive-hooks/${params.parameter.pre_receive_hook_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update pre-receive hook enforcement for a repository
     * For pre-receive hooks which are allowed to be configured at the repo level, you can set `enforcement`
     * operationId: enterprise-admin/update-pre-receive-hook-enforcement-for-repo
     * Request URI: /repos/{owner}/{repo}/pre-receive-hooks/{pre_receive_hook_id}
     */
    async enterprise$admin$update$pre$receive$hook$enforcement$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pre-receive-hooks/${params.parameter.pre_receive_hook_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List repository projects
     * Lists the projects in a repository. Returns a `404 Not Found` status if projects are disabled in the repository. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
     * operationId: projects/list-for-repo
     * Request URI: /repos/{owner}/{repo}/projects
     */
    async projects$list$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/projects`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            state: { value: params.parameter.state, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a repository project
     * Creates a repository project board. Returns a `404 Not Found` status if projects are disabled in the repository. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
     * operationId: projects/create-for-repo
     * Request URI: /repos/{owner}/{repo}/projects
     */
    async projects$create$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/projects`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List pull requests
     * Draft pull requests are available in public repositories with GitHub Free and GitHub Free for organizations, GitHub Pro, and legacy per-repository billing plans, and in public and private repositories with GitHub Team and GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     * operationId: pulls/list
     * Request URI: /repos/{owner}/{repo}/pulls
     */
    async pulls$list(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            state: { value: params.parameter.state, explode: false },
            head: { value: params.parameter.head, explode: false },
            base: { value: params.parameter.base, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a pull request
     * Draft pull requests are available in public repositories with GitHub Free and GitHub Free for organizations, GitHub Pro, and legacy per-repository billing plans, and in public and private repositories with GitHub Team and GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * To open or update a pull request in a public repository, you must have write access to the head or the source branch. For organization-owned repositories, you must be a member of the organization that owns the repository to open or update a pull request.
     *
     * You can create a new pull request.
     *
     * This endpoint triggers [notifications](https://docs.github.com/en/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/guides/best-practices-for-integrators#dealing-with-rate-limits)" for details.
     * operationId: pulls/create
     * Request URI: /repos/{owner}/{repo}/pulls
     */
    async pulls$create(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List review comments in a repository
     * Lists review comments for all pull requests in a repository. By default, review comments are in ascending order by ID.
     * operationId: pulls/list-review-comments-for-repo
     * Request URI: /repos/{owner}/{repo}/pulls/comments
     */
    async pulls$list$review$comments$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/comments`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            sort: { value: params.parameter.sort, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            since: { value: params.parameter.since, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a review comment for a pull request
     * Provides details for a review comment.
     * operationId: pulls/get-review-comment
     * Request URI: /repos/{owner}/{repo}/pulls/comments/{comment_id}
     */
    async pulls$get$review$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/comments/${params.parameter.comment_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a review comment for a pull request
     * Deletes a review comment.
     * operationId: pulls/delete-review-comment
     * Request URI: /repos/{owner}/{repo}/pulls/comments/{comment_id}
     */
    async pulls$delete$review$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/comments/${params.parameter.comment_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a review comment for a pull request
     * Enables you to edit a review comment.
     * operationId: pulls/update-review-comment
     * Request URI: /repos/{owner}/{repo}/pulls/comments/{comment_id}
     */
    async pulls$update$review$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/comments/${params.parameter.comment_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List reactions for a pull request review comment
     * List the reactions to a [pull request review comment](https://docs.github.com/enterprise-server@3.4/rest/reference/pulls#review-comments).
     * operationId: reactions/list-for-pull-request-review-comment
     * Request URI: /repos/{owner}/{repo}/pulls/comments/{comment_id}/reactions
     */
    async reactions$list$for$pull$request$review$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/comments/${params.parameter.comment_id}/reactions`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            content: { value: params.parameter.content, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create reaction for a pull request review comment
     * Create a reaction to a [pull request review comment](https://docs.github.com/enterprise-server@3.4/rest/reference/pulls#comments). A response with an HTTP `200` status means that you already added the reaction type to this pull request review comment.
     * operationId: reactions/create-for-pull-request-review-comment
     * Request URI: /repos/{owner}/{repo}/pulls/comments/{comment_id}/reactions
     */
    async reactions$create$for$pull$request$review$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/comments/${params.parameter.comment_id}/reactions`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete a pull request comment reaction
     * **Note:** You can also specify a repository by `repository_id` using the route `DELETE /repositories/:repository_id/pulls/comments/:comment_id/reactions/:reaction_id.`
     *
     * Delete a reaction to a [pull request review comment](https://docs.github.com/enterprise-server@3.4/rest/reference/pulls#review-comments).
     * operationId: reactions/delete-for-pull-request-comment
     * Request URI: /repos/{owner}/{repo}/pulls/comments/{comment_id}/reactions/{reaction_id}
     */
    async reactions$delete$for$pull$request$comment(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/comments/${params.parameter.comment_id}/reactions/${params.parameter.reaction_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Get a pull request
     * Draft pull requests are available in public repositories with GitHub Free and GitHub Free for organizations, GitHub Pro, and legacy per-repository billing plans, and in public and private repositories with GitHub Team and GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Lists details of a pull request by providing its number.
     *
     * When you get, [create](https://docs.github.com/enterprise-server@3.4/rest/reference/pulls/#create-a-pull-request), or [edit](https://docs.github.com/enterprise-server@3.4/rest/reference/pulls#update-a-pull-request) a pull request, GitHub Enterprise Server creates a merge commit to test whether the pull request can be automatically merged into the base branch. This test commit is not added to the base branch or the head branch. You can review the status of the test commit using the `mergeable` key. For more information, see "[Checking mergeability of pull requests](https://docs.github.com/enterprise-server@3.4/rest/guides/getting-started-with-the-git-database-api#checking-mergeability-of-pull-requests)".
     *
     * The value of the `mergeable` attribute can be `true`, `false`, or `null`. If the value is `null`, then GitHub Enterprise Server has started a background job to compute the mergeability. After giving the job time to complete, resubmit the request. When the job finishes, you will see a non-`null` value for the `mergeable` attribute in the response. If `mergeable` is `true`, then `merge_commit_sha` will be the SHA of the _test_ merge commit.
     *
     * The value of the `merge_commit_sha` attribute changes depending on the state of the pull request. Before merging a pull request, the `merge_commit_sha` attribute holds the SHA of the _test_ merge commit. After merging a pull request, the `merge_commit_sha` attribute changes depending on how you merged the pull request:
     *
     * *   If merged as a [merge commit](https://docs.github.com/articles/about-merge-methods-on-github/), `merge_commit_sha` represents the SHA of the merge commit.
     * *   If merged via a [squash](https://docs.github.com/articles/about-merge-methods-on-github/#squashing-your-merge-commits), `merge_commit_sha` represents the SHA of the squashed commit on the base branch.
     * *   If [rebased](https://docs.github.com/articles/about-merge-methods-on-github/#rebasing-and-merging-your-commits), `merge_commit_sha` represents the commit that the base branch was updated to.
     *
     * Pass the appropriate [media type](https://docs.github.com/enterprise-server@3.4/rest/overview/media-types/#commits-commit-comparison-and-pull-requests) to fetch diff and patch formats.
     * operationId: pulls/get
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}
     */
    async pulls$get(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update a pull request
     * Draft pull requests are available in public repositories with GitHub Free and GitHub Free for organizations, GitHub Pro, and legacy per-repository billing plans, and in public and private repositories with GitHub Team and GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * To open or update a pull request in a public repository, you must have write access to the head or the source branch. For organization-owned repositories, you must be a member of the organization that owns the repository to open or update a pull request.
     * operationId: pulls/update
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}
     */
    async pulls$update(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List review comments on a pull request
     * Lists all review comments for a pull request. By default, review comments are in ascending order by ID.
     * operationId: pulls/list-review-comments
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/comments
     */
    async pulls$list$review$comments(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/comments`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            sort: { value: params.parameter.sort, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            since: { value: params.parameter.since, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a review comment for a pull request
     *
     * Creates a review comment in the pull request diff. To add a regular comment to a pull request timeline, see "[Create an issue comment](https://docs.github.com/enterprise-server@3.4/rest/reference/issues#create-an-issue-comment)." We recommend creating a review comment using `line`, `side`, and optionally `start_line` and `start_side` if your comment applies to more than one line in the pull request diff.
     *
     * You can still create a review comment using the `position` parameter. When you use `position`, the `line`, `side`, `start_line`, and `start_side` parameters are not required.
     *
     * **Note:** The position value equals the number of lines down from the first "@@" hunk header in the file you want to add a comment. The line just below the "@@" line is position 1, the next line is position 2, and so on. The position in the diff continues to increase through lines of whitespace and additional hunks until the beginning of a new file.
     *
     * This endpoint triggers [notifications](https://docs.github.com/en/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     * operationId: pulls/create-review-comment
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/comments
     */
    async pulls$create$review$comment(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/comments`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Create a reply for a review comment
     * Creates a reply to a review comment for a pull request. For the `comment_id`, provide the ID of the review comment you are replying to. This must be the ID of a _top-level review comment_, not a reply to that comment. Replies to replies are not supported.
     *
     * This endpoint triggers [notifications](https://docs.github.com/en/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     * operationId: pulls/create-reply-for-review-comment
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/comments/{comment_id}/replies
     */
    async pulls$create$reply$for$review$comment(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/comments/${params.parameter.comment_id}/replies`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List commits on a pull request
     * Lists a maximum of 250 commits for a pull request. To receive a complete commit list for pull requests with more than 250 commits, use the [List commits](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#list-commits) endpoint.
     * operationId: pulls/list-commits
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/commits
     */
    async pulls$list$commits(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/commits`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List pull requests files
     * **Note:** Responses include a maximum of 3000 files. The paginated response returns 30 files per page by default.
     * operationId: pulls/list-files
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/files
     */
    async pulls$list$files(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/files`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Check if a pull request has been merged
     * operationId: pulls/check-if-merged
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/merge
     */
    async pulls$check$if$merged(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/merge`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Merge a pull request
     * This endpoint triggers [notifications](https://docs.github.com/enterprise-server@3.4/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     * operationId: pulls/merge
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/merge
     */
    async pulls$merge(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/merge`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List requested reviewers for a pull request
     * operationId: pulls/list-requested-reviewers
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/requested_reviewers
     */
    async pulls$list$requested$reviewers(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/requested_reviewers`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Request reviewers for a pull request
     * This endpoint triggers [notifications](https://docs.github.com/enterprise-server@3.4/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     * operationId: pulls/request-reviewers
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/requested_reviewers
     */
    async pulls$request$reviewers(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/requested_reviewers`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove requested reviewers from a pull request
     * operationId: pulls/remove-requested-reviewers
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/requested_reviewers
     */
    async pulls$remove$requested$reviewers(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/requested_reviewers`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List reviews for a pull request
     * The list of reviews returns in chronological order.
     * operationId: pulls/list-reviews
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/reviews
     */
    async pulls$list$reviews(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/reviews`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a review for a pull request
     * This endpoint triggers [notifications](https://docs.github.com/en/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     *
     * Pull request reviews created in the `PENDING` state do not include the `submitted_at` property in the response.
     *
     * **Note:** To comment on a specific line in a file, you need to first determine the _position_ of that line in the diff. The GitHub REST API v3 offers the `application/vnd.github.v3.diff` [media type](https://docs.github.com/enterprise-server@3.4/rest/overview/media-types#commits-commit-comparison-and-pull-requests). To see a pull request diff, add this media type to the `Accept` header of a call to the [single pull request](https://docs.github.com/enterprise-server@3.4/rest/reference/pulls#get-a-pull-request) endpoint.
     *
     * The `position` value equals the number of lines down from the first "@@" hunk header in the file you want to add a comment. The line just below the "@@" line is position 1, the next line is position 2, and so on. The position in the diff continues to increase through lines of whitespace and additional hunks until the beginning of a new file.
     * operationId: pulls/create-review
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/reviews
     */
    async pulls$create$review(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/reviews`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a review for a pull request
     * operationId: pulls/get-review
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}
     */
    async pulls$get$review(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/reviews/${params.parameter.review_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update a review for a pull request
     * Update the review summary comment with new text.
     * operationId: pulls/update-review
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}
     */
    async pulls$update$review(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/reviews/${params.parameter.review_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete a pending review for a pull request
     * operationId: pulls/delete-pending-review
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}
     */
    async pulls$delete$pending$review(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/reviews/${params.parameter.review_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List comments for a pull request review
     * List comments for a specific pull request review.
     * operationId: pulls/list-comments-for-review
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}/comments
     */
    async pulls$list$comments$for$review(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/reviews/${params.parameter.review_id}/comments`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Dismiss a review for a pull request
     * **Note:** To dismiss a pull request review on a [protected branch](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#branches), you must be a repository administrator or be included in the list of people or teams who can dismiss pull request reviews.
     * operationId: pulls/dismiss-review
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}/dismissals
     */
    async pulls$dismiss$review(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/reviews/${params.parameter.review_id}/dismissals`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Submit a review for a pull request
     * operationId: pulls/submit-review
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}/events
     */
    async pulls$submit$review(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/reviews/${params.parameter.review_id}/events`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Update a pull request branch
     * Updates the pull request branch with the latest upstream changes by merging HEAD from the base branch into the pull request branch.
     * operationId: pulls/update-branch
     * Request URI: /repos/{owner}/{repo}/pulls/{pull_number}/update-branch
     */
    async pulls$update$branch(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/pulls/${params.parameter.pull_number}/update-branch`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a repository README
     * Gets the preferred README for a repository.
     *
     * READMEs support [custom media types](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#custom-media-types) for retrieving the raw content or rendered HTML.
     * operationId: repos/get-readme
     * Request URI: /repos/{owner}/{repo}/readme
     */
    async repos$get$readme(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/readme`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            ref: { value: params.parameter.ref, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a repository README for a directory
     * Gets the README from a repository directory.
     *
     * READMEs support [custom media types](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#custom-media-types) for retrieving the raw content or rendered HTML.
     * operationId: repos/get-readme-in-directory
     * Request URI: /repos/{owner}/{repo}/readme/{dir}
     */
    async repos$get$readme$in$directory(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/readme/${params.parameter.dir}`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            ref: { value: params.parameter.ref, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List releases
     * This returns a list of releases, which does not include regular Git tags that have not been associated with a release. To get a list of Git tags, use the [Repository Tags API](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#list-repository-tags).
     *
     * Information about published releases are available to everyone. Only users with push access will receive listings for draft releases.
     * operationId: repos/list-releases
     * Request URI: /repos/{owner}/{repo}/releases
     */
    async repos$list$releases(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/releases`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a release
     * Users with push access to the repository can create a release.
     *
     * This endpoint triggers [notifications](https://docs.github.com/en/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     * operationId: repos/create-release
     * Request URI: /repos/{owner}/{repo}/releases
     */
    async repos$create$release(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/releases`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a release asset
     * To download the asset's binary content, set the `Accept` header of the request to [`application/octet-stream`](https://docs.github.com/enterprise-server@3.4/rest/overview/media-types). The API will either redirect the client to the location, or stream it directly if possible. API clients should handle both a `200` or `302` response.
     * operationId: repos/get-release-asset
     * Request URI: /repos/{owner}/{repo}/releases/assets/{asset_id}
     */
    async repos$get$release$asset(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/releases/assets/${params.parameter.asset_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a release asset
     * operationId: repos/delete-release-asset
     * Request URI: /repos/{owner}/{repo}/releases/assets/{asset_id}
     */
    async repos$delete$release$asset(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/releases/assets/${params.parameter.asset_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a release asset
     * Users with push access to the repository can edit a release asset.
     * operationId: repos/update-release-asset
     * Request URI: /repos/{owner}/{repo}/releases/assets/{asset_id}
     */
    async repos$update$release$asset(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/releases/assets/${params.parameter.asset_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Generate release notes content for a release
     * Generate a name and body describing a [release](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#releases). The body content will be markdown formatted and contain information like the changes since last release and users who contributed. The generated release notes are not saved anywhere. They are intended to be generated and used when creating a new release.
     * operationId: repos/generate-release-notes
     * Request URI: /repos/{owner}/{repo}/releases/generate-notes
     */
    async repos$generate$release$notes(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/releases/generate-notes`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get the latest release
     * View the latest published full release for the repository.
     *
     * The latest release is the most recent non-prerelease, non-draft release, sorted by the `created_at` attribute. The `created_at` attribute is the date of the commit used for the release, and not the date when the release was drafted or published.
     * operationId: repos/get-latest-release
     * Request URI: /repos/{owner}/{repo}/releases/latest
     */
    async repos$get$latest$release(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/releases/latest`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get a release by tag name
     * Get a published release with the specified tag.
     * operationId: repos/get-release-by-tag
     * Request URI: /repos/{owner}/{repo}/releases/tags/{tag}
     */
    async repos$get$release$by$tag(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/releases/tags/${params.parameter.tag}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get a release
     * **Note:** This returns an `upload_url` key corresponding to the endpoint for uploading release assets. This key is a [hypermedia resource](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#hypermedia).
     * operationId: repos/get-release
     * Request URI: /repos/{owner}/{repo}/releases/{release_id}
     */
    async repos$get$release(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/releases/${params.parameter.release_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a release
     * Users with push access to the repository can delete a release.
     * operationId: repos/delete-release
     * Request URI: /repos/{owner}/{repo}/releases/{release_id}
     */
    async repos$delete$release(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/releases/${params.parameter.release_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a release
     * Users with push access to the repository can edit a release.
     * operationId: repos/update-release
     * Request URI: /repos/{owner}/{repo}/releases/{release_id}
     */
    async repos$update$release(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/releases/${params.parameter.release_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List release assets
     * operationId: repos/list-release-assets
     * Request URI: /repos/{owner}/{repo}/releases/{release_id}/assets
     */
    async repos$list$release$assets(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/releases/${params.parameter.release_id}/assets`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Upload a release asset
     * This endpoint makes use of [a Hypermedia relation](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#hypermedia) to determine which URL to access. The endpoint you call to upload release assets is specific to your release. Use the `upload_url` returned in
     * the response of the [Create a release endpoint](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#create-a-release) to upload a release asset.
     *
     * You need to use an HTTP client which supports [SNI](http://en.wikipedia.org/wiki/Server_Name_Indication) to make calls to this endpoint.
     *
     * Most libraries will set the required `Content-Length` header automatically. Use the required `Content-Type` header to provide the media type of the asset. For a list of media types, see [Media Types](https://www.iana.org/assignments/media-types/media-types.xhtml). For example:
     *
     * `application/zip`
     *
     * GitHub Enterprise Server expects the asset data in its raw binary form, rather than JSON. You will send the raw binary content of the asset as the request body. Everything else about the endpoint is the same as the rest of the API. For example,
     * you'll still need to pass your authentication to be able to upload an asset.
     *
     * When an upstream failure occurs, you will receive a `502 Bad Gateway` status. This may leave an empty asset with a state of `starter`. It can be safely deleted.
     *
     * **Notes:**
     * *   GitHub Enterprise Server renames asset filenames that have special characters, non-alphanumeric characters, and leading or trailing periods. The "[List assets for a release](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#list-assets-for-a-release)"
     * endpoint lists the renamed filenames. For more information and help, contact [GitHub Enterprise Server Support](https://support.github.com/contact?tags=dotcom-rest-api).
     * *   If you upload an asset with the same filename as another uploaded asset, you'll receive an error and must delete the old file before you can re-upload the new asset.
     * operationId: repos/upload-release-asset
     * Request URI: /repos/{owner}/{repo}/releases/{release_id}/assets
     */
    async repos$upload$release$asset(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/releases/${params.parameter.release_id}/assets`;
        const headers = {
            "Content-Type": "*/*",
            Accept: "application/json",
        };
        const queryParameters = {
            name: { value: params.parameter.name, explode: false },
            label: { value: params.parameter.label, explode: false },
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Create reaction for a release
     * Create a reaction to a [release](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#releases). A response with a `Status: 200 OK` means that you already added the reaction type to this release.
     * operationId: reactions/create-for-release
     * Request URI: /repos/{owner}/{repo}/releases/{release_id}/reactions
     */
    async reactions$create$for$release(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/releases/${params.parameter.release_id}/reactions`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List repository cache replication status
     * Lists the status of each repository cache replica.
     * operationId: repos/list-cache-info
     * Request URI: /repos/{owner}/{repo}/replicas/caches
     */
    async repos$list$cache$info(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/replicas/caches`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List secret scanning alerts for a repository
     * Lists secret scanning alerts for a private repository, from newest to oldest. To use this endpoint, you must be an administrator for the repository or organization, and you must use an access token with the `repo` scope or `security_events` scope.
     *
     * GitHub Apps must have the `secret_scanning_alerts` read permission to use this endpoint.
     * operationId: secret-scanning/list-alerts-for-repo
     * Request URI: /repos/{owner}/{repo}/secret-scanning/alerts
     */
    async secret$scanning$list$alerts$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/secret-scanning/alerts`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            state: { value: params.parameter.state, explode: false },
            secret_type: { value: params.parameter.secret_type, explode: false },
            resolution: { value: params.parameter.resolution, explode: false },
            page: { value: params.parameter.page, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a secret scanning alert
     * Gets a single secret scanning alert detected in a private repository. To use this endpoint, you must be an administrator for the repository or organization, and you must use an access token with the `repo` scope or `security_events` scope.
     *
     * GitHub Apps must have the `secret_scanning_alerts` read permission to use this endpoint.
     * operationId: secret-scanning/get-alert
     * Request URI: /repos/{owner}/{repo}/secret-scanning/alerts/{alert_number}
     */
    async secret$scanning$get$alert(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/secret-scanning/alerts/${params.parameter.alert_number}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update a secret scanning alert
     * Updates the status of a secret scanning alert in a private repository. To use this endpoint, you must be an administrator for the repository or organization, and you must use an access token with the `repo` scope or `security_events` scope.
     *
     * GitHub Apps must have the `secret_scanning_alerts` write permission to use this endpoint.
     * operationId: secret-scanning/update-alert
     * Request URI: /repos/{owner}/{repo}/secret-scanning/alerts/{alert_number}
     */
    async secret$scanning$update$alert(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/secret-scanning/alerts/${params.parameter.alert_number}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List locations for a secret scanning alert
     * Lists all locations for a given secret scanning alert for a private repository. To use this endpoint, you must be an administrator for the repository or organization, and you must use an access token with the `repo` scope or `security_events` scope.
     *
     * GitHub Apps must have the `secret_scanning_alerts` read permission to use this endpoint.
     * operationId: secret-scanning/list-locations-for-alert
     * Request URI: /repos/{owner}/{repo}/secret-scanning/alerts/{alert_number}/locations
     */
    async secret$scanning$list$locations$for$alert(params, option) {
        const url = this.baseUrl +
            `/repos/${params.parameter.owner}/${params.parameter.repo}/secret-scanning/alerts/${params.parameter.alert_number}/locations`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            page: { value: params.parameter.page, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List stargazers
     * Lists the people that have starred the repository.
     *
     * You can also find out _when_ stars were created by passing the following custom [media type](https://docs.github.com/enterprise-server@3.4/rest/overview/media-types/) via the `Accept` header:
     * operationId: activity/list-stargazers-for-repo
     * Request URI: /repos/{owner}/{repo}/stargazers
     */
    async activity$list$stargazers$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/stargazers`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get the weekly commit activity
     * Returns a weekly aggregate of the number of additions and deletions pushed to a repository.
     * operationId: repos/get-code-frequency-stats
     * Request URI: /repos/{owner}/{repo}/stats/code_frequency
     */
    async repos$get$code$frequency$stats(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/stats/code_frequency`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get the last year of commit activity
     * Returns the last year of commit activity grouped by week. The `days` array is a group of commits per day, starting on `Sunday`.
     * operationId: repos/get-commit-activity-stats
     * Request URI: /repos/{owner}/{repo}/stats/commit_activity
     */
    async repos$get$commit$activity$stats(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/stats/commit_activity`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get all contributor commit activity
     *
     * Returns the `total` number of commits authored by the contributor. In addition, the response includes a Weekly Hash (`weeks` array) with the following information:
     *
     * *   `w` - Start of the week, given as a [Unix timestamp](http://en.wikipedia.org/wiki/Unix_time).
     * *   `a` - Number of additions
     * *   `d` - Number of deletions
     * *   `c` - Number of commits
     * operationId: repos/get-contributors-stats
     * Request URI: /repos/{owner}/{repo}/stats/contributors
     */
    async repos$get$contributors$stats(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/stats/contributors`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get the weekly commit count
     * Returns the total commit counts for the `owner` and total commit counts in `all`. `all` is everyone combined, including the `owner` in the last 52 weeks. If you'd like to get the commit counts for non-owners, you can subtract `owner` from `all`.
     *
     * The array order is oldest week (index 0) to most recent week.
     * operationId: repos/get-participation-stats
     * Request URI: /repos/{owner}/{repo}/stats/participation
     */
    async repos$get$participation$stats(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/stats/participation`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get the hourly commit count for each day
     * Each array contains the day number, hour number, and number of commits:
     *
     * *   `0-6`: Sunday - Saturday
     * *   `0-23`: Hour of day
     * *   Number of commits
     *
     * For example, `[2, 14, 25]` indicates that there were 25 total commits, during the 2:00pm hour on Tuesdays. All times are based on the time zone of individual commits.
     * operationId: repos/get-punch-card-stats
     * Request URI: /repos/{owner}/{repo}/stats/punch_card
     */
    async repos$get$punch$card$stats(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/stats/punch_card`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create a commit status
     * Users with push access in a repository can create commit statuses for a given SHA.
     *
     * Note: there is a limit of 1000 statuses per `sha` and `context` within a repository. Attempts to create more than 1000 statuses will result in a validation error.
     * operationId: repos/create-commit-status
     * Request URI: /repos/{owner}/{repo}/statuses/{sha}
     */
    async repos$create$commit$status(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/statuses/${params.parameter.sha}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List watchers
     * Lists the people watching the specified repository.
     * operationId: activity/list-watchers-for-repo
     * Request URI: /repos/{owner}/{repo}/subscribers
     */
    async activity$list$watchers$for$repo(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/subscribers`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a repository subscription
     * operationId: activity/get-repo-subscription
     * Request URI: /repos/{owner}/{repo}/subscription
     */
    async activity$get$repo$subscription(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/subscription`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set a repository subscription
     * If you would like to watch a repository, set `subscribed` to `true`. If you would like to ignore notifications made within a repository, set `ignored` to `true`. If you would like to stop watching a repository, [delete the repository's subscription](https://docs.github.com/enterprise-server@3.4/rest/reference/activity#delete-a-repository-subscription) completely.
     * operationId: activity/set-repo-subscription
     * Request URI: /repos/{owner}/{repo}/subscription
     */
    async activity$set$repo$subscription(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/subscription`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete a repository subscription
     * This endpoint should only be used to stop watching a repository. To control whether or not you wish to receive notifications from a repository, [set the repository's subscription manually](https://docs.github.com/enterprise-server@3.4/rest/reference/activity#set-a-repository-subscription).
     * operationId: activity/delete-repo-subscription
     * Request URI: /repos/{owner}/{repo}/subscription
     */
    async activity$delete$repo$subscription(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/subscription`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List repository tags
     * operationId: repos/list-tags
     * Request URI: /repos/{owner}/{repo}/tags
     */
    async repos$list$tags(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/tags`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Download a repository archive (tar)
     * Gets a redirect URL to download a tar archive for a repository. If you omit `:ref`, the repository’s default branch (usually
     * `master`) will be used. Please make sure your HTTP framework is configured to follow redirects or you will need to use
     * the `Location` header to make a second `GET` request.
     * **Note**: For private repositories, these links are temporary and expire after five minutes.
     * operationId: repos/download-tarball-archive
     * Request URI: /repos/{owner}/{repo}/tarball/{ref}
     */
    async repos$download$tarball$archive(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/tarball/${params.parameter.ref}`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List repository teams
     * operationId: repos/list-teams
     * Request URI: /repos/{owner}/{repo}/teams
     */
    async repos$list$teams(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/teams`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get all repository topics
     * operationId: repos/get-all-topics
     * Request URI: /repos/{owner}/{repo}/topics
     */
    async repos$get$all$topics(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/topics`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            page: { value: params.parameter.page, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Replace all repository topics
     * operationId: repos/replace-all-topics
     * Request URI: /repos/{owner}/{repo}/topics
     */
    async repos$replace$all$topics(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/topics`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Transfer a repository
     * A transfer request will need to be accepted by the new owner when transferring a personal repository to another user. The response will contain the original `owner`, and the transfer will continue asynchronously. For more details on the requirements to transfer personal and organization-owned repositories, see [about repository transfers](https://docs.github.com/articles/about-repository-transfers/).
     * operationId: repos/transfer
     * Request URI: /repos/{owner}/{repo}/transfer
     */
    async repos$transfer(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/transfer`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Download a repository archive (zip)
     * Gets a redirect URL to download a zip archive for a repository. If you omit `:ref`, the repository’s default branch (usually
     * `master`) will be used. Please make sure your HTTP framework is configured to follow redirects or you will need to use
     * the `Location` header to make a second `GET` request.
     * **Note**: For private repositories, these links are temporary and expire after five minutes.
     * operationId: repos/download-zipball-archive
     * Request URI: /repos/{owner}/{repo}/zipball/{ref}
     */
    async repos$download$zipball$archive(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.owner}/${params.parameter.repo}/zipball/${params.parameter.ref}`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create a repository using a template
     * Creates a new repository using a repository template. Use the `template_owner` and `template_repo` route parameters to specify the repository to use as the template. The authenticated user must own or be a member of an organization that owns the repository. To check if a repository is available to use as a template, get the repository's information using the [Get a repository](https://docs.github.com/enterprise-server@3.4/rest/reference/repos#get-a-repository) endpoint and check that the `is_template` key is `true`.
     *
     * **OAuth scope requirements**
     *
     * When using [OAuth](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/), authorizations must include:
     *
     * *   `public_repo` scope or `repo` scope to create a public repository. Note: For GitHub AE, use `repo` scope to create an internal repository.
     * *   `repo` scope to create a private repository
     * operationId: repos/create-using-template
     * Request URI: /repos/{template_owner}/{template_repo}/generate
     */
    async repos$create$using$template(params, option) {
        const url = this.baseUrl + `/repos/${params.parameter.template_owner}/${params.parameter.template_repo}/generate`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List public repositories
     * Lists all public repositories in the order that they were created.
     *
     * Note:
     * - For GitHub Enterprise Server, this endpoint will only list repositories available to all users on the enterprise.
     * - Pagination is powered exclusively by the `since` parameter. Use the [Link header](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#link-header) to get the URL for the next page of repositories.
     * operationId: repos/list-public
     * Request URI: /repositories
     */
    async repos$list$public(params, option) {
        const url = this.baseUrl + `/repositories`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            since: { value: params.parameter.since, explode: false },
            visibility: { value: params.parameter.visibility, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List environment secrets
     * Lists all secrets available in an environment without revealing their encrypted values. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     * operationId: actions/list-environment-secrets
     * Request URI: /repositories/{repository_id}/environments/{environment_name}/secrets
     */
    async actions$list$environment$secrets(params, option) {
        const url = this.baseUrl + `/repositories/${params.parameter.repository_id}/environments/${params.parameter.environment_name}/secrets`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get an environment public key
     * Get the public key for an environment, which you need to encrypt environment secrets. You need to encrypt a secret before you can create or update secrets. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     * operationId: actions/get-environment-public-key
     * Request URI: /repositories/{repository_id}/environments/{environment_name}/secrets/public-key
     */
    async actions$get$environment$public$key(params, option) {
        const url = this.baseUrl + `/repositories/${params.parameter.repository_id}/environments/${params.parameter.environment_name}/secrets/public-key`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get an environment secret
     * Gets a single environment secret without revealing its encrypted value. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     * operationId: actions/get-environment-secret
     * Request URI: /repositories/{repository_id}/environments/{environment_name}/secrets/{secret_name}
     */
    async actions$get$environment$secret(params, option) {
        const url = this.baseUrl +
            `/repositories/${params.parameter.repository_id}/environments/${params.parameter.environment_name}/secrets/${params.parameter.secret_name}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create or update an environment secret
     * Creates or updates an environment secret with an encrypted value. Encrypt your secret using
     * [LibSodium](https://libsodium.gitbook.io/doc/bindings_for_other_languages). You must authenticate using an access
     * token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use
     * this endpoint.
     *
     * #### Example encrypting a secret using Node.js
     *
     * Encrypt your secret using the [tweetsodium](https://github.com/github/tweetsodium) library.
     *
     * ```
     * const sodium = require('tweetsodium');
     *
     * const key = "base64-encoded-public-key";
     * const value = "plain-text-secret";
     *
     * // Convert the message and key to Uint8Array's (Buffer implements that interface)
     * const messageBytes = Buffer.from(value);
     * const keyBytes = Buffer.from(key, 'base64');
     *
     * // Encrypt using LibSodium.
     * const encryptedBytes = sodium.seal(messageBytes, keyBytes);
     *
     * // Base64 the encrypted secret
     * const encrypted = Buffer.from(encryptedBytes).toString('base64');
     *
     * console.log(encrypted);
     * ```
     *
     *
     * #### Example encrypting a secret using Python
     *
     * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
     *
     * ```
     * from base64 import b64encode
     * from nacl import encoding, public
     *
     * def encrypt(public_key: str, secret_value: str) -> str:
     *   """Encrypt a Unicode string using the public key."""
     *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
     *   sealed_box = public.SealedBox(public_key)
     *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
     *   return b64encode(encrypted).decode("utf-8")
     * ```
     *
     * #### Example encrypting a secret using C#
     *
     * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
     *
     * ```
     * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
     * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
     *
     * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
     *
     * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
     * ```
     *
     * #### Example encrypting a secret using Ruby
     *
     * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
     *
     * ```ruby
     * require "rbnacl"
     * require "base64"
     *
     * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
     * public_key = RbNaCl::PublicKey.new(key)
     *
     * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
     * encrypted_secret = box.encrypt("my_secret")
     *
     * # Print the base64 encoded secret
     * puts Base64.strict_encode64(encrypted_secret)
     * ```
     * operationId: actions/create-or-update-environment-secret
     * Request URI: /repositories/{repository_id}/environments/{environment_name}/secrets/{secret_name}
     */
    async actions$create$or$update$environment$secret(params, option) {
        const url = this.baseUrl +
            `/repositories/${params.parameter.repository_id}/environments/${params.parameter.environment_name}/secrets/${params.parameter.secret_name}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete an environment secret
     * Deletes a secret in an environment using the secret name. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     * operationId: actions/delete-environment-secret
     * Request URI: /repositories/{repository_id}/environments/{environment_name}/secrets/{secret_name}
     */
    async actions$delete$environment$secret(params, option) {
        const url = this.baseUrl +
            `/repositories/${params.parameter.repository_id}/environments/${params.parameter.environment_name}/secrets/${params.parameter.secret_name}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Search code
     * Searches for query terms inside of a file. This method returns up to 100 results [per page](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#pagination).
     *
     * When searching for code, you can get text match metadata for the file **content** and file **path** fields when you pass the `text-match` media type. For more details about how to receive highlighted search results, see [Text match metadata](https://docs.github.com/enterprise-server@3.4/rest/reference/search#text-match-metadata).
     *
     * For example, if you want to find the definition of the `addClass` function inside [jQuery](https://github.com/jquery/jquery) repository, your query would look something like this:
     *
     * `q=addClass+in:file+language:js+repo:jquery/jquery`
     *
     * This query searches for the keyword `addClass` within a file's contents. The query limits the search to files where the language is JavaScript in the `jquery/jquery` repository.
     *
     * #### Considerations for code search
     *
     * Due to the complexity of searching code, there are a few restrictions on how searches are performed:
     *
     * *   Only the _default branch_ is considered. In most cases, this will be the `master` branch.
     * *   Only files smaller than 384 KB are searchable.
     * *   You must always include at least one search term when searching source code. For example, searching for [`language:go`](https://github.com/search?utf8=%E2%9C%93&q=language%3Ago&type=Code) is not valid, while [`amazing
     * language:go`](https://github.com/search?utf8=%E2%9C%93&q=amazing+language%3Ago&type=Code) is.
     * operationId: search/code
     * Request URI: /search/code
     */
    async search$code(params, option) {
        const url = this.baseUrl + `/search/code`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            q: { value: params.parameter.q, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            order: { value: params.parameter.order, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Search commits
     * Find commits via various criteria on the default branch (usually `master`). This method returns up to 100 results [per page](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#pagination).
     *
     * When searching for commits, you can get text match metadata for the **message** field when you provide the `text-match` media type. For more details about how to receive highlighted search results, see [Text match
     * metadata](https://docs.github.com/enterprise-server@3.4/rest/reference/search#text-match-metadata).
     *
     * For example, if you want to find commits related to CSS in the [octocat/Spoon-Knife](https://github.com/octocat/Spoon-Knife) repository. Your query would look something like this:
     *
     * `q=repo:octocat/Spoon-Knife+css`
     * operationId: search/commits
     * Request URI: /search/commits
     */
    async search$commits(params, option) {
        const url = this.baseUrl + `/search/commits`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            q: { value: params.parameter.q, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            order: { value: params.parameter.order, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Search issues and pull requests
     * Find issues by state and keyword. This method returns up to 100 results [per page](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#pagination).
     *
     * When searching for issues, you can get text match metadata for the issue **title**, issue **body**, and issue **comment body** fields when you pass the `text-match` media type. For more details about how to receive highlighted
     * search results, see [Text match metadata](https://docs.github.com/enterprise-server@3.4/rest/reference/search#text-match-metadata).
     *
     * For example, if you want to find the oldest unresolved Python bugs on Windows. Your query might look something like this.
     *
     * `q=windows+label:bug+language:python+state:open&sort=created&order=asc`
     *
     * This query searches for the keyword `windows`, within any open issue that is labeled as `bug`. The search runs across repositories whose primary language is Python. The results are sorted by creation date in ascending order, which means the oldest issues appear first in the search results.
     *
     * **Note:** For [user-to-server](https://docs.github.com/developers/apps/identifying-and-authorizing-users-for-github-apps#user-to-server-requests) GitHub App requests, you can't retrieve a combination of issues and pull requests in a single query. Requests that don't include the `is:issue` or `is:pull-request` qualifier will receive an HTTP `422 Unprocessable Entity` response. To get results for both issues and pull requests, you must send separate queries for issues and pull requests. For more information about the `is` qualifier, see "[Searching only issues or pull requests](https://docs.github.com/github/searching-for-information-on-github/searching-issues-and-pull-requests#search-only-issues-or-pull-requests)."
     * operationId: search/issues-and-pull-requests
     * Request URI: /search/issues
     */
    async search$issues$and$pull$requests(params, option) {
        const url = this.baseUrl + `/search/issues`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            q: { value: params.parameter.q, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            order: { value: params.parameter.order, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Search labels
     * Find labels in a repository with names or descriptions that match search keywords. Returns up to 100 results [per page](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#pagination).
     *
     * When searching for labels, you can get text match metadata for the label **name** and **description** fields when you pass the `text-match` media type. For more details about how to receive highlighted search results, see [Text match metadata](https://docs.github.com/enterprise-server@3.4/rest/reference/search#text-match-metadata).
     *
     * For example, if you want to find labels in the `linguist` repository that match `bug`, `defect`, or `enhancement`. Your query might look like this:
     *
     * `q=bug+defect+enhancement&repository_id=64778136`
     *
     * The labels that best match the query appear first in the search results.
     * operationId: search/labels
     * Request URI: /search/labels
     */
    async search$labels(params, option) {
        const url = this.baseUrl + `/search/labels`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            repository_id: { value: params.parameter.repository_id, explode: false },
            q: { value: params.parameter.q, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            order: { value: params.parameter.order, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Search repositories
     * Find repositories via various criteria. This method returns up to 100 results [per page](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#pagination).
     *
     * When searching for repositories, you can get text match metadata for the **name** and **description** fields when you pass the `text-match` media type. For more details about how to receive highlighted search results, see [Text match metadata](https://docs.github.com/enterprise-server@3.4/rest/reference/search#text-match-metadata).
     *
     * For example, if you want to search for popular Tetris repositories written in assembly code, your query might look like this:
     *
     * `q=tetris+language:assembly&sort=stars&order=desc`
     *
     * This query searches for repositories with the word `tetris` in the name, the description, or the README. The results are limited to repositories where the primary language is assembly. The results are sorted by stars in descending order, so that the most popular repositories appear first in the search results.
     * operationId: search/repos
     * Request URI: /search/repositories
     */
    async search$repos(params, option) {
        const url = this.baseUrl + `/search/repositories`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            q: { value: params.parameter.q, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            order: { value: params.parameter.order, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Search topics
     * Find topics via various criteria. Results are sorted by best match. This method returns up to 100 results [per page](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#pagination). See "[Searching topics](https://docs.github.com/articles/searching-topics/)" for a detailed list of qualifiers.
     *
     * When searching for topics, you can get text match metadata for the topic's **short\_description**, **description**, **name**, or **display\_name** field when you pass the `text-match` media type. For more details about how to receive highlighted search results, see [Text match metadata](https://docs.github.com/enterprise-server@3.4/rest/reference/search#text-match-metadata).
     *
     * For example, if you want to search for topics related to Ruby that are featured on https://github.com/topics. Your query might look like this:
     *
     * `q=ruby+is:featured`
     *
     * This query searches for topics with the keyword `ruby` and limits the results to find only topics that are featured. The topics that are the best match for the query appear first in the search results.
     * operationId: search/topics
     * Request URI: /search/topics
     */
    async search$topics(params, option) {
        const url = this.baseUrl + `/search/topics`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            q: { value: params.parameter.q, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Search users
     * Find users via various criteria. This method returns up to 100 results [per page](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#pagination).
     *
     * When searching for users, you can get text match metadata for the issue **login**, **email**, and **name** fields when you pass the `text-match` media type. For more details about highlighting search results, see [Text match metadata](https://docs.github.com/enterprise-server@3.4/rest/reference/search#text-match-metadata). For more details about how to receive highlighted search results, see [Text match metadata](https://docs.github.com/enterprise-server@3.4/rest/reference/search#text-match-metadata).
     *
     * For example, if you're looking for a list of popular users, you might try this query:
     *
     * `q=tom+repos:%3E42+followers:%3E1000`
     *
     * This query searches for users with the name `tom`. The results are restricted to users with more than 42 repositories and over 1,000 followers.
     * operationId: search/users
     * Request URI: /search/users
     */
    async search$users(params, option) {
        const url = this.baseUrl + `/search/users`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            q: { value: params.parameter.q, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            order: { value: params.parameter.order, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get the configuration status
     * This endpoint allows you to check the status of the most recent configuration process:
     *
     * Note that you may need to wait several seconds after you start a process before you can check its status.
     *
     * The different statuses are:
     *
     * | Status        | Description                       |
     * | ------------- | --------------------------------- |
     * | `PENDING`     | The job has not started yet       |
     * | `CONFIGURING` | The job is running                |
     * | `DONE`        | The job has finished correctly    |
     * | `FAILED`      | The job has finished unexpectedly |
     * operationId: enterprise-admin/get-configuration-status
     * Request URI: /setup/api/configcheck
     */
    async enterprise$admin$get$configuration$status(option) {
        const url = this.baseUrl + `/setup/api/configcheck`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Start a configuration process
     * This endpoint allows you to start a configuration process at any time for your updated settings to take effect:
     * operationId: enterprise-admin/start-configuration-process
     * Request URI: /setup/api/configure
     */
    async enterprise$admin$start$configuration$process(option) {
        const url = this.baseUrl + `/setup/api/configure`;
        const headers = {};
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Get the maintenance status
     * Check your installation's maintenance status:
     * operationId: enterprise-admin/get-maintenance-status
     * Request URI: /setup/api/maintenance
     */
    async enterprise$admin$get$maintenance$status(option) {
        const url = this.baseUrl + `/setup/api/maintenance`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Enable or disable maintenance mode
     * **Note:** The request body for this operation must be submitted as `application/x-www-form-urlencoded` data. You can submit a parameter value as a string, or you can use a tool such as `curl` to submit a parameter value as the contents of a text file. For more information, see the [`curl` documentation](https://curl.se/docs/manpage.html#--data-urlencode).
     * operationId: enterprise-admin/enable-or-disable-maintenance-mode
     * Request URI: /setup/api/maintenance
     */
    async enterprise$admin$enable$or$disable$maintenance$mode(params, option) {
        const url = this.baseUrl + `/setup/api/maintenance`;
        const headers = {
            "Content-Type": "application/x-www-form-urlencoded",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get settings
     * operationId: enterprise-admin/get-settings
     * Request URI: /setup/api/settings
     */
    async enterprise$admin$get$settings(option) {
        const url = this.baseUrl + `/setup/api/settings`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Set settings
     * For a list of the available settings, see the [Get settings endpoint](https://docs.github.com/enterprise-server@3.4/rest/reference/enterprise-admin#get-settings).
     *
     * **Note:** The request body for this operation must be submitted as `application/x-www-form-urlencoded` data. You can submit a parameter value as a string, or you can use a tool such as `curl` to submit a parameter value as the contents of a text file. For more information, see the [`curl` documentation](https://curl.se/docs/manpage.html#--data-urlencode).
     * operationId: enterprise-admin/set-settings
     * Request URI: /setup/api/settings
     */
    async enterprise$admin$set$settings(params, option) {
        const url = this.baseUrl + `/setup/api/settings`;
        const headers = {
            "Content-Type": "application/x-www-form-urlencoded",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get all authorized SSH keys
     * operationId: enterprise-admin/get-all-authorized-ssh-keys
     * Request URI: /setup/api/settings/authorized-keys
     */
    async enterprise$admin$get$all$authorized$ssh$keys(option) {
        const url = this.baseUrl + `/setup/api/settings/authorized-keys`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Add an authorized SSH key
     * **Note:** The request body for this operation must be submitted as `application/x-www-form-urlencoded` data. You can submit a parameter value as a string, or you can use a tool such as `curl` to submit a parameter value as the contents of a text file. For more information, see the [`curl` documentation](https://curl.se/docs/manpage.html#--data-urlencode).
     * operationId: enterprise-admin/add-authorized-ssh-key
     * Request URI: /setup/api/settings/authorized-keys
     */
    async enterprise$admin$add$authorized$ssh$key(params, option) {
        const url = this.baseUrl + `/setup/api/settings/authorized-keys`;
        const headers = {
            "Content-Type": "application/x-www-form-urlencoded",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Remove an authorized SSH key
     * **Note:** The request body for this operation must be submitted as `application/x-www-form-urlencoded` data. You can submit a parameter value as a string, or you can use a tool such as `curl` to submit a parameter value as the contents of a text file. For more information, see the [`curl` documentation](https://curl.se/docs/manpage.html#--data-urlencode).
     * operationId: enterprise-admin/remove-authorized-ssh-key
     * Request URI: /setup/api/settings/authorized-keys
     */
    async enterprise$admin$remove$authorized$ssh$key(params, option) {
        const url = this.baseUrl + `/setup/api/settings/authorized-keys`;
        const headers = {
            "Content-Type": "application/x-www-form-urlencoded",
            Accept: "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Create a GitHub license
     * When you boot a GitHub instance for the first time, you can use the following endpoint to upload a license.
     *
     * Note that you need to `POST` to [`/setup/api/configure`](https://docs.github.com/enterprise-server@3.4/rest/reference/enterprise-admin#start-a-configuration-process) to start the actual configuration process.
     *
     * When using this endpoint, your GitHub instance must have a password set. This can be accomplished two ways:
     *
     * 1.  If you're working directly with the API before accessing the web interface, you must pass in the password parameter to set your password.
     * 2.  If you set up your instance via the web interface before accessing the API, your calls to this endpoint do not need the password parameter.
     *
     * **Note:** The request body for this operation must be submitted as `application/x-www-form-urlencoded` data. You can submit a parameter value as a string, or you can use a tool such as `curl` to submit a parameter value as the contents of a text file. For more information, see the [`curl` documentation](https://curl.se/docs/manpage.html#--data-urlencode).
     * operationId: enterprise-admin/create-enterprise-server-license
     * Request URI: /setup/api/start
     */
    async enterprise$admin$create$enterprise$server$license(params, option) {
        const url = this.baseUrl + `/setup/api/start`;
        const headers = {
            "Content-Type": "application/x-www-form-urlencoded",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Upgrade a license
     * This API upgrades your license and also triggers the configuration process.
     *
     * **Note:** The request body for this operation must be submitted as `application/x-www-form-urlencoded` data. You can submit a parameter value as a string, or you can use a tool such as `curl` to submit a parameter value as the contents of a text file. For more information, see the [`curl` documentation](https://curl.se/docs/manpage.html#--data-urlencode).
     * operationId: enterprise-admin/upgrade-license
     * Request URI: /setup/api/upgrade
     */
    async enterprise$admin$upgrade$license(params, option) {
        const url = this.baseUrl + `/setup/api/upgrade`;
        const headers = {
            "Content-Type": "application/x-www-form-urlencoded",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * @deprecated
     * Get a team (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the [Get a team by name](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#get-a-team-by-name) endpoint.
     * operationId: teams/get-legacy
     * Request URI: /teams/{team_id}
     */
    async teams$get$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Delete a team (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Delete a team](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#delete-a-team) endpoint.
     *
     * To delete a team, the authenticated user must be an organization owner or team maintainer.
     *
     * If you are an organization owner, deleting a parent team will delete all of its child teams as well.
     * operationId: teams/delete-legacy
     * Request URI: /teams/{team_id}
     */
    async teams$delete$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Update a team (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Update a team](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#update-a-team) endpoint.
     *
     * To edit a team, the authenticated user must either be an organization owner or a team maintainer.
     *
     * **Note:** With nested teams, the `privacy` for parent teams cannot be `secret`.
     * operationId: teams/update-legacy
     * Request URI: /teams/{team_id}
     */
    async teams$update$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * @deprecated
     * List discussions (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List discussions`](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#list-discussions) endpoint.
     *
     * List all discussions on a team's page. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: teams/list-discussions-legacy
     * Request URI: /teams/{team_id}/discussions
     */
    async teams$list$discussions$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/discussions`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            direction: { value: params.parameter.direction, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * @deprecated
     * Create a discussion (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`Create a discussion`](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#create-a-discussion) endpoint.
     *
     * Creates a new discussion post on a team's page. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * This endpoint triggers [notifications](https://docs.github.com/en/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     * operationId: teams/create-discussion-legacy
     * Request URI: /teams/{team_id}/discussions
     */
    async teams$create$discussion$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/discussions`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * @deprecated
     * Get a discussion (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Get a discussion](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#get-a-discussion) endpoint.
     *
     * Get a specific discussion on a team's page. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: teams/get-discussion-legacy
     * Request URI: /teams/{team_id}/discussions/{discussion_number}
     */
    async teams$get$discussion$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/discussions/${params.parameter.discussion_number}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Delete a discussion (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`Delete a discussion`](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#delete-a-discussion) endpoint.
     *
     * Delete a discussion from a team's page. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: teams/delete-discussion-legacy
     * Request URI: /teams/{team_id}/discussions/{discussion_number}
     */
    async teams$delete$discussion$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/discussions/${params.parameter.discussion_number}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Update a discussion (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Update a discussion](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#update-a-discussion) endpoint.
     *
     * Edits the title and body text of a discussion post. Only the parameters you provide are updated. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: teams/update-discussion-legacy
     * Request URI: /teams/{team_id}/discussions/{discussion_number}
     */
    async teams$update$discussion$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/discussions/${params.parameter.discussion_number}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * @deprecated
     * List discussion comments (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [List discussion comments](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#list-discussion-comments) endpoint.
     *
     * List all comments on a team discussion. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: teams/list-discussion-comments-legacy
     * Request URI: /teams/{team_id}/discussions/{discussion_number}/comments
     */
    async teams$list$discussion$comments$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/discussions/${params.parameter.discussion_number}/comments`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            direction: { value: params.parameter.direction, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * @deprecated
     * Create a discussion comment (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Create a discussion comment](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#create-a-discussion-comment) endpoint.
     *
     * Creates a new comment on a team discussion. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * This endpoint triggers [notifications](https://docs.github.com/en/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/enterprise-server@3.4/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     * operationId: teams/create-discussion-comment-legacy
     * Request URI: /teams/{team_id}/discussions/{discussion_number}/comments
     */
    async teams$create$discussion$comment$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/discussions/${params.parameter.discussion_number}/comments`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * @deprecated
     * Get a discussion comment (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Get a discussion comment](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#get-a-discussion-comment) endpoint.
     *
     * Get a specific comment on a team discussion. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: teams/get-discussion-comment-legacy
     * Request URI: /teams/{team_id}/discussions/{discussion_number}/comments/{comment_number}
     */
    async teams$get$discussion$comment$legacy(params, option) {
        const url = this.baseUrl +
            `/teams/${params.parameter.team_id}/discussions/${params.parameter.discussion_number}/comments/${params.parameter.comment_number}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Delete a discussion comment (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Delete a discussion comment](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#delete-a-discussion-comment) endpoint.
     *
     * Deletes a comment on a team discussion. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: teams/delete-discussion-comment-legacy
     * Request URI: /teams/{team_id}/discussions/{discussion_number}/comments/{comment_number}
     */
    async teams$delete$discussion$comment$legacy(params, option) {
        const url = this.baseUrl +
            `/teams/${params.parameter.team_id}/discussions/${params.parameter.discussion_number}/comments/${params.parameter.comment_number}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Update a discussion comment (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Update a discussion comment](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#update-a-discussion-comment) endpoint.
     *
     * Edits the body text of a discussion comment. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: teams/update-discussion-comment-legacy
     * Request URI: /teams/{team_id}/discussions/{discussion_number}/comments/{comment_number}
     */
    async teams$update$discussion$comment$legacy(params, option) {
        const url = this.baseUrl +
            `/teams/${params.parameter.team_id}/discussions/${params.parameter.discussion_number}/comments/${params.parameter.comment_number}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * @deprecated
     * List reactions for a team discussion comment (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List reactions for a team discussion comment`](https://docs.github.com/enterprise-server@3.4/rest/reference/reactions#list-reactions-for-a-team-discussion-comment) endpoint.
     *
     * List the reactions to a [team discussion comment](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#discussion-comments). OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: reactions/list-for-team-discussion-comment-legacy
     * Request URI: /teams/{team_id}/discussions/{discussion_number}/comments/{comment_number}/reactions
     */
    async reactions$list$for$team$discussion$comment$legacy(params, option) {
        const url = this.baseUrl +
            `/teams/${params.parameter.team_id}/discussions/${params.parameter.discussion_number}/comments/${params.parameter.comment_number}/reactions`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            content: { value: params.parameter.content, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * @deprecated
     * Create reaction for a team discussion comment (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new "[Create reaction for a team discussion comment](https://docs.github.com/enterprise-server@3.4/rest/reference/reactions#create-reaction-for-a-team-discussion-comment)" endpoint.
     *
     * Create a reaction to a [team discussion comment](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#discussion-comments). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/). A response with an HTTP `200` status means that you already added the reaction type to this team discussion comment.
     * operationId: reactions/create-for-team-discussion-comment-legacy
     * Request URI: /teams/{team_id}/discussions/{discussion_number}/comments/{comment_number}/reactions
     */
    async reactions$create$for$team$discussion$comment$legacy(params, option) {
        const url = this.baseUrl +
            `/teams/${params.parameter.team_id}/discussions/${params.parameter.discussion_number}/comments/${params.parameter.comment_number}/reactions`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * @deprecated
     * List reactions for a team discussion (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List reactions for a team discussion`](https://docs.github.com/enterprise-server@3.4/rest/reference/reactions#list-reactions-for-a-team-discussion) endpoint.
     *
     * List the reactions to a [team discussion](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#discussions). OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: reactions/list-for-team-discussion-legacy
     * Request URI: /teams/{team_id}/discussions/{discussion_number}/reactions
     */
    async reactions$list$for$team$discussion$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/discussions/${params.parameter.discussion_number}/reactions`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            content: { value: params.parameter.content, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * @deprecated
     * Create reaction for a team discussion (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`Create reaction for a team discussion`](https://docs.github.com/enterprise-server@3.4/rest/reference/reactions#create-reaction-for-a-team-discussion) endpoint.
     *
     * Create a reaction to a [team discussion](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#discussions). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/). A response with an HTTP `200` status means that you already added the reaction type to this team discussion.
     * operationId: reactions/create-for-team-discussion-legacy
     * Request URI: /teams/{team_id}/discussions/{discussion_number}/reactions
     */
    async reactions$create$for$team$discussion$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/discussions/${params.parameter.discussion_number}/reactions`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * @deprecated
     * List team members (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List team members`](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#list-team-members) endpoint.
     *
     * Team members will include the members of child teams.
     * operationId: teams/list-members-legacy
     * Request URI: /teams/{team_id}/members
     */
    async teams$list$members$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/members`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            role: { value: params.parameter.role, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * @deprecated
     * Get team member (Legacy)
     * The "Get team member" endpoint (described below) is deprecated.
     *
     * We recommend using the [Get team membership for a user](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#get-team-membership-for-a-user) endpoint instead. It allows you to get both active and pending memberships.
     *
     * To list members in a team, the team must be visible to the authenticated user.
     * operationId: teams/get-member-legacy
     * Request URI: /teams/{team_id}/members/{username}
     */
    async teams$get$member$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/members/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Add team member (Legacy)
     * The "Add team member" endpoint (described below) is deprecated.
     *
     * We recommend using the [Add or update team membership for a user](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#add-or-update-team-membership-for-a-user) endpoint instead. It allows you to invite new organization members to your teams.
     *
     * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * To add someone to a team, the authenticated user must be an organization owner or a team maintainer in the team they're changing. The person being added to the team must be a member of the team's organization.
     *
     * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub Enterprise Server team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub Enterprise Server](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
     *
     * Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#http-verbs)."
     * operationId: teams/add-member-legacy
     * Request URI: /teams/{team_id}/members/{username}
     */
    async teams$add$member$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/members/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Remove team member (Legacy)
     * The "Remove team member" endpoint (described below) is deprecated.
     *
     * We recommend using the [Remove team membership for a user](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#remove-team-membership-for-a-user) endpoint instead. It allows you to remove both active and pending memberships.
     *
     * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * To remove a team member, the authenticated user must have 'admin' permissions to the team or be an owner of the org that the team is associated with. Removing a team member does not delete the user, it just removes them from the team.
     *
     * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub Enterprise Server team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub Enterprise Server](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
     * operationId: teams/remove-member-legacy
     * Request URI: /teams/{team_id}/members/{username}
     */
    async teams$remove$member$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/members/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Get team membership for a user (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Get team membership for a user](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#get-team-membership-for-a-user) endpoint.
     *
     * Team members will include the members of child teams.
     *
     * To get a user's membership with a team, the team must be visible to the authenticated user.
     *
     * **Note:**
     * The response contains the `state` of the membership and the member's `role`.
     *
     * The `role` for organization owners is set to `maintainer`. For more information about `maintainer` roles, see [Create a team](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#create-a-team).
     * operationId: teams/get-membership-for-user-legacy
     * Request URI: /teams/{team_id}/memberships/{username}
     */
    async teams$get$membership$for$user$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/memberships/${params.parameter.username}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Add or update team membership for a user (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Add or update team membership for a user](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#add-or-update-team-membership-for-a-user) endpoint.
     *
     * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * If the user is already a member of the team's organization, this endpoint will add the user to the team. To add a membership between an organization member and a team, the authenticated user must be an organization owner or a team maintainer.
     *
     * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub Enterprise Server team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub Enterprise Server](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
     *
     * If the user is unaffiliated with the team's organization, this endpoint will send an invitation to the user via email. This newly-created membership will be in the "pending" state until the user accepts the invitation, at which point the membership will transition to the "active" state and the user will be added as a member of the team. To add a membership between an unaffiliated user and a team, the authenticated user must be an organization owner.
     *
     * If the user is already a member of the team, this endpoint will update the role of the team member's role. To update the membership of a team member, the authenticated user must be an organization owner or a team maintainer.
     * operationId: teams/add-or-update-membership-for-user-legacy
     * Request URI: /teams/{team_id}/memberships/{username}
     */
    async teams$add$or$update$membership$for$user$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/memberships/${params.parameter.username}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * @deprecated
     * Remove team membership for a user (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Remove team membership for a user](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#remove-team-membership-for-a-user) endpoint.
     *
     * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * To remove a membership between a user and a team, the authenticated user must have 'admin' permissions to the team or be an owner of the organization that the team is associated with. Removing team membership does not delete the user, it just removes their membership from the team.
     *
     * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub Enterprise Server team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub Enterprise Server](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
     * operationId: teams/remove-membership-for-user-legacy
     * Request URI: /teams/{team_id}/memberships/{username}
     */
    async teams$remove$membership$for$user$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/memberships/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * List team projects (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List team projects`](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#list-team-projects) endpoint.
     *
     * Lists the organization projects for a team.
     * operationId: teams/list-projects-legacy
     * Request URI: /teams/{team_id}/projects
     */
    async teams$list$projects$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/projects`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * @deprecated
     * Check team permissions for a project (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Check team permissions for a project](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#check-team-permissions-for-a-project) endpoint.
     *
     * Checks whether a team has `read`, `write`, or `admin` permissions for an organization project. The response includes projects inherited from a parent team.
     * operationId: teams/check-permissions-for-project-legacy
     * Request URI: /teams/{team_id}/projects/{project_id}
     */
    async teams$check$permissions$for$project$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/projects/${params.parameter.project_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Add or update team project permissions (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Add or update team project permissions](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#add-or-update-team-project-permissions) endpoint.
     *
     * Adds an organization project to a team. To add a project to a team or update the team's permission on a project, the authenticated user must have `admin` permissions for the project. The project and team must be part of the same organization.
     * operationId: teams/add-or-update-project-permissions-legacy
     * Request URI: /teams/{team_id}/projects/{project_id}
     */
    async teams$add$or$update$project$permissions$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/projects/${params.parameter.project_id}`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * @deprecated
     * Remove a project from a team (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Remove a project from a team](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#remove-a-project-from-a-team) endpoint.
     *
     * Removes an organization project from a team. An organization owner or a team maintainer can remove any project from the team. To remove a project from a team as an organization member, the authenticated user must have `read` access to both the team and project, or `admin` access to the team or project. **Note:** This endpoint removes the project from the team, but does not delete it.
     * operationId: teams/remove-project-legacy
     * Request URI: /teams/{team_id}/projects/{project_id}
     */
    async teams$remove$project$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/projects/${params.parameter.project_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * List team repositories (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [List team repositories](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#list-team-repositories) endpoint.
     * operationId: teams/list-repos-legacy
     * Request URI: /teams/{team_id}/repos
     */
    async teams$list$repos$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/repos`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * @deprecated
     * Check team permissions for a repository (Legacy)
     * **Note**: Repositories inherited through a parent team will also be checked.
     *
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Check team permissions for a repository](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#check-team-permissions-for-a-repository) endpoint.
     *
     * You can also get information about the specified repository, including what permissions the team grants on it, by passing the following custom [media type](https://docs.github.com/enterprise-server@3.4/rest/overview/media-types/) via the `Accept` header:
     * operationId: teams/check-permissions-for-repo-legacy
     * Request URI: /teams/{team_id}/repos/{owner}/{repo}
     */
    async teams$check$permissions$for$repo$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/repos/${params.parameter.owner}/${params.parameter.repo}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * Add or update team repository permissions (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new "[Add or update team repository permissions](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#add-or-update-team-repository-permissions)" endpoint.
     *
     * To add a repository to a team or update the team's permission on a repository, the authenticated user must have admin access to the repository, and must be able to see the team. The repository must be owned by the organization, or a direct fork of a repository owned by the organization. You will get a `422 Unprocessable Entity` status if you attempt to add a repository to a team that is not owned by the organization.
     *
     * Note that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#http-verbs)."
     * operationId: teams/add-or-update-repo-permissions-legacy
     * Request URI: /teams/{team_id}/repos/{owner}/{repo}
     */
    async teams$add$or$update$repo$permissions$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/repos/${params.parameter.owner}/${params.parameter.repo}`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * @deprecated
     * Remove a repository from a team (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Remove a repository from a team](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#remove-a-repository-from-a-team) endpoint.
     *
     * If the authenticated user is an organization owner or a team maintainer, they can remove any repositories from the team. To remove a repository from a team as an organization member, the authenticated user must have admin access to the repository and must be able to see the team. NOTE: This does not delete the repository, it just removes it from the team.
     * operationId: teams/remove-repo-legacy
     * Request URI: /teams/{team_id}/repos/{owner}/{repo}
     */
    async teams$remove$repo$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/repos/${params.parameter.owner}/${params.parameter.repo}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * @deprecated
     * List child teams (Legacy)
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List child teams`](https://docs.github.com/enterprise-server@3.4/rest/reference/teams#list-child-teams) endpoint.
     * operationId: teams/list-child-legacy
     * Request URI: /teams/{team_id}/teams
     */
    async teams$list$child$legacy(params, option) {
        const url = this.baseUrl + `/teams/${params.parameter.team_id}/teams`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get the authenticated user
     * If the authenticated user is authenticated through basic authentication or OAuth with the `user` scope, then the response lists public and private profile information.
     *
     * If the authenticated user is authenticated through OAuth without the `user` scope, then the response lists only public profile information.
     * operationId: users/get-authenticated
     * Request URI: /user
     */
    async users$get$authenticated(option) {
        const url = this.baseUrl + `/user`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update the authenticated user
     * **Note:** If your email is set to private and you send an `email` parameter as part of this request to update your profile, your privacy settings are still enforced: the email address will not be displayed on your public profile or via the API.
     * operationId: users/update-authenticated
     * Request URI: /user
     */
    async users$update$authenticated(params, option) {
        const url = this.baseUrl + `/user`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List email addresses for the authenticated user
     * Lists all of your email addresses, and specifies which one is visible to the public. This endpoint is accessible with the `user:email` scope.
     * operationId: users/list-emails-for-authenticated-user
     * Request URI: /user/emails
     */
    async users$list$emails$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/emails`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Add an email address for the authenticated user
     * This endpoint is accessible with the `user` scope.
     * operationId: users/add-email-for-authenticated-user
     * Request URI: /user/emails
     */
    async users$add$email$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/emails`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete an email address for the authenticated user
     * This endpoint is accessible with the `user` scope.
     * operationId: users/delete-email-for-authenticated-user
     * Request URI: /user/emails
     */
    async users$delete$email$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/emails`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List followers of the authenticated user
     * Lists the people following the authenticated user.
     * operationId: users/list-followers-for-authenticated-user
     * Request URI: /user/followers
     */
    async users$list$followers$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/followers`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List the people the authenticated user follows
     * Lists the people who the authenticated user follows.
     * operationId: users/list-followed-by-authenticated-user
     * Request URI: /user/following
     */
    async users$list$followed$by$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/following`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Check if a person is followed by the authenticated user
     * operationId: users/check-person-is-followed-by-authenticated
     * Request URI: /user/following/{username}
     */
    async users$check$person$is$followed$by$authenticated(params, option) {
        const url = this.baseUrl + `/user/following/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Follow a user
     * Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#http-verbs)."
     *
     * Following a user requires the user to be logged in and authenticated with basic auth or OAuth with the `user:follow` scope.
     * operationId: users/follow
     * Request URI: /user/following/{username}
     */
    async users$follow(params, option) {
        const url = this.baseUrl + `/user/following/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Unfollow a user
     * Unfollowing a user requires the user to be logged in and authenticated with basic auth or OAuth with the `user:follow` scope.
     * operationId: users/unfollow
     * Request URI: /user/following/{username}
     */
    async users$unfollow(params, option) {
        const url = this.baseUrl + `/user/following/${params.parameter.username}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List GPG keys for the authenticated user
     * Lists the current user's GPG keys. Requires that you are authenticated via Basic Auth or via OAuth with at least `read:gpg_key` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: users/list-gpg-keys-for-authenticated-user
     * Request URI: /user/gpg_keys
     */
    async users$list$gpg$keys$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/gpg_keys`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a GPG key for the authenticated user
     * Adds a GPG key to the authenticated user's GitHub account. Requires that you are authenticated via Basic Auth, or OAuth with at least `write:gpg_key` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: users/create-gpg-key-for-authenticated-user
     * Request URI: /user/gpg_keys
     */
    async users$create$gpg$key$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/gpg_keys`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a GPG key for the authenticated user
     * View extended details for a single GPG key. Requires that you are authenticated via Basic Auth or via OAuth with at least `read:gpg_key` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: users/get-gpg-key-for-authenticated-user
     * Request URI: /user/gpg_keys/{gpg_key_id}
     */
    async users$get$gpg$key$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/gpg_keys/${params.parameter.gpg_key_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a GPG key for the authenticated user
     * Removes a GPG key from the authenticated user's GitHub account. Requires that you are authenticated via Basic Auth or via OAuth with at least `admin:gpg_key` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: users/delete-gpg-key-for-authenticated-user
     * Request URI: /user/gpg_keys/{gpg_key_id}
     */
    async users$delete$gpg$key$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/gpg_keys/${params.parameter.gpg_key_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List app installations accessible to the user access token
     * Lists installations of your GitHub App that the authenticated user has explicit permission (`:read`, `:write`, or `:admin`) to access.
     *
     * You must use a [user-to-server OAuth access token](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/#identifying-users-on-your-site), created for a user who has authorized your GitHub App, to access this endpoint.
     *
     * The authenticated user has explicit permission to access repositories they own, repositories where they are a collaborator, and repositories that they can access through an organization membership.
     *
     * You can find the permissions for the installation under the `permissions` key.
     * operationId: apps/list-installations-for-authenticated-user
     * Request URI: /user/installations
     */
    async apps$list$installations$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/installations`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List repositories accessible to the user access token
     * List repositories that the authenticated user has explicit permission (`:read`, `:write`, or `:admin`) to access for an installation.
     *
     * The authenticated user has explicit permission to access repositories they own, repositories where they are a collaborator, and repositories that they can access through an organization membership.
     *
     * You must use a [user-to-server OAuth access token](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/#identifying-users-on-your-site), created for a user who has authorized your GitHub App, to access this endpoint.
     *
     * The access the user has to each repository is included in the hash under the `permissions` key.
     * operationId: apps/list-installation-repos-for-authenticated-user
     * Request URI: /user/installations/{installation_id}/repositories
     */
    async apps$list$installation$repos$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/installations/${params.parameter.installation_id}/repositories`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Add a repository to an app installation
     * Add a single repository to an installation. The authenticated user must have admin access to the repository.
     *
     * You must use a personal access token (which you can create via the [command line](https://docs.github.com/enterprise-server@3.4/github/authenticating-to-github/creating-a-personal-access-token) or [Basic Authentication](https://docs.github.com/enterprise-server@3.4/rest/overview/other-authentication-methods#basic-authentication)) to access this endpoint.
     * operationId: apps/add-repo-to-installation-for-authenticated-user
     * Request URI: /user/installations/{installation_id}/repositories/{repository_id}
     */
    async apps$add$repo$to$installation$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/installations/${params.parameter.installation_id}/repositories/${params.parameter.repository_id}`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Remove a repository from an app installation
     * Remove a single repository from an installation. The authenticated user must have admin access to the repository.
     *
     * You must use a personal access token (which you can create via the [command line](https://docs.github.com/enterprise-server@3.4/github/authenticating-to-github/creating-a-personal-access-token) or [Basic Authentication](https://docs.github.com/enterprise-server@3.4/rest/overview/other-authentication-methods#basic-authentication)) to access this endpoint.
     * operationId: apps/remove-repo-from-installation-for-authenticated-user
     * Request URI: /user/installations/{installation_id}/repositories/{repository_id}
     */
    async apps$remove$repo$from$installation$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/installations/${params.parameter.installation_id}/repositories/${params.parameter.repository_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List user account issues assigned to the authenticated user
     * List issues across owned and member repositories assigned to the authenticated user.
     *
     * **Note**: GitHub's REST API v3 considers every pull request an issue, but not every issue is a pull request. For this
     * reason, "Issues" endpoints may return both issues and pull requests in the response. You can identify pull requests by
     * the `pull_request` key. Be aware that the `id` of a pull request returned from "Issues" endpoints will be an _issue id_. To find out the pull
     * request id, use the "[List pull requests](https://docs.github.com/enterprise-server@3.4/rest/reference/pulls#list-pull-requests)" endpoint.
     * operationId: issues/list-for-authenticated-user
     * Request URI: /user/issues
     */
    async issues$list$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/issues`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filter: { value: params.parameter.filter, explode: false },
            state: { value: params.parameter.state, explode: false },
            labels: { value: params.parameter.labels, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            since: { value: params.parameter.since, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List public SSH keys for the authenticated user
     * Lists the public SSH keys for the authenticated user's GitHub account. Requires that you are authenticated via Basic Auth or via OAuth with at least `read:public_key` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: users/list-public-ssh-keys-for-authenticated-user
     * Request URI: /user/keys
     */
    async users$list$public$ssh$keys$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/keys`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a public SSH key for the authenticated user
     * Adds a public SSH key to the authenticated user's GitHub account. Requires that you are authenticated via Basic Auth, or OAuth with at least `write:public_key` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: users/create-public-ssh-key-for-authenticated-user
     * Request URI: /user/keys
     */
    async users$create$public$ssh$key$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/keys`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get a public SSH key for the authenticated user
     * View extended details for a single public SSH key. Requires that you are authenticated via Basic Auth or via OAuth with at least `read:public_key` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: users/get-public-ssh-key-for-authenticated-user
     * Request URI: /user/keys/{key_id}
     */
    async users$get$public$ssh$key$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/keys/${params.parameter.key_id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a public SSH key for the authenticated user
     * Removes a public SSH key from the authenticated user's GitHub account. Requires that you are authenticated via Basic Auth or via OAuth with at least `admin:public_key` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     * operationId: users/delete-public-ssh-key-for-authenticated-user
     * Request URI: /user/keys/{key_id}
     */
    async users$delete$public$ssh$key$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/keys/${params.parameter.key_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List organization memberships for the authenticated user
     * operationId: orgs/list-memberships-for-authenticated-user
     * Request URI: /user/memberships/orgs
     */
    async orgs$list$memberships$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/memberships/orgs`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            state: { value: params.parameter.state, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get an organization membership for the authenticated user
     * operationId: orgs/get-membership-for-authenticated-user
     * Request URI: /user/memberships/orgs/{org}
     */
    async orgs$get$membership$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/memberships/orgs/${params.parameter.org}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Update an organization membership for the authenticated user
     * operationId: orgs/update-membership-for-authenticated-user
     * Request URI: /user/memberships/orgs/{org}
     */
    async orgs$update$membership$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/memberships/orgs/${params.parameter.org}`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("PATCH", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List user migrations
     * Lists all migrations a user has started.
     * operationId: migrations/list-for-authenticated-user
     * Request URI: /user/migrations
     */
    async migrations$list$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/migrations`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Start a user migration
     * Initiates the generation of a user migration archive.
     * operationId: migrations/start-for-authenticated-user
     * Request URI: /user/migrations
     */
    async migrations$start$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/migrations`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Download a user migration archive
     * Fetches the URL to download the migration archive as a `tar.gz` file. Depending on the resources your repository uses, the migration archive can contain JSON files with data for these objects:
     *
     * *   attachments
     * *   bases
     * *   commit\_comments
     * *   issue\_comments
     * *   issue\_events
     * *   issues
     * *   milestones
     * *   organizations
     * *   projects
     * *   protected\_branches
     * *   pull\_request\_reviews
     * *   pull\_requests
     * *   releases
     * *   repositories
     * *   review\_comments
     * *   schema
     * *   users
     *
     * The archive will also contain an `attachments` directory that includes all attachment files uploaded to GitHub.com and a `repositories` directory that contains the repository's Git data.
     * operationId: migrations/get-archive-for-authenticated-user
     * Request URI: /user/migrations/{migration_id}/archive
     */
    async migrations$get$archive$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/migrations/${params.parameter.migration_id}/archive`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List repositories for a user migration
     * Lists all the repositories for this user migration.
     * operationId: migrations/list-repos-for-authenticated-user
     * Request URI: /user/migrations/{migration_id}/repositories
     */
    async migrations$list$repos$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/migrations/${params.parameter.migration_id}/repositories`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List organizations for the authenticated user
     * List organizations for the authenticated user.
     *
     * **OAuth scope requirements**
     *
     * This only lists organizations that your authorization allows you to operate on in some way (e.g., you can list teams with `read:org` scope, you can publicize your organization membership with `user` scope, etc.). Therefore, this API requires at least `user` or `read:org` scope. OAuth requests with insufficient scope receive a `403 Forbidden` response.
     * operationId: orgs/list-for-authenticated-user
     * Request URI: /user/orgs
     */
    async orgs$list$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/orgs`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a user project
     * operationId: projects/create-for-authenticated-user
     * Request URI: /user/projects
     */
    async projects$create$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/projects`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List public email addresses for the authenticated user
     * Lists your publicly visible email address, which you can set with the [Set primary email visibility for the authenticated user](https://docs.github.com/enterprise-server@3.4/rest/reference/users#set-primary-email-visibility-for-the-authenticated-user) endpoint. This endpoint is accessible with the `user:email` scope.
     * operationId: users/list-public-emails-for-authenticated-user
     * Request URI: /user/public_emails
     */
    async users$list$public$emails$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/public_emails`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List repositories for the authenticated user
     * Lists repositories that the authenticated user has explicit permission (`:read`, `:write`, or `:admin`) to access.
     *
     * The authenticated user has explicit permission to access repositories they own, repositories where they are a collaborator, and repositories that they can access through an organization membership.
     * operationId: repos/list-for-authenticated-user
     * Request URI: /user/repos
     */
    async repos$list$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/repos`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            visibility: { value: params.parameter.visibility, explode: false },
            affiliation: { value: params.parameter.affiliation, explode: false },
            type: { value: params.parameter.type, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
            since: { value: params.parameter.since, explode: false },
            before: { value: params.parameter.before, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a repository for the authenticated user
     * Creates a new repository for the authenticated user.
     *
     * **OAuth scope requirements**
     *
     * When using [OAuth](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/), authorizations must include:
     *
     * *   `public_repo` scope or `repo` scope to create a public repository. Note: For GitHub AE, use `repo` scope to create an internal repository.
     * *   `repo` scope to create a private repository.
     * operationId: repos/create-for-authenticated-user
     * Request URI: /user/repos
     */
    async repos$create$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/repos`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List repository invitations for the authenticated user
     * When authenticating as a user, this endpoint will list all currently open repository invitations for that user.
     * operationId: repos/list-invitations-for-authenticated-user
     * Request URI: /user/repository_invitations
     */
    async repos$list$invitations$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/repository_invitations`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Decline a repository invitation
     * operationId: repos/decline-invitation-for-authenticated-user
     * Request URI: /user/repository_invitations/{invitation_id}
     */
    async repos$decline$invitation$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/repository_invitations/${params.parameter.invitation_id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Accept a repository invitation
     * operationId: repos/accept-invitation-for-authenticated-user
     * Request URI: /user/repository_invitations/{invitation_id}
     */
    async repos$accept$invitation$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/repository_invitations/${params.parameter.invitation_id}`;
        const headers = {};
        return this.apiClient.request("PATCH", url, headers, undefined, undefined, option);
    }
    /**
     * List repositories starred by the authenticated user
     * Lists repositories the authenticated user has starred.
     *
     * You can also find out _when_ stars were created by passing the following custom [media type](https://docs.github.com/enterprise-server@3.4/rest/overview/media-types/) via the `Accept` header:
     * operationId: activity/list-repos-starred-by-authenticated-user
     * Request URI: /user/starred
     */
    async activity$list$repos$starred$by$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/starred`;
        const headers = {
            Accept: params.headers.Accept,
        };
        const queryParameters = {
            sort: { value: params.parameter.sort, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Check if a repository is starred by the authenticated user
     * operationId: activity/check-repo-is-starred-by-authenticated-user
     * Request URI: /user/starred/{owner}/{repo}
     */
    async activity$check$repo$is$starred$by$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/starred/${params.parameter.owner}/${params.parameter.repo}`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Star a repository for the authenticated user
     * Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#http-verbs)."
     * operationId: activity/star-repo-for-authenticated-user
     * Request URI: /user/starred/{owner}/{repo}
     */
    async activity$star$repo$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/starred/${params.parameter.owner}/${params.parameter.repo}`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Unstar a repository for the authenticated user
     * operationId: activity/unstar-repo-for-authenticated-user
     * Request URI: /user/starred/{owner}/{repo}
     */
    async activity$unstar$repo$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/starred/${params.parameter.owner}/${params.parameter.repo}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List repositories watched by the authenticated user
     * Lists repositories the authenticated user is watching.
     * operationId: activity/list-watched-repos-for-authenticated-user
     * Request URI: /user/subscriptions
     */
    async activity$list$watched$repos$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/subscriptions`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List teams for the authenticated user
     * List all of the teams across all of the organizations to which the authenticated user belongs. This method requires `user`, `repo`, or `read:org` [scope](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/) when authenticating via [OAuth](https://docs.github.com/enterprise-server@3.4/apps/building-oauth-apps/).
     * operationId: teams/list-for-authenticated-user
     * Request URI: /user/teams
     */
    async teams$list$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/user/teams`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List users
     * Lists all users, in the order that they signed up on GitHub Enterprise Server. This list includes personal user accounts and organization accounts.
     *
     * Note: Pagination is powered exclusively by the `since` parameter. Use the [Link header](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#link-header) to get the URL for the next page of users.
     * operationId: users/list
     * Request URI: /users
     */
    async users$list(params, option) {
        const url = this.baseUrl + `/users`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            since: { value: params.parameter.since, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a user
     * Provides publicly available information about someone with a GitHub account.
     *
     * GitHub Apps with the `Plan` user permission can use this endpoint to retrieve information about a user's GitHub Enterprise Server plan. The GitHub App must be authenticated as a user. See "[Identifying and authorizing users for GitHub Apps](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/)" for details about authentication. For an example response, see 'Response with GitHub Enterprise Server plan information' below"
     *
     * The `email` key in the following response is the publicly visible email address from your GitHub Enterprise Server [profile page](https://github.com/settings/profile). When setting up your profile, you can select a primary email address to be “public” which provides an email entry for this endpoint. If you do not set a public email address for `email`, then it will have a value of `null`. You only see publicly visible email addresses when authenticated with GitHub Enterprise Server. For more information, see [Authentication](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#authentication).
     *
     * The Emails API enables you to list all of your email addresses, and toggle a primary email to be visible publicly. For more information, see "[Emails API](https://docs.github.com/enterprise-server@3.4/rest/reference/users#emails)".
     * operationId: users/get-by-username
     * Request URI: /users/{username}
     */
    async users$get$by$username(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List events for the authenticated user
     * If you are authenticated as the given user, you will see your private events. Otherwise, you'll only see public events.
     * operationId: activity/list-events-for-authenticated-user
     * Request URI: /users/{username}/events
     */
    async activity$list$events$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/events`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List organization events for the authenticated user
     * This is the user's organization dashboard. You must be authenticated as the user to view this.
     * operationId: activity/list-org-events-for-authenticated-user
     * Request URI: /users/{username}/events/orgs/{org}
     */
    async activity$list$org$events$for$authenticated$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/events/orgs/${params.parameter.org}`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List public events for a user
     * operationId: activity/list-public-events-for-user
     * Request URI: /users/{username}/events/public
     */
    async activity$list$public$events$for$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/events/public`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List followers of a user
     * Lists the people following the specified user.
     * operationId: users/list-followers-for-user
     * Request URI: /users/{username}/followers
     */
    async users$list$followers$for$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/followers`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List the people a user follows
     * Lists the people who the specified user follows.
     * operationId: users/list-following-for-user
     * Request URI: /users/{username}/following
     */
    async users$list$following$for$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/following`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Check if a user follows another user
     * operationId: users/check-following-for-user
     * Request URI: /users/{username}/following/{target_user}
     */
    async users$check$following$for$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/following/${params.parameter.target_user}`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List gists for a user
     * Lists public gists for the specified user:
     * operationId: gists/list-for-user
     * Request URI: /users/{username}/gists
     */
    async gists$list$for$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/gists`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            since: { value: params.parameter.since, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List GPG keys for a user
     * Lists the GPG keys for a user. This information is accessible by anyone.
     * operationId: users/list-gpg-keys-for-user
     * Request URI: /users/{username}/gpg_keys
     */
    async users$list$gpg$keys$for$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/gpg_keys`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get contextual information for a user
     * Provides hovercard information when authenticated through basic auth or OAuth with the `repo` scope. You can find out more about someone in relation to their pull requests, issues, repositories, and organizations.
     *
     * The `subject_type` and `subject_id` parameters provide context for the person's hovercard, which returns more information than without the parameters. For example, if you wanted to find out more about `octocat` who owns the `Spoon-Knife` repository via cURL, it would look like this:
     *
     * ```shell
     *  curl -u username:token
     *   https://api.github.com/users/octocat/hovercard?subject_type=repository&subject_id=1300192
     * ```
     * operationId: users/get-context-for-user
     * Request URI: /users/{username}/hovercard
     */
    async users$get$context$for$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/hovercard`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            subject_type: { value: params.parameter.subject_type, explode: false },
            subject_id: { value: params.parameter.subject_id, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get a user installation for the authenticated app
     * Enables an authenticated GitHub App to find the user’s installation information.
     *
     * You must use a [JWT](https://docs.github.com/enterprise-server@3.4/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     * operationId: apps/get-user-installation
     * Request URI: /users/{username}/installation
     */
    async apps$get$user$installation(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/installation`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List public keys for a user
     * Lists the _verified_ public SSH keys for a user. This is accessible by anyone.
     * operationId: users/list-public-keys-for-user
     * Request URI: /users/{username}/keys
     */
    async users$list$public$keys$for$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/keys`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List organizations for a user
     * List [public organization memberships](https://docs.github.com/articles/publicizing-or-concealing-organization-membership) for the specified user.
     *
     * This method only lists _public_ memberships, regardless of authentication. If you need to fetch all of the organization memberships (public and private) for the authenticated user, use the [List organizations for the authenticated user](https://docs.github.com/enterprise-server@3.4/rest/reference/orgs#list-organizations-for-the-authenticated-user) API instead.
     * operationId: orgs/list-for-user
     * Request URI: /users/{username}/orgs
     */
    async orgs$list$for$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/orgs`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List user projects
     * operationId: projects/list-for-user
     * Request URI: /users/{username}/projects
     */
    async projects$list$for$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/projects`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            state: { value: params.parameter.state, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List events received by the authenticated user
     * These are events that you've received by watching repos and following users. If you are authenticated as the given user, you will see private events. Otherwise, you'll only see public events.
     * operationId: activity/list-received-events-for-user
     * Request URI: /users/{username}/received_events
     */
    async activity$list$received$events$for$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/received_events`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List public events received by a user
     * operationId: activity/list-received-public-events-for-user
     * Request URI: /users/{username}/received_events/public
     */
    async activity$list$received$public$events$for$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/received_events/public`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List repositories for a user
     * Lists public repositories for the specified user. Note: For GitHub AE, this endpoint will list internal repositories for the specified user.
     * operationId: repos/list-for-user
     * Request URI: /users/{username}/repos
     */
    async repos$list$for$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/repos`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            type: { value: params.parameter.type, explode: false },
            sort: { value: params.parameter.sort, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Promote a user to be a site administrator
     * Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#http-verbs)."
     * operationId: enterprise-admin/promote-user-to-be-site-administrator
     * Request URI: /users/{username}/site_admin
     */
    async enterprise$admin$promote$user$to$be$site$administrator(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/site_admin`;
        const headers = {};
        return this.apiClient.request("PUT", url, headers, undefined, undefined, option);
    }
    /**
     * Demote a site administrator
     * You can demote any user account except your own.
     * operationId: enterprise-admin/demote-site-administrator
     * Request URI: /users/{username}/site_admin
     */
    async enterprise$admin$demote$site$administrator(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/site_admin`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * List repositories starred by a user
     * Lists repositories a user has starred.
     *
     * You can also find out _when_ stars were created by passing the following custom [media type](https://docs.github.com/enterprise-server@3.4/rest/overview/media-types/) via the `Accept` header:
     * operationId: activity/list-repos-starred-by-user
     * Request URI: /users/{username}/starred
     */
    async activity$list$repos$starred$by$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/starred`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            sort: { value: params.parameter.sort, explode: false },
            direction: { value: params.parameter.direction, explode: false },
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List repositories watched by a user
     * Lists repositories a user is watching.
     * operationId: activity/list-repos-watched-by-user
     * Request URI: /users/{username}/subscriptions
     */
    async activity$list$repos$watched$by$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/subscriptions`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            per_page: { value: params.parameter.per_page, explode: false },
            page: { value: params.parameter.page, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Suspend a user
     * If your GitHub instance uses [LDAP Sync with Active Directory LDAP servers](https://docs.github.com/enterprise/admin/guides/user-management/using-ldap), Active Directory LDAP-authenticated users cannot be suspended through this API. If you attempt to suspend an Active Directory LDAP-authenticated user through this API, it will return a `403` response.
     *
     * You can suspend any user account except your own.
     *
     * Note that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/enterprise-server@3.4/rest/overview/resources-in-the-rest-api#http-verbs)."
     * operationId: enterprise-admin/suspend-user
     * Request URI: /users/{username}/suspended
     */
    async enterprise$admin$suspend$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/suspended`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Unsuspend a user
     * If your GitHub instance uses [LDAP Sync with Active Directory LDAP servers](https://docs.github.com/enterprise/admin/guides/user-management/using-ldap), this API is disabled and will return a `403` response. Active Directory LDAP-authenticated users cannot be unsuspended using the API.
     * operationId: enterprise-admin/unsuspend-user
     * Request URI: /users/{username}/suspended
     */
    async enterprise$admin$unsuspend$user(params, option) {
        const url = this.baseUrl + `/users/${params.parameter.username}/suspended`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("DELETE", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get the Zen of GitHub
     * Get a random sentence from the Zen of GitHub
     * operationId: meta/get-zen
     * Request URI: /zen
     */
    async meta$get$zen(option) {
        const url = this.baseUrl + `/zen`;
        const headers = {
            Accept: "text/plain",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
}
